


from athenaCL.libATH import pitchTools





class MusicXmlNote:
   """"""

   def __init__(self):
      self.ps = 60
      self.dur = 4


   def getPitch(self):
      return self.ps # transform from atheancl representation

#     <pitch> 
#       <step>E</step> 
#       <alter>-1</alter> s
#       <octave>5</octave> 
#     </pitch> 
# Alter values of -2 and 2 can be used for double-flat and double-sharp. Decimal values can be used 
# for microtones (e.g., 0.5 for a quarter-tone sharp), but not all programs may convert this into 
# MIDI pitch-bend data. 

# The duration element is an integer that represents a note's duration in terms of divisions per 
# quarter note. Since our example has 12 divisions per quarter note, a quarter note has a duration of 
# 12. The eighth-note triplets have a duration of 4, while the eighth notes have a duration of 6. 



   def __call__(self):

      msg = []
      msg.append('<note>')

      msg.append('</note>')
      return ''.join(msg)
   



class MusicXmlMeasure:

   def __init__(self):
      self.attributes = {}
      self.notes = {}

   def setAttributes(self, divisions=1, key=(0,'major'), 
                     time=(4,4), clef=('G', 2)):
      self.attributes['divisions'] = divisions
      self.attributes['key'] = key
      self.attributes['time'] = time
      self.attributes['clef'] = clef
      

   def setNotes(self, notes):
      """add a list of note objects?"""
      self.notes = []
   
   def __call__(self, number):
      msg = []
      msg.append("""<measure number="%s">""" % number)

      msg.append("""<attributes>""")
      msg.append("""<divisions>%s</divisions>""" % self.attributes['divisions'])

      msg.append("""<key>
<fifths>%s</fifths>
<mode>%s</mode>
</key>""" % (self.attributes['key'][0], self.attributes['key'][1]))

      msg.append("""<time>
<beats>%s</beats>
<beat-type>%s</beat-type>
</time>""" % (self.attributes['time'][0], self.attributes['time'][1]))

      msg.append("""<clef>
<sign>%s</sign>
<line>%s</line>
</clef>""" % (self.attributes['clef'][0], self.attributes['clef'][1]))
      msg.append("""</attributes>""")

      # call each note object to get note markup
      for note in self.notes:
         msg.append(note()) # call note to get note date

      msg.append("""</measure>""")






class MusicXmlScore:

   def __init__(self):


      self.head = """<?xml version="1.0" encoding="UTF-8" standalone="no"?> 
<!DOCTYPE score-partwise PUBLIC 
    "-//Recordare//DTD MusicXML 1.1 Partwise//EN" 
    "http://www.musicxml.org/dtds/partwise.dtd"> 
"""

      self.encoding = """<encoding> 
<encoding-date>2002-02-16</encoding-date> 
<software>athenaCL</software> 
</encoding> 
"""

      self._partRef = {} # a list of dictionaries
      


   def partAdd(self, name, id=None):
      """add a part to the part list"""

      if id == None:
         id = len(self._partRef)

#       self.partRef{id : {'name':name}}



