#!/usr/local/bin/python
#-----------------------------------------------------------------||||||||||||--
# Name:         MCdata.py
# Purpose:      stores primary map-class table.
#
# Authors:      Christopher Ariza
#
# Copyright:    (c) 2001-2002 Christopher Ariza
# License:      GPL
#-----------------------------------------------------------------||||||||||||--

# number of map classes
# "Triangle of numbers k!*Stirling2(n,k)" [A019538]
# http://www.research.att.com/cgi-bin/access.cgi/as/njas/sequences/eisA.cgi?Anum=019538
#
#        setB
#setA    1   2   3   4    5    6   
#
#   1    1
#   2    1   2
#   3    1   6   6                                        
#   4    1   14  36  24                                      
#   5    1   30  150 240  120                                         
#   6    1   62  540 1560 1800 720  

#-----------------------------------------------------------------||||||||||||--

#
# used to be like this, but this is redundant
#mvt_2_2 ={ 1 : [(0, 0), (1, 1)],
#           2 : [(0, 1), (1, 0)]}
#
# this way uses the position in the tuple as the first coord
#mvt_2_2 ={ 1 : (0, 1),
#           2 : (1, 0)}
#

#----------------------------
map_1_1 ={ 1 : (0,)}
#----------------------------
map_2_2 ={ 1 : (0, 1),
           2 : (1, 0)}

map_2_1 ={ 1 : (0, 0)}
#----------------------------
map_3_3 ={ 1 : (0, 1, 2),
           2 : (0, 2, 1),
           3 : (1, 0, 2),
           4 : (1, 2, 0),
           5 : (2, 0, 1),
           6 : (2, 1, 0)}

map_3_2 ={ 1 : (0, 0, 1),
           2 : (0, 1, 0),
           3 : (0, 1, 1),
           4 : (1, 0, 0),
           5 : (1, 0, 1),
           6 : (1, 1, 0)}

map_3_1 ={ 1 : (0, 0, 0)}
#----------------------------
map_4_4 ={ 1 : (0, 1, 2, 3),
           2 : (0, 1, 3, 2),
           3 : (0, 2, 1, 3),
           4 : (0, 2, 3, 1),
           5 : (0, 3, 1, 2),
           6 : (0, 3, 2, 1),
           7 : (1, 0, 2, 3),
           8 : (1, 0, 3, 2),
           9 : (1, 2, 0, 3),
          10 : (1, 2, 3, 0),
          11 : (1, 3, 0, 2),
          12 : (1, 3, 2, 0),
          13 : (2, 0, 1, 3),
          14 : (2, 0, 3, 1),
          15 : (2, 1, 0, 3),
          16 : (2, 1, 3, 0),
          17 : (2, 3, 0, 1),
          18 : (2, 3, 1, 0),
          19 : (3, 0, 1, 2),
          20 : (3, 0, 2, 1),
          21 : (3, 1, 0, 2),
          22 : (3, 1, 2, 0),
          23 : (3, 2, 0, 1),
          24 : (3, 2, 1, 0)}

map_4_3 ={ 1 : (0, 0, 1, 2),
           2 : (0, 0, 2, 1),
           3 : (0, 1, 0, 2),
           4 : (0, 1, 1, 2),
           5 : (0, 1, 2, 0),
           6 : (0, 1, 2, 1),
           7 : (0, 1, 2, 2),
           8 : (0, 2, 0, 1),
           9 : (0, 2, 1, 0),
          10 : (0, 2, 1, 1),
          11 : (0, 2, 1, 2),
          12 : (0, 2, 2, 1),
          13 : (1, 0, 0, 2),
          14 : (1, 0, 1, 2),
          15 : (1, 0, 2, 0),
          16 : (1, 0, 2, 1),
          17 : (1, 0, 2, 2),
          18 : (1, 1, 0, 2),
          19 : (1, 1, 2, 0),
          20 : (1, 2, 0, 0),
          21 : (1, 2, 0, 1),
          22 : (1, 2, 0, 2),
          23 : (1, 2, 1, 0),
          24 : (1, 2, 2, 0),
          25 : (2, 0, 0, 1),
          26 : (2, 0, 1, 0),
          27 : (2, 0, 1, 1),
          28 : (2, 0, 1, 2),
          29 : (2, 0, 2, 1),
          30 : (2, 1, 0, 0),
          31 : (2, 1, 0, 1),
          32 : (2, 1, 0, 2),
          33 : (2, 1, 1, 0),
          34 : (2, 1, 2, 0),
          35 : (2, 2, 0, 1),
          36 : (2, 2, 1, 0)}

map_4_2 ={ 1 : (0, 0, 0, 1),
           2 : (0, 0, 1, 0),
           3 : (0, 0, 1, 1),
           4 : (0, 1, 0, 0),
           5 : (0, 1, 0, 1),
           6 : (0, 1, 1, 0),
           7 : (0, 1, 1, 1),
           8 : (1, 0, 0, 0),
           9 : (1, 0, 0, 1),
          10 : (1, 0, 1, 0),
          11 : (1, 0, 1, 1),
          12 : (1, 1, 0, 0),
          13 : (1, 1, 0, 1),
          14 : (1, 1, 1, 0)}

map_4_1 ={ 1 : (0, 0, 0, 0)}
#----------------------------
map_5_5 ={ 1 : (0, 1, 2, 3, 4),
           2 : (0, 1, 2, 4, 3),
           3 : (0, 1, 3, 2, 4),
           4 : (0, 1, 3, 4, 2),
           5 : (0, 1, 4, 2, 3),
           6 : (0, 1, 4, 3, 2),
           7 : (0, 2, 1, 3, 4),
           8 : (0, 2, 1, 4, 3),
           9 : (0, 2, 3, 1, 4),
          10 : (0, 2, 3, 4, 1),
          11 : (0, 2, 4, 1, 3),
          12 : (0, 2, 4, 3, 1),
          13 : (0, 3, 1, 2, 4),
          14 : (0, 3, 1, 4, 2),
          15 : (0, 3, 2, 1, 4),
          16 : (0, 3, 2, 4, 1),
          17 : (0, 3, 4, 1, 2),
          18 : (0, 3, 4, 2, 1),
          19 : (0, 4, 1, 2, 3),
          20 : (0, 4, 1, 3, 2),
          21 : (0, 4, 2, 1, 3),
          22 : (0, 4, 2, 3, 1),
          23 : (0, 4, 3, 1, 2),
          24 : (0, 4, 3, 2, 1),
          25 : (1, 0, 2, 3, 4),
          26 : (1, 0, 2, 4, 3),
          27 : (1, 0, 3, 2, 4),
          28 : (1, 0, 3, 4, 2),
          29 : (1, 0, 4, 2, 3),
          30 : (1, 0, 4, 3, 2),
          31 : (1, 2, 0, 3, 4),
          32 : (1, 2, 0, 4, 3),
          33 : (1, 2, 3, 0, 4),
          34 : (1, 2, 3, 4, 0),
          35 : (1, 2, 4, 0, 3),
          36 : (1, 2, 4, 3, 0),
          37 : (1, 3, 0, 2, 4),
          38 : (1, 3, 0, 4, 2),
          39 : (1, 3, 2, 0, 4),
          40 : (1, 3, 2, 4, 0),
          41 : (1, 3, 4, 0, 2),
          42 : (1, 3, 4, 2, 0),
          43 : (1, 4, 0, 2, 3),
          44 : (1, 4, 0, 3, 2),
          45 : (1, 4, 2, 0, 3),
          46 : (1, 4, 2, 3, 0),
          47 : (1, 4, 3, 0, 2),
          48 : (1, 4, 3, 2, 0),
          49 : (2, 0, 1, 3, 4),
          50 : (2, 0, 1, 4, 3),
          51 : (2, 0, 3, 1, 4),
          52 : (2, 0, 3, 4, 1),
          53 : (2, 0, 4, 1, 3),
          54 : (2, 0, 4, 3, 1),
          55 : (2, 1, 0, 3, 4),
          56 : (2, 1, 0, 4, 3),
          57 : (2, 1, 3, 0, 4),
          58 : (2, 1, 3, 4, 0),
          59 : (2, 1, 4, 0, 3),
          60 : (2, 1, 4, 3, 0),
          61 : (2, 3, 0, 1, 4),
          62 : (2, 3, 0, 4, 1),
          63 : (2, 3, 1, 0, 4),
          64 : (2, 3, 1, 4, 0),
          65 : (2, 3, 4, 0, 1),
          66 : (2, 3, 4, 1, 0),
          67 : (2, 4, 0, 1, 3),
          68 : (2, 4, 0, 3, 1),
          69 : (2, 4, 1, 0, 3),
          70 : (2, 4, 1, 3, 0),
          71 : (2, 4, 3, 0, 1),
          72 : (2, 4, 3, 1, 0),
          73 : (3, 0, 1, 2, 4),
          74 : (3, 0, 1, 4, 2),
          75 : (3, 0, 2, 1, 4),
          76 : (3, 0, 2, 4, 1),
          77 : (3, 0, 4, 1, 2),
          78 : (3, 0, 4, 2, 1),
          79 : (3, 1, 0, 2, 4),
          80 : (3, 1, 0, 4, 2),
          81 : (3, 1, 2, 0, 4),
          82 : (3, 1, 2, 4, 0),
          83 : (3, 1, 4, 0, 2),
          84 : (3, 1, 4, 2, 0),
          85 : (3, 2, 0, 1, 4),
          86 : (3, 2, 0, 4, 1),
          87 : (3, 2, 1, 0, 4),
          88 : (3, 2, 1, 4, 0),
          89 : (3, 2, 4, 0, 1),
          90 : (3, 2, 4, 1, 0),
          91 : (3, 4, 0, 1, 2),
          92 : (3, 4, 0, 2, 1),
          93 : (3, 4, 1, 0, 2),
          94 : (3, 4, 1, 2, 0),
          95 : (3, 4, 2, 0, 1),
          96 : (3, 4, 2, 1, 0),
          97 : (4, 0, 1, 2, 3),
          98 : (4, 0, 1, 3, 2),
          99 : (4, 0, 2, 1, 3),
          100 : (4, 0, 2, 3, 1),
          101 : (4, 0, 3, 1, 2),
          102 : (4, 0, 3, 2, 1),
          103 : (4, 1, 0, 2, 3),
          104 : (4, 1, 0, 3, 2),
          105 : (4, 1, 2, 0, 3),
          106 : (4, 1, 2, 3, 0),
          107 : (4, 1, 3, 0, 2),
          108 : (4, 1, 3, 2, 0),
          109 : (4, 2, 0, 1, 3),
          110 : (4, 2, 0, 3, 1),
          111 : (4, 2, 1, 0, 3),
          112 : (4, 2, 1, 3, 0),
          113 : (4, 2, 3, 0, 1),
          114 : (4, 2, 3, 1, 0),
          115 : (4, 3, 0, 1, 2),
          116 : (4, 3, 0, 2, 1),
          117 : (4, 3, 1, 0, 2),
          118 : (4, 3, 1, 2, 0),
          119 : (4, 3, 2, 0, 1),
          120 : (4, 3, 2, 1, 0)}

map_5_4 ={ 1 : (0, 0, 1, 2, 3),
           2 : (0, 0, 1, 3, 2),
           3 : (0, 0, 2, 1, 3),
           4 : (0, 0, 2, 3, 1),
           5 : (0, 0, 3, 1, 2),
           6 : (0, 0, 3, 2, 1),
           7 : (0, 1, 0, 2, 3),
           8 : (0, 1, 0, 3, 2),
           9 : (0, 1, 1, 2, 3),
          10 : (0, 1, 1, 3, 2),
          11 : (0, 1, 2, 0, 3),
          12 : (0, 1, 2, 1, 3),
          13 : (0, 1, 2, 2, 3),
          14 : (0, 1, 2, 3, 0),
          15 : (0, 1, 2, 3, 1),
          16 : (0, 1, 2, 3, 2),
          17 : (0, 1, 2, 3, 3),
          18 : (0, 1, 3, 0, 2),
          19 : (0, 1, 3, 1, 2),
          20 : (0, 1, 3, 2, 0),
          21 : (0, 1, 3, 2, 1),
          22 : (0, 1, 3, 2, 2),
          23 : (0, 1, 3, 2, 3),
          24 : (0, 1, 3, 3, 2),
          25 : (0, 2, 0, 1, 3),
          26 : (0, 2, 0, 3, 1),
          27 : (0, 2, 1, 0, 3),
          28 : (0, 2, 1, 1, 3),
          29 : (0, 2, 1, 2, 3),
          30 : (0, 2, 1, 3, 0),
          31 : (0, 2, 1, 3, 1),
          32 : (0, 2, 1, 3, 2),
          33 : (0, 2, 1, 3, 3),
          34 : (0, 2, 2, 1, 3),
          35 : (0, 2, 2, 3, 1),
          36 : (0, 2, 3, 0, 1),
          37 : (0, 2, 3, 1, 0),
          38 : (0, 2, 3, 1, 1),
          39 : (0, 2, 3, 1, 2),
          40 : (0, 2, 3, 1, 3),
          41 : (0, 2, 3, 2, 1),
          42 : (0, 2, 3, 3, 1),
          43 : (0, 3, 0, 1, 2),
          44 : (0, 3, 0, 2, 1),
          45 : (0, 3, 1, 0, 2),
          46 : (0, 3, 1, 1, 2),
          47 : (0, 3, 1, 2, 0),
          48 : (0, 3, 1, 2, 1),
          49 : (0, 3, 1, 2, 2),
          50 : (0, 3, 1, 2, 3),
          51 : (0, 3, 1, 3, 2),
          52 : (0, 3, 2, 0, 1),
          53 : (0, 3, 2, 1, 0),
          54 : (0, 3, 2, 1, 1),
          55 : (0, 3, 2, 1, 2),
          56 : (0, 3, 2, 1, 3),
          57 : (0, 3, 2, 2, 1),
          58 : (0, 3, 2, 3, 1),
          59 : (0, 3, 3, 1, 2),
          60 : (0, 3, 3, 2, 1),
          61 : (1, 0, 0, 2, 3),
          62 : (1, 0, 0, 3, 2),
          63 : (1, 0, 1, 2, 3),
          64 : (1, 0, 1, 3, 2),
          65 : (1, 0, 2, 0, 3),
          66 : (1, 0, 2, 1, 3),
          67 : (1, 0, 2, 2, 3),
          68 : (1, 0, 2, 3, 0),
          69 : (1, 0, 2, 3, 1),
          70 : (1, 0, 2, 3, 2),
          71 : (1, 0, 2, 3, 3),
          72 : (1, 0, 3, 0, 2),
          73 : (1, 0, 3, 1, 2),
          74 : (1, 0, 3, 2, 0),
          75 : (1, 0, 3, 2, 1),
          76 : (1, 0, 3, 2, 2),
          77 : (1, 0, 3, 2, 3),
          78 : (1, 0, 3, 3, 2),
          79 : (1, 1, 0, 2, 3),
          80 : (1, 1, 0, 3, 2),
          81 : (1, 1, 2, 0, 3),
          82 : (1, 1, 2, 3, 0),
          83 : (1, 1, 3, 0, 2),
          84 : (1, 1, 3, 2, 0),
          85 : (1, 2, 0, 0, 3),
          86 : (1, 2, 0, 1, 3),
          87 : (1, 2, 0, 2, 3),
          88 : (1, 2, 0, 3, 0),
          89 : (1, 2, 0, 3, 1),
          90 : (1, 2, 0, 3, 2),
          91 : (1, 2, 0, 3, 3),
          92 : (1, 2, 1, 0, 3),
          93 : (1, 2, 1, 3, 0),
          94 : (1, 2, 2, 0, 3),
          95 : (1, 2, 2, 3, 0),
          96 : (1, 2, 3, 0, 0),
          97 : (1, 2, 3, 0, 1),
          98 : (1, 2, 3, 0, 2),
          99 : (1, 2, 3, 0, 3),
          100 : (1, 2, 3, 1, 0),
          101 : (1, 2, 3, 2, 0),
          102 : (1, 2, 3, 3, 0),
          103 : (1, 3, 0, 0, 2),
          104 : (1, 3, 0, 1, 2),
          105 : (1, 3, 0, 2, 0),
          106 : (1, 3, 0, 2, 1),
          107 : (1, 3, 0, 2, 2),
          108 : (1, 3, 0, 2, 3),
          109 : (1, 3, 0, 3, 2),
          110 : (1, 3, 1, 0, 2),
          111 : (1, 3, 1, 2, 0),
          112 : (1, 3, 2, 0, 0),
          113 : (1, 3, 2, 0, 1),
          114 : (1, 3, 2, 0, 2),
          115 : (1, 3, 2, 0, 3),
          116 : (1, 3, 2, 1, 0),
          117 : (1, 3, 2, 2, 0),
          118 : (1, 3, 2, 3, 0),
          119 : (1, 3, 3, 0, 2),
          120 : (1, 3, 3, 2, 0),
          121 : (2, 0, 0, 1, 3),
          122 : (2, 0, 0, 3, 1),
          123 : (2, 0, 1, 0, 3),
          124 : (2, 0, 1, 1, 3),
          125 : (2, 0, 1, 2, 3),
          126 : (2, 0, 1, 3, 0),
          127 : (2, 0, 1, 3, 1),
          128 : (2, 0, 1, 3, 2),
          129 : (2, 0, 1, 3, 3),
          130 : (2, 0, 2, 1, 3),
          131 : (2, 0, 2, 3, 1),
          132 : (2, 0, 3, 0, 1),
          133 : (2, 0, 3, 1, 0),
          134 : (2, 0, 3, 1, 1),
          135 : (2, 0, 3, 1, 2),
          136 : (2, 0, 3, 1, 3),
          137 : (2, 0, 3, 2, 1),
          138 : (2, 0, 3, 3, 1),
          139 : (2, 1, 0, 0, 3),
          140 : (2, 1, 0, 1, 3),
          141 : (2, 1, 0, 2, 3),
          142 : (2, 1, 0, 3, 0),
          143 : (2, 1, 0, 3, 1),
          144 : (2, 1, 0, 3, 2),
          145 : (2, 1, 0, 3, 3),
          146 : (2, 1, 1, 0, 3),
          147 : (2, 1, 1, 3, 0),
          148 : (2, 1, 2, 0, 3),
          149 : (2, 1, 2, 3, 0),
          150 : (2, 1, 3, 0, 0),
          151 : (2, 1, 3, 0, 1),
          152 : (2, 1, 3, 0, 2),
          153 : (2, 1, 3, 0, 3),
          154 : (2, 1, 3, 1, 0),
          155 : (2, 1, 3, 2, 0),
          156 : (2, 1, 3, 3, 0),
          157 : (2, 2, 0, 1, 3),
          158 : (2, 2, 0, 3, 1),
          159 : (2, 2, 1, 0, 3),
          160 : (2, 2, 1, 3, 0),
          161 : (2, 2, 3, 0, 1),
          162 : (2, 2, 3, 1, 0),
          163 : (2, 3, 0, 0, 1),
          164 : (2, 3, 0, 1, 0),
          165 : (2, 3, 0, 1, 1),
          166 : (2, 3, 0, 1, 2),
          167 : (2, 3, 0, 1, 3),
          168 : (2, 3, 0, 2, 1),
          169 : (2, 3, 0, 3, 1),
          170 : (2, 3, 1, 0, 0),
          171 : (2, 3, 1, 0, 1),
          172 : (2, 3, 1, 0, 2),
          173 : (2, 3, 1, 0, 3),
          174 : (2, 3, 1, 1, 0),
          175 : (2, 3, 1, 2, 0),
          176 : (2, 3, 1, 3, 0),
          177 : (2, 3, 2, 0, 1),
          178 : (2, 3, 2, 1, 0),
          179 : (2, 3, 3, 0, 1),
          180 : (2, 3, 3, 1, 0),
          181 : (3, 0, 0, 1, 2),
          182 : (3, 0, 0, 2, 1),
          183 : (3, 0, 1, 0, 2),
          184 : (3, 0, 1, 1, 2),
          185 : (3, 0, 1, 2, 0),
          186 : (3, 0, 1, 2, 1),
          187 : (3, 0, 1, 2, 2),
          188 : (3, 0, 1, 2, 3),
          189 : (3, 0, 1, 3, 2),
          190 : (3, 0, 2, 0, 1),
          191 : (3, 0, 2, 1, 0),
          192 : (3, 0, 2, 1, 1),
          193 : (3, 0, 2, 1, 2),
          194 : (3, 0, 2, 1, 3),
          195 : (3, 0, 2, 2, 1),
          196 : (3, 0, 2, 3, 1),
          197 : (3, 0, 3, 1, 2),
          198 : (3, 0, 3, 2, 1),
          199 : (3, 1, 0, 0, 2),
          200 : (3, 1, 0, 1, 2),
          201 : (3, 1, 0, 2, 0),
          202 : (3, 1, 0, 2, 1),
          203 : (3, 1, 0, 2, 2),
          204 : (3, 1, 0, 2, 3),
          205 : (3, 1, 0, 3, 2),
          206 : (3, 1, 1, 0, 2),
          207 : (3, 1, 1, 2, 0),
          208 : (3, 1, 2, 0, 0),
          209 : (3, 1, 2, 0, 1),
          210 : (3, 1, 2, 0, 2),
          211 : (3, 1, 2, 0, 3),
          212 : (3, 1, 2, 1, 0),
          213 : (3, 1, 2, 2, 0),
          214 : (3, 1, 2, 3, 0),
          215 : (3, 1, 3, 0, 2),
          216 : (3, 1, 3, 2, 0),
          217 : (3, 2, 0, 0, 1),
          218 : (3, 2, 0, 1, 0),
          219 : (3, 2, 0, 1, 1),
          220 : (3, 2, 0, 1, 2),
          221 : (3, 2, 0, 1, 3),
          222 : (3, 2, 0, 2, 1),
          223 : (3, 2, 0, 3, 1),
          224 : (3, 2, 1, 0, 0),
          225 : (3, 2, 1, 0, 1),
          226 : (3, 2, 1, 0, 2),
          227 : (3, 2, 1, 0, 3),
          228 : (3, 2, 1, 1, 0),
          229 : (3, 2, 1, 2, 0),
          230 : (3, 2, 1, 3, 0),
          231 : (3, 2, 2, 0, 1),
          232 : (3, 2, 2, 1, 0),
          233 : (3, 2, 3, 0, 1),
          234 : (3, 2, 3, 1, 0),
          235 : (3, 3, 0, 1, 2),
          236 : (3, 3, 0, 2, 1),
          237 : (3, 3, 1, 0, 2),
          238 : (3, 3, 1, 2, 0),
          239 : (3, 3, 2, 0, 1),
          240 : (3, 3, 2, 1, 0)}

map_5_3 ={ 1 : (0, 0, 0, 1, 2),
           2 : (0, 0, 0, 2, 1),
           3 : (0, 0, 1, 0, 2),
           4 : (0, 0, 1, 1, 2),
           5 : (0, 0, 1, 2, 0),
           6 : (0, 0, 1, 2, 1),
           7 : (0, 0, 1, 2, 2),
           8 : (0, 0, 2, 0, 1),
           9 : (0, 0, 2, 1, 0),
          10 : (0, 0, 2, 1, 1),
          11 : (0, 0, 2, 1, 2),
          12 : (0, 0, 2, 2, 1),
          13 : (0, 1, 0, 0, 2),
          14 : (0, 1, 0, 1, 2),
          15 : (0, 1, 0, 2, 0),
          16 : (0, 1, 0, 2, 1),
          17 : (0, 1, 0, 2, 2),
          18 : (0, 1, 1, 0, 2),
          19 : (0, 1, 1, 1, 2),
          20 : (0, 1, 1, 2, 0),
          21 : (0, 1, 1, 2, 1),
          22 : (0, 1, 1, 2, 2),
          23 : (0, 1, 2, 0, 0),
          24 : (0, 1, 2, 0, 1),
          25 : (0, 1, 2, 0, 2),
          26 : (0, 1, 2, 1, 0),
          27 : (0, 1, 2, 1, 1),
          28 : (0, 1, 2, 1, 2),
          29 : (0, 1, 2, 2, 0),
          30 : (0, 1, 2, 2, 1),
          31 : (0, 1, 2, 2, 2),
          32 : (0, 2, 0, 0, 1),
          33 : (0, 2, 0, 1, 0),
          34 : (0, 2, 0, 1, 1),
          35 : (0, 2, 0, 1, 2),
          36 : (0, 2, 0, 2, 1),
          37 : (0, 2, 1, 0, 0),
          38 : (0, 2, 1, 0, 1),
          39 : (0, 2, 1, 0, 2),
          40 : (0, 2, 1, 1, 0),
          41 : (0, 2, 1, 1, 1),
          42 : (0, 2, 1, 1, 2),
          43 : (0, 2, 1, 2, 0),
          44 : (0, 2, 1, 2, 1),
          45 : (0, 2, 1, 2, 2),
          46 : (0, 2, 2, 0, 1),
          47 : (0, 2, 2, 1, 0),
          48 : (0, 2, 2, 1, 1),
          49 : (0, 2, 2, 1, 2),
          50 : (0, 2, 2, 2, 1),
          51 : (1, 0, 0, 0, 2),
          52 : (1, 0, 0, 1, 2),
          53 : (1, 0, 0, 2, 0),
          54 : (1, 0, 0, 2, 1),
          55 : (1, 0, 0, 2, 2),
          56 : (1, 0, 1, 0, 2),
          57 : (1, 0, 1, 1, 2),
          58 : (1, 0, 1, 2, 0),
          59 : (1, 0, 1, 2, 1),
          60 : (1, 0, 1, 2, 2),
          61 : (1, 0, 2, 0, 0),
          62 : (1, 0, 2, 0, 1),
          63 : (1, 0, 2, 0, 2),
          64 : (1, 0, 2, 1, 0),
          65 : (1, 0, 2, 1, 1),
          66 : (1, 0, 2, 1, 2),
          67 : (1, 0, 2, 2, 0),
          68 : (1, 0, 2, 2, 1),
          69 : (1, 0, 2, 2, 2),
          70 : (1, 1, 0, 0, 2),
          71 : (1, 1, 0, 1, 2),
          72 : (1, 1, 0, 2, 0),
          73 : (1, 1, 0, 2, 1),
          74 : (1, 1, 0, 2, 2),
          75 : (1, 1, 1, 0, 2),
          76 : (1, 1, 1, 2, 0),
          77 : (1, 1, 2, 0, 0),
          78 : (1, 1, 2, 0, 1),
          79 : (1, 1, 2, 0, 2),
          80 : (1, 1, 2, 1, 0),
          81 : (1, 1, 2, 2, 0),
          82 : (1, 2, 0, 0, 0),
          83 : (1, 2, 0, 0, 1),
          84 : (1, 2, 0, 0, 2),
          85 : (1, 2, 0, 1, 0),
          86 : (1, 2, 0, 1, 1),
          87 : (1, 2, 0, 1, 2),
          88 : (1, 2, 0, 2, 0),
          89 : (1, 2, 0, 2, 1),
          90 : (1, 2, 0, 2, 2),
          91 : (1, 2, 1, 0, 0),
          92 : (1, 2, 1, 0, 1),
          93 : (1, 2, 1, 0, 2),
          94 : (1, 2, 1, 1, 0),
          95 : (1, 2, 1, 2, 0),
          96 : (1, 2, 2, 0, 0),
          97 : (1, 2, 2, 0, 1),
          98 : (1, 2, 2, 0, 2),
          99 : (1, 2, 2, 1, 0),
          100 : (1, 2, 2, 2, 0),
          101 : (2, 0, 0, 0, 1),
          102 : (2, 0, 0, 1, 0),
          103 : (2, 0, 0, 1, 1),
          104 : (2, 0, 0, 1, 2),
          105 : (2, 0, 0, 2, 1),
          106 : (2, 0, 1, 0, 0),
          107 : (2, 0, 1, 0, 1),
          108 : (2, 0, 1, 0, 2),
          109 : (2, 0, 1, 1, 0),
          110 : (2, 0, 1, 1, 1),
          111 : (2, 0, 1, 1, 2),
          112 : (2, 0, 1, 2, 0),
          113 : (2, 0, 1, 2, 1),
          114 : (2, 0, 1, 2, 2),
          115 : (2, 0, 2, 0, 1),
          116 : (2, 0, 2, 1, 0),
          117 : (2, 0, 2, 1, 1),
          118 : (2, 0, 2, 1, 2),
          119 : (2, 0, 2, 2, 1),
          120 : (2, 1, 0, 0, 0),
          121 : (2, 1, 0, 0, 1),
          122 : (2, 1, 0, 0, 2),
          123 : (2, 1, 0, 1, 0),
          124 : (2, 1, 0, 1, 1),
          125 : (2, 1, 0, 1, 2),
          126 : (2, 1, 0, 2, 0),
          127 : (2, 1, 0, 2, 1),
          128 : (2, 1, 0, 2, 2),
          129 : (2, 1, 1, 0, 0),
          130 : (2, 1, 1, 0, 1),
          131 : (2, 1, 1, 0, 2),
          132 : (2, 1, 1, 1, 0),
          133 : (2, 1, 1, 2, 0),
          134 : (2, 1, 2, 0, 0),
          135 : (2, 1, 2, 0, 1),
          136 : (2, 1, 2, 0, 2),
          137 : (2, 1, 2, 1, 0),
          138 : (2, 1, 2, 2, 0),
          139 : (2, 2, 0, 0, 1),
          140 : (2, 2, 0, 1, 0),
          141 : (2, 2, 0, 1, 1),
          142 : (2, 2, 0, 1, 2),
          143 : (2, 2, 0, 2, 1),
          144 : (2, 2, 1, 0, 0),
          145 : (2, 2, 1, 0, 1),
          146 : (2, 2, 1, 0, 2),
          147 : (2, 2, 1, 1, 0),
          148 : (2, 2, 1, 2, 0),
          149 : (2, 2, 2, 0, 1),
          150 : (2, 2, 2, 1, 0)}

map_5_2 ={ 1 : (0, 0, 0, 0, 1),
           2 : (0, 0, 0, 1, 0),
           3 : (0, 0, 0, 1, 1),
           4 : (0, 0, 1, 0, 0),
           5 : (0, 0, 1, 0, 1),
           6 : (0, 0, 1, 1, 0),
           7 : (0, 0, 1, 1, 1),
           8 : (0, 1, 0, 0, 0),
           9 : (0, 1, 0, 0, 1),
          10 : (0, 1, 0, 1, 0),
          11 : (0, 1, 0, 1, 1),
          12 : (0, 1, 1, 0, 0),
          13 : (0, 1, 1, 0, 1),
          14 : (0, 1, 1, 1, 0),
          15 : (0, 1, 1, 1, 1),
          16 : (1, 0, 0, 0, 0),
          17 : (1, 0, 0, 0, 1),
          18 : (1, 0, 0, 1, 0),
          19 : (1, 0, 0, 1, 1),
          20 : (1, 0, 1, 0, 0),
          21 : (1, 0, 1, 0, 1),
          22 : (1, 0, 1, 1, 0),
          23 : (1, 0, 1, 1, 1),
          24 : (1, 1, 0, 0, 0),
          25 : (1, 1, 0, 0, 1),
          26 : (1, 1, 0, 1, 0),
          27 : (1, 1, 0, 1, 1),
          28 : (1, 1, 1, 0, 0),
          29 : (1, 1, 1, 0, 1),
          30 : (1, 1, 1, 1, 0)}

map_5_1 ={ 1 : (0, 0, 0, 0, 0)}
#----------------------------
map_6_6 ={ 1 : (0, 1, 2, 3, 4, 5),
           2 : (0, 1, 2, 3, 5, 4),
           3 : (0, 1, 2, 4, 3, 5),
           4 : (0, 1, 2, 4, 5, 3),
           5 : (0, 1, 2, 5, 3, 4),
           6 : (0, 1, 2, 5, 4, 3),
           7 : (0, 1, 3, 2, 4, 5),
           8 : (0, 1, 3, 2, 5, 4),
           9 : (0, 1, 3, 4, 2, 5),
          10 : (0, 1, 3, 4, 5, 2),
          11 : (0, 1, 3, 5, 2, 4),
          12 : (0, 1, 3, 5, 4, 2),
          13 : (0, 1, 4, 2, 3, 5),
          14 : (0, 1, 4, 2, 5, 3),
          15 : (0, 1, 4, 3, 2, 5),
          16 : (0, 1, 4, 3, 5, 2),
          17 : (0, 1, 4, 5, 2, 3),
          18 : (0, 1, 4, 5, 3, 2),
          19 : (0, 1, 5, 2, 3, 4),
          20 : (0, 1, 5, 2, 4, 3),
          21 : (0, 1, 5, 3, 2, 4),
          22 : (0, 1, 5, 3, 4, 2),
          23 : (0, 1, 5, 4, 2, 3),
          24 : (0, 1, 5, 4, 3, 2),
          25 : (0, 2, 1, 3, 4, 5),
          26 : (0, 2, 1, 3, 5, 4),
          27 : (0, 2, 1, 4, 3, 5),
          28 : (0, 2, 1, 4, 5, 3),
          29 : (0, 2, 1, 5, 3, 4),
          30 : (0, 2, 1, 5, 4, 3),
          31 : (0, 2, 3, 1, 4, 5),
          32 : (0, 2, 3, 1, 5, 4),
          33 : (0, 2, 3, 4, 1, 5),
          34 : (0, 2, 3, 4, 5, 1),
          35 : (0, 2, 3, 5, 1, 4),
          36 : (0, 2, 3, 5, 4, 1),
          37 : (0, 2, 4, 1, 3, 5),
          38 : (0, 2, 4, 1, 5, 3),
          39 : (0, 2, 4, 3, 1, 5),
          40 : (0, 2, 4, 3, 5, 1),
          41 : (0, 2, 4, 5, 1, 3),
          42 : (0, 2, 4, 5, 3, 1),
          43 : (0, 2, 5, 1, 3, 4),
          44 : (0, 2, 5, 1, 4, 3),
          45 : (0, 2, 5, 3, 1, 4),
          46 : (0, 2, 5, 3, 4, 1),
          47 : (0, 2, 5, 4, 1, 3),
          48 : (0, 2, 5, 4, 3, 1),
          49 : (0, 3, 1, 2, 4, 5),
          50 : (0, 3, 1, 2, 5, 4),
          51 : (0, 3, 1, 4, 2, 5),
          52 : (0, 3, 1, 4, 5, 2),
          53 : (0, 3, 1, 5, 2, 4),
          54 : (0, 3, 1, 5, 4, 2),
          55 : (0, 3, 2, 1, 4, 5),
          56 : (0, 3, 2, 1, 5, 4),
          57 : (0, 3, 2, 4, 1, 5),
          58 : (0, 3, 2, 4, 5, 1),
          59 : (0, 3, 2, 5, 1, 4),
          60 : (0, 3, 2, 5, 4, 1),
          61 : (0, 3, 4, 1, 2, 5),
          62 : (0, 3, 4, 1, 5, 2),
          63 : (0, 3, 4, 2, 1, 5),
          64 : (0, 3, 4, 2, 5, 1),
          65 : (0, 3, 4, 5, 1, 2),
          66 : (0, 3, 4, 5, 2, 1),
          67 : (0, 3, 5, 1, 2, 4),
          68 : (0, 3, 5, 1, 4, 2),
          69 : (0, 3, 5, 2, 1, 4),
          70 : (0, 3, 5, 2, 4, 1),
          71 : (0, 3, 5, 4, 1, 2),
          72 : (0, 3, 5, 4, 2, 1),
          73 : (0, 4, 1, 2, 3, 5),
          74 : (0, 4, 1, 2, 5, 3),
          75 : (0, 4, 1, 3, 2, 5),
          76 : (0, 4, 1, 3, 5, 2),
          77 : (0, 4, 1, 5, 2, 3),
          78 : (0, 4, 1, 5, 3, 2),
          79 : (0, 4, 2, 1, 3, 5),
          80 : (0, 4, 2, 1, 5, 3),
          81 : (0, 4, 2, 3, 1, 5),
          82 : (0, 4, 2, 3, 5, 1),
          83 : (0, 4, 2, 5, 1, 3),
          84 : (0, 4, 2, 5, 3, 1),
          85 : (0, 4, 3, 1, 2, 5),
          86 : (0, 4, 3, 1, 5, 2),
          87 : (0, 4, 3, 2, 1, 5),
          88 : (0, 4, 3, 2, 5, 1),
          89 : (0, 4, 3, 5, 1, 2),
          90 : (0, 4, 3, 5, 2, 1),
          91 : (0, 4, 5, 1, 2, 3),
          92 : (0, 4, 5, 1, 3, 2),
          93 : (0, 4, 5, 2, 1, 3),
          94 : (0, 4, 5, 2, 3, 1),
          95 : (0, 4, 5, 3, 1, 2),
          96 : (0, 4, 5, 3, 2, 1),
          97 : (0, 5, 1, 2, 3, 4),
          98 : (0, 5, 1, 2, 4, 3),
          99 : (0, 5, 1, 3, 2, 4),
          100 : (0, 5, 1, 3, 4, 2),
          101 : (0, 5, 1, 4, 2, 3),
          102 : (0, 5, 1, 4, 3, 2),
          103 : (0, 5, 2, 1, 3, 4),
          104 : (0, 5, 2, 1, 4, 3),
          105 : (0, 5, 2, 3, 1, 4),
          106 : (0, 5, 2, 3, 4, 1),
          107 : (0, 5, 2, 4, 1, 3),
          108 : (0, 5, 2, 4, 3, 1),
          109 : (0, 5, 3, 1, 2, 4),
          110 : (0, 5, 3, 1, 4, 2),
          111 : (0, 5, 3, 2, 1, 4),
          112 : (0, 5, 3, 2, 4, 1),
          113 : (0, 5, 3, 4, 1, 2),
          114 : (0, 5, 3, 4, 2, 1),
          115 : (0, 5, 4, 1, 2, 3),
          116 : (0, 5, 4, 1, 3, 2),
          117 : (0, 5, 4, 2, 1, 3),
          118 : (0, 5, 4, 2, 3, 1),
          119 : (0, 5, 4, 3, 1, 2),
          120 : (0, 5, 4, 3, 2, 1),
          121 : (1, 0, 2, 3, 4, 5),
          122 : (1, 0, 2, 3, 5, 4),
          123 : (1, 0, 2, 4, 3, 5),
          124 : (1, 0, 2, 4, 5, 3),
          125 : (1, 0, 2, 5, 3, 4),
          126 : (1, 0, 2, 5, 4, 3),
          127 : (1, 0, 3, 2, 4, 5),
          128 : (1, 0, 3, 2, 5, 4),
          129 : (1, 0, 3, 4, 2, 5),
          130 : (1, 0, 3, 4, 5, 2),
          131 : (1, 0, 3, 5, 2, 4),
          132 : (1, 0, 3, 5, 4, 2),
          133 : (1, 0, 4, 2, 3, 5),
          134 : (1, 0, 4, 2, 5, 3),
          135 : (1, 0, 4, 3, 2, 5),
          136 : (1, 0, 4, 3, 5, 2),
          137 : (1, 0, 4, 5, 2, 3),
          138 : (1, 0, 4, 5, 3, 2),
          139 : (1, 0, 5, 2, 3, 4),
          140 : (1, 0, 5, 2, 4, 3),
          141 : (1, 0, 5, 3, 2, 4),
          142 : (1, 0, 5, 3, 4, 2),
          143 : (1, 0, 5, 4, 2, 3),
          144 : (1, 0, 5, 4, 3, 2),
          145 : (1, 2, 0, 3, 4, 5),
          146 : (1, 2, 0, 3, 5, 4),
          147 : (1, 2, 0, 4, 3, 5),
          148 : (1, 2, 0, 4, 5, 3),
          149 : (1, 2, 0, 5, 3, 4),
          150 : (1, 2, 0, 5, 4, 3),
          151 : (1, 2, 3, 0, 4, 5),
          152 : (1, 2, 3, 0, 5, 4),
          153 : (1, 2, 3, 4, 0, 5),
          154 : (1, 2, 3, 4, 5, 0),
          155 : (1, 2, 3, 5, 0, 4),
          156 : (1, 2, 3, 5, 4, 0),
          157 : (1, 2, 4, 0, 3, 5),
          158 : (1, 2, 4, 0, 5, 3),
          159 : (1, 2, 4, 3, 0, 5),
          160 : (1, 2, 4, 3, 5, 0),
          161 : (1, 2, 4, 5, 0, 3),
          162 : (1, 2, 4, 5, 3, 0),
          163 : (1, 2, 5, 0, 3, 4),
          164 : (1, 2, 5, 0, 4, 3),
          165 : (1, 2, 5, 3, 0, 4),
          166 : (1, 2, 5, 3, 4, 0),
          167 : (1, 2, 5, 4, 0, 3),
          168 : (1, 2, 5, 4, 3, 0),
          169 : (1, 3, 0, 2, 4, 5),
          170 : (1, 3, 0, 2, 5, 4),
          171 : (1, 3, 0, 4, 2, 5),
          172 : (1, 3, 0, 4, 5, 2),
          173 : (1, 3, 0, 5, 2, 4),
          174 : (1, 3, 0, 5, 4, 2),
          175 : (1, 3, 2, 0, 4, 5),
          176 : (1, 3, 2, 0, 5, 4),
          177 : (1, 3, 2, 4, 0, 5),
          178 : (1, 3, 2, 4, 5, 0),
          179 : (1, 3, 2, 5, 0, 4),
          180 : (1, 3, 2, 5, 4, 0),
          181 : (1, 3, 4, 0, 2, 5),
          182 : (1, 3, 4, 0, 5, 2),
          183 : (1, 3, 4, 2, 0, 5),
          184 : (1, 3, 4, 2, 5, 0),
          185 : (1, 3, 4, 5, 0, 2),
          186 : (1, 3, 4, 5, 2, 0),
          187 : (1, 3, 5, 0, 2, 4),
          188 : (1, 3, 5, 0, 4, 2),
          189 : (1, 3, 5, 2, 0, 4),
          190 : (1, 3, 5, 2, 4, 0),
          191 : (1, 3, 5, 4, 0, 2),
          192 : (1, 3, 5, 4, 2, 0),
          193 : (1, 4, 0, 2, 3, 5),
          194 : (1, 4, 0, 2, 5, 3),
          195 : (1, 4, 0, 3, 2, 5),
          196 : (1, 4, 0, 3, 5, 2),
          197 : (1, 4, 0, 5, 2, 3),
          198 : (1, 4, 0, 5, 3, 2),
          199 : (1, 4, 2, 0, 3, 5),
          200 : (1, 4, 2, 0, 5, 3),
          201 : (1, 4, 2, 3, 0, 5),
          202 : (1, 4, 2, 3, 5, 0),
          203 : (1, 4, 2, 5, 0, 3),
          204 : (1, 4, 2, 5, 3, 0),
          205 : (1, 4, 3, 0, 2, 5),
          206 : (1, 4, 3, 0, 5, 2),
          207 : (1, 4, 3, 2, 0, 5),
          208 : (1, 4, 3, 2, 5, 0),
          209 : (1, 4, 3, 5, 0, 2),
          210 : (1, 4, 3, 5, 2, 0),
          211 : (1, 4, 5, 0, 2, 3),
          212 : (1, 4, 5, 0, 3, 2),
          213 : (1, 4, 5, 2, 0, 3),
          214 : (1, 4, 5, 2, 3, 0),
          215 : (1, 4, 5, 3, 0, 2),
          216 : (1, 4, 5, 3, 2, 0),
          217 : (1, 5, 0, 2, 3, 4),
          218 : (1, 5, 0, 2, 4, 3),
          219 : (1, 5, 0, 3, 2, 4),
          220 : (1, 5, 0, 3, 4, 2),
          221 : (1, 5, 0, 4, 2, 3),
          222 : (1, 5, 0, 4, 3, 2),
          223 : (1, 5, 2, 0, 3, 4),
          224 : (1, 5, 2, 0, 4, 3),
          225 : (1, 5, 2, 3, 0, 4),
          226 : (1, 5, 2, 3, 4, 0),
          227 : (1, 5, 2, 4, 0, 3),
          228 : (1, 5, 2, 4, 3, 0),
          229 : (1, 5, 3, 0, 2, 4),
          230 : (1, 5, 3, 0, 4, 2),
          231 : (1, 5, 3, 2, 0, 4),
          232 : (1, 5, 3, 2, 4, 0),
          233 : (1, 5, 3, 4, 0, 2),
          234 : (1, 5, 3, 4, 2, 0),
          235 : (1, 5, 4, 0, 2, 3),
          236 : (1, 5, 4, 0, 3, 2),
          237 : (1, 5, 4, 2, 0, 3),
          238 : (1, 5, 4, 2, 3, 0),
          239 : (1, 5, 4, 3, 0, 2),
          240 : (1, 5, 4, 3, 2, 0),
          241 : (2, 0, 1, 3, 4, 5),
          242 : (2, 0, 1, 3, 5, 4),
          243 : (2, 0, 1, 4, 3, 5),
          244 : (2, 0, 1, 4, 5, 3),
          245 : (2, 0, 1, 5, 3, 4),
          246 : (2, 0, 1, 5, 4, 3),
          247 : (2, 0, 3, 1, 4, 5),
          248 : (2, 0, 3, 1, 5, 4),
          249 : (2, 0, 3, 4, 1, 5),
          250 : (2, 0, 3, 4, 5, 1),
          251 : (2, 0, 3, 5, 1, 4),
          252 : (2, 0, 3, 5, 4, 1),
          253 : (2, 0, 4, 1, 3, 5),
          254 : (2, 0, 4, 1, 5, 3),
          255 : (2, 0, 4, 3, 1, 5),
          256 : (2, 0, 4, 3, 5, 1),
          257 : (2, 0, 4, 5, 1, 3),
          258 : (2, 0, 4, 5, 3, 1),
          259 : (2, 0, 5, 1, 3, 4),
          260 : (2, 0, 5, 1, 4, 3),
          261 : (2, 0, 5, 3, 1, 4),
          262 : (2, 0, 5, 3, 4, 1),
          263 : (2, 0, 5, 4, 1, 3),
          264 : (2, 0, 5, 4, 3, 1),
          265 : (2, 1, 0, 3, 4, 5),
          266 : (2, 1, 0, 3, 5, 4),
          267 : (2, 1, 0, 4, 3, 5),
          268 : (2, 1, 0, 4, 5, 3),
          269 : (2, 1, 0, 5, 3, 4),
          270 : (2, 1, 0, 5, 4, 3),
          271 : (2, 1, 3, 0, 4, 5),
          272 : (2, 1, 3, 0, 5, 4),
          273 : (2, 1, 3, 4, 0, 5),
          274 : (2, 1, 3, 4, 5, 0),
          275 : (2, 1, 3, 5, 0, 4),
          276 : (2, 1, 3, 5, 4, 0),
          277 : (2, 1, 4, 0, 3, 5),
          278 : (2, 1, 4, 0, 5, 3),
          279 : (2, 1, 4, 3, 0, 5),
          280 : (2, 1, 4, 3, 5, 0),
          281 : (2, 1, 4, 5, 0, 3),
          282 : (2, 1, 4, 5, 3, 0),
          283 : (2, 1, 5, 0, 3, 4),
          284 : (2, 1, 5, 0, 4, 3),
          285 : (2, 1, 5, 3, 0, 4),
          286 : (2, 1, 5, 3, 4, 0),
          287 : (2, 1, 5, 4, 0, 3),
          288 : (2, 1, 5, 4, 3, 0),
          289 : (2, 3, 0, 1, 4, 5),
          290 : (2, 3, 0, 1, 5, 4),
          291 : (2, 3, 0, 4, 1, 5),
          292 : (2, 3, 0, 4, 5, 1),
          293 : (2, 3, 0, 5, 1, 4),
          294 : (2, 3, 0, 5, 4, 1),
          295 : (2, 3, 1, 0, 4, 5),
          296 : (2, 3, 1, 0, 5, 4),
          297 : (2, 3, 1, 4, 0, 5),
          298 : (2, 3, 1, 4, 5, 0),
          299 : (2, 3, 1, 5, 0, 4),
          300 : (2, 3, 1, 5, 4, 0),
          301 : (2, 3, 4, 0, 1, 5),
          302 : (2, 3, 4, 0, 5, 1),
          303 : (2, 3, 4, 1, 0, 5),
          304 : (2, 3, 4, 1, 5, 0),
          305 : (2, 3, 4, 5, 0, 1),
          306 : (2, 3, 4, 5, 1, 0),
          307 : (2, 3, 5, 0, 1, 4),
          308 : (2, 3, 5, 0, 4, 1),
          309 : (2, 3, 5, 1, 0, 4),
          310 : (2, 3, 5, 1, 4, 0),
          311 : (2, 3, 5, 4, 0, 1),
          312 : (2, 3, 5, 4, 1, 0),
          313 : (2, 4, 0, 1, 3, 5),
          314 : (2, 4, 0, 1, 5, 3),
          315 : (2, 4, 0, 3, 1, 5),
          316 : (2, 4, 0, 3, 5, 1),
          317 : (2, 4, 0, 5, 1, 3),
          318 : (2, 4, 0, 5, 3, 1),
          319 : (2, 4, 1, 0, 3, 5),
          320 : (2, 4, 1, 0, 5, 3),
          321 : (2, 4, 1, 3, 0, 5),
          322 : (2, 4, 1, 3, 5, 0),
          323 : (2, 4, 1, 5, 0, 3),
          324 : (2, 4, 1, 5, 3, 0),
          325 : (2, 4, 3, 0, 1, 5),
          326 : (2, 4, 3, 0, 5, 1),
          327 : (2, 4, 3, 1, 0, 5),
          328 : (2, 4, 3, 1, 5, 0),
          329 : (2, 4, 3, 5, 0, 1),
          330 : (2, 4, 3, 5, 1, 0),
          331 : (2, 4, 5, 0, 1, 3),
          332 : (2, 4, 5, 0, 3, 1),
          333 : (2, 4, 5, 1, 0, 3),
          334 : (2, 4, 5, 1, 3, 0),
          335 : (2, 4, 5, 3, 0, 1),
          336 : (2, 4, 5, 3, 1, 0),
          337 : (2, 5, 0, 1, 3, 4),
          338 : (2, 5, 0, 1, 4, 3),
          339 : (2, 5, 0, 3, 1, 4),
          340 : (2, 5, 0, 3, 4, 1),
          341 : (2, 5, 0, 4, 1, 3),
          342 : (2, 5, 0, 4, 3, 1),
          343 : (2, 5, 1, 0, 3, 4),
          344 : (2, 5, 1, 0, 4, 3),
          345 : (2, 5, 1, 3, 0, 4),
          346 : (2, 5, 1, 3, 4, 0),
          347 : (2, 5, 1, 4, 0, 3),
          348 : (2, 5, 1, 4, 3, 0),
          349 : (2, 5, 3, 0, 1, 4),
          350 : (2, 5, 3, 0, 4, 1),
          351 : (2, 5, 3, 1, 0, 4),
          352 : (2, 5, 3, 1, 4, 0),
          353 : (2, 5, 3, 4, 0, 1),
          354 : (2, 5, 3, 4, 1, 0),
          355 : (2, 5, 4, 0, 1, 3),
          356 : (2, 5, 4, 0, 3, 1),
          357 : (2, 5, 4, 1, 0, 3),
          358 : (2, 5, 4, 1, 3, 0),
          359 : (2, 5, 4, 3, 0, 1),
          360 : (2, 5, 4, 3, 1, 0),
          361 : (3, 0, 1, 2, 4, 5),
          362 : (3, 0, 1, 2, 5, 4),
          363 : (3, 0, 1, 4, 2, 5),
          364 : (3, 0, 1, 4, 5, 2),
          365 : (3, 0, 1, 5, 2, 4),
          366 : (3, 0, 1, 5, 4, 2),
          367 : (3, 0, 2, 1, 4, 5),
          368 : (3, 0, 2, 1, 5, 4),
          369 : (3, 0, 2, 4, 1, 5),
          370 : (3, 0, 2, 4, 5, 1),
          371 : (3, 0, 2, 5, 1, 4),
          372 : (3, 0, 2, 5, 4, 1),
          373 : (3, 0, 4, 1, 2, 5),
          374 : (3, 0, 4, 1, 5, 2),
          375 : (3, 0, 4, 2, 1, 5),
          376 : (3, 0, 4, 2, 5, 1),
          377 : (3, 0, 4, 5, 1, 2),
          378 : (3, 0, 4, 5, 2, 1),
          379 : (3, 0, 5, 1, 2, 4),
          380 : (3, 0, 5, 1, 4, 2),
          381 : (3, 0, 5, 2, 1, 4),
          382 : (3, 0, 5, 2, 4, 1),
          383 : (3, 0, 5, 4, 1, 2),
          384 : (3, 0, 5, 4, 2, 1),
          385 : (3, 1, 0, 2, 4, 5),
          386 : (3, 1, 0, 2, 5, 4),
          387 : (3, 1, 0, 4, 2, 5),
          388 : (3, 1, 0, 4, 5, 2),
          389 : (3, 1, 0, 5, 2, 4),
          390 : (3, 1, 0, 5, 4, 2),
          391 : (3, 1, 2, 0, 4, 5),
          392 : (3, 1, 2, 0, 5, 4),
          393 : (3, 1, 2, 4, 0, 5),
          394 : (3, 1, 2, 4, 5, 0),
          395 : (3, 1, 2, 5, 0, 4),
          396 : (3, 1, 2, 5, 4, 0),
          397 : (3, 1, 4, 0, 2, 5),
          398 : (3, 1, 4, 0, 5, 2),
          399 : (3, 1, 4, 2, 0, 5),
          400 : (3, 1, 4, 2, 5, 0),
          401 : (3, 1, 4, 5, 0, 2),
          402 : (3, 1, 4, 5, 2, 0),
          403 : (3, 1, 5, 0, 2, 4),
          404 : (3, 1, 5, 0, 4, 2),
          405 : (3, 1, 5, 2, 0, 4),
          406 : (3, 1, 5, 2, 4, 0),
          407 : (3, 1, 5, 4, 0, 2),
          408 : (3, 1, 5, 4, 2, 0),
          409 : (3, 2, 0, 1, 4, 5),
          410 : (3, 2, 0, 1, 5, 4),
          411 : (3, 2, 0, 4, 1, 5),
          412 : (3, 2, 0, 4, 5, 1),
          413 : (3, 2, 0, 5, 1, 4),
          414 : (3, 2, 0, 5, 4, 1),
          415 : (3, 2, 1, 0, 4, 5),
          416 : (3, 2, 1, 0, 5, 4),
          417 : (3, 2, 1, 4, 0, 5),
          418 : (3, 2, 1, 4, 5, 0),
          419 : (3, 2, 1, 5, 0, 4),
          420 : (3, 2, 1, 5, 4, 0),
          421 : (3, 2, 4, 0, 1, 5),
          422 : (3, 2, 4, 0, 5, 1),
          423 : (3, 2, 4, 1, 0, 5),
          424 : (3, 2, 4, 1, 5, 0),
          425 : (3, 2, 4, 5, 0, 1),
          426 : (3, 2, 4, 5, 1, 0),
          427 : (3, 2, 5, 0, 1, 4),
          428 : (3, 2, 5, 0, 4, 1),
          429 : (3, 2, 5, 1, 0, 4),
          430 : (3, 2, 5, 1, 4, 0),
          431 : (3, 2, 5, 4, 0, 1),
          432 : (3, 2, 5, 4, 1, 0),
          433 : (3, 4, 0, 1, 2, 5),
          434 : (3, 4, 0, 1, 5, 2),
          435 : (3, 4, 0, 2, 1, 5),
          436 : (3, 4, 0, 2, 5, 1),
          437 : (3, 4, 0, 5, 1, 2),
          438 : (3, 4, 0, 5, 2, 1),
          439 : (3, 4, 1, 0, 2, 5),
          440 : (3, 4, 1, 0, 5, 2),
          441 : (3, 4, 1, 2, 0, 5),
          442 : (3, 4, 1, 2, 5, 0),
          443 : (3, 4, 1, 5, 0, 2),
          444 : (3, 4, 1, 5, 2, 0),
          445 : (3, 4, 2, 0, 1, 5),
          446 : (3, 4, 2, 0, 5, 1),
          447 : (3, 4, 2, 1, 0, 5),
          448 : (3, 4, 2, 1, 5, 0),
          449 : (3, 4, 2, 5, 0, 1),
          450 : (3, 4, 2, 5, 1, 0),
          451 : (3, 4, 5, 0, 1, 2),
          452 : (3, 4, 5, 0, 2, 1),
          453 : (3, 4, 5, 1, 0, 2),
          454 : (3, 4, 5, 1, 2, 0),
          455 : (3, 4, 5, 2, 0, 1),
          456 : (3, 4, 5, 2, 1, 0),
          457 : (3, 5, 0, 1, 2, 4),
          458 : (3, 5, 0, 1, 4, 2),
          459 : (3, 5, 0, 2, 1, 4),
          460 : (3, 5, 0, 2, 4, 1),
          461 : (3, 5, 0, 4, 1, 2),
          462 : (3, 5, 0, 4, 2, 1),
          463 : (3, 5, 1, 0, 2, 4),
          464 : (3, 5, 1, 0, 4, 2),
          465 : (3, 5, 1, 2, 0, 4),
          466 : (3, 5, 1, 2, 4, 0),
          467 : (3, 5, 1, 4, 0, 2),
          468 : (3, 5, 1, 4, 2, 0),
          469 : (3, 5, 2, 0, 1, 4),
          470 : (3, 5, 2, 0, 4, 1),
          471 : (3, 5, 2, 1, 0, 4),
          472 : (3, 5, 2, 1, 4, 0),
          473 : (3, 5, 2, 4, 0, 1),
          474 : (3, 5, 2, 4, 1, 0),
          475 : (3, 5, 4, 0, 1, 2),
          476 : (3, 5, 4, 0, 2, 1),
          477 : (3, 5, 4, 1, 0, 2),
          478 : (3, 5, 4, 1, 2, 0),
          479 : (3, 5, 4, 2, 0, 1),
          480 : (3, 5, 4, 2, 1, 0),
          481 : (4, 0, 1, 2, 3, 5),
          482 : (4, 0, 1, 2, 5, 3),
          483 : (4, 0, 1, 3, 2, 5),
          484 : (4, 0, 1, 3, 5, 2),
          485 : (4, 0, 1, 5, 2, 3),
          486 : (4, 0, 1, 5, 3, 2),
          487 : (4, 0, 2, 1, 3, 5),
          488 : (4, 0, 2, 1, 5, 3),
          489 : (4, 0, 2, 3, 1, 5),
          490 : (4, 0, 2, 3, 5, 1),
          491 : (4, 0, 2, 5, 1, 3),
          492 : (4, 0, 2, 5, 3, 1),
          493 : (4, 0, 3, 1, 2, 5),
          494 : (4, 0, 3, 1, 5, 2),
          495 : (4, 0, 3, 2, 1, 5),
          496 : (4, 0, 3, 2, 5, 1),
          497 : (4, 0, 3, 5, 1, 2),
          498 : (4, 0, 3, 5, 2, 1),
          499 : (4, 0, 5, 1, 2, 3),
          500 : (4, 0, 5, 1, 3, 2),
          501 : (4, 0, 5, 2, 1, 3),
          502 : (4, 0, 5, 2, 3, 1),
          503 : (4, 0, 5, 3, 1, 2),
          504 : (4, 0, 5, 3, 2, 1),
          505 : (4, 1, 0, 2, 3, 5),
          506 : (4, 1, 0, 2, 5, 3),
          507 : (4, 1, 0, 3, 2, 5),
          508 : (4, 1, 0, 3, 5, 2),
          509 : (4, 1, 0, 5, 2, 3),
          510 : (4, 1, 0, 5, 3, 2),
          511 : (4, 1, 2, 0, 3, 5),
          512 : (4, 1, 2, 0, 5, 3),
          513 : (4, 1, 2, 3, 0, 5),
          514 : (4, 1, 2, 3, 5, 0),
          515 : (4, 1, 2, 5, 0, 3),
          516 : (4, 1, 2, 5, 3, 0),
          517 : (4, 1, 3, 0, 2, 5),
          518 : (4, 1, 3, 0, 5, 2),
          519 : (4, 1, 3, 2, 0, 5),
          520 : (4, 1, 3, 2, 5, 0),
          521 : (4, 1, 3, 5, 0, 2),
          522 : (4, 1, 3, 5, 2, 0),
          523 : (4, 1, 5, 0, 2, 3),
          524 : (4, 1, 5, 0, 3, 2),
          525 : (4, 1, 5, 2, 0, 3),
          526 : (4, 1, 5, 2, 3, 0),
          527 : (4, 1, 5, 3, 0, 2),
          528 : (4, 1, 5, 3, 2, 0),
          529 : (4, 2, 0, 1, 3, 5),
          530 : (4, 2, 0, 1, 5, 3),
          531 : (4, 2, 0, 3, 1, 5),
          532 : (4, 2, 0, 3, 5, 1),
          533 : (4, 2, 0, 5, 1, 3),
          534 : (4, 2, 0, 5, 3, 1),
          535 : (4, 2, 1, 0, 3, 5),
          536 : (4, 2, 1, 0, 5, 3),
          537 : (4, 2, 1, 3, 0, 5),
          538 : (4, 2, 1, 3, 5, 0),
          539 : (4, 2, 1, 5, 0, 3),
          540 : (4, 2, 1, 5, 3, 0),
          541 : (4, 2, 3, 0, 1, 5),
          542 : (4, 2, 3, 0, 5, 1),
          543 : (4, 2, 3, 1, 0, 5),
          544 : (4, 2, 3, 1, 5, 0),
          545 : (4, 2, 3, 5, 0, 1),
          546 : (4, 2, 3, 5, 1, 0),
          547 : (4, 2, 5, 0, 1, 3),
          548 : (4, 2, 5, 0, 3, 1),
          549 : (4, 2, 5, 1, 0, 3),
          550 : (4, 2, 5, 1, 3, 0),
          551 : (4, 2, 5, 3, 0, 1),
          552 : (4, 2, 5, 3, 1, 0),
          553 : (4, 3, 0, 1, 2, 5),
          554 : (4, 3, 0, 1, 5, 2),
          555 : (4, 3, 0, 2, 1, 5),
          556 : (4, 3, 0, 2, 5, 1),
          557 : (4, 3, 0, 5, 1, 2),
          558 : (4, 3, 0, 5, 2, 1),
          559 : (4, 3, 1, 0, 2, 5),
          560 : (4, 3, 1, 0, 5, 2),
          561 : (4, 3, 1, 2, 0, 5),
          562 : (4, 3, 1, 2, 5, 0),
          563 : (4, 3, 1, 5, 0, 2),
          564 : (4, 3, 1, 5, 2, 0),
          565 : (4, 3, 2, 0, 1, 5),
          566 : (4, 3, 2, 0, 5, 1),
          567 : (4, 3, 2, 1, 0, 5),
          568 : (4, 3, 2, 1, 5, 0),
          569 : (4, 3, 2, 5, 0, 1),
          570 : (4, 3, 2, 5, 1, 0),
          571 : (4, 3, 5, 0, 1, 2),
          572 : (4, 3, 5, 0, 2, 1),
          573 : (4, 3, 5, 1, 0, 2),
          574 : (4, 3, 5, 1, 2, 0),
          575 : (4, 3, 5, 2, 0, 1),
          576 : (4, 3, 5, 2, 1, 0),
          577 : (4, 5, 0, 1, 2, 3),
          578 : (4, 5, 0, 1, 3, 2),
          579 : (4, 5, 0, 2, 1, 3),
          580 : (4, 5, 0, 2, 3, 1),
          581 : (4, 5, 0, 3, 1, 2),
          582 : (4, 5, 0, 3, 2, 1),
          583 : (4, 5, 1, 0, 2, 3),
          584 : (4, 5, 1, 0, 3, 2),
          585 : (4, 5, 1, 2, 0, 3),
          586 : (4, 5, 1, 2, 3, 0),
          587 : (4, 5, 1, 3, 0, 2),
          588 : (4, 5, 1, 3, 2, 0),
          589 : (4, 5, 2, 0, 1, 3),
          590 : (4, 5, 2, 0, 3, 1),
          591 : (4, 5, 2, 1, 0, 3),
          592 : (4, 5, 2, 1, 3, 0),
          593 : (4, 5, 2, 3, 0, 1),
          594 : (4, 5, 2, 3, 1, 0),
          595 : (4, 5, 3, 0, 1, 2),
          596 : (4, 5, 3, 0, 2, 1),
          597 : (4, 5, 3, 1, 0, 2),
          598 : (4, 5, 3, 1, 2, 0),
          599 : (4, 5, 3, 2, 0, 1),
          600 : (4, 5, 3, 2, 1, 0),
          601 : (5, 0, 1, 2, 3, 4),
          602 : (5, 0, 1, 2, 4, 3),
          603 : (5, 0, 1, 3, 2, 4),
          604 : (5, 0, 1, 3, 4, 2),
          605 : (5, 0, 1, 4, 2, 3),
          606 : (5, 0, 1, 4, 3, 2),
          607 : (5, 0, 2, 1, 3, 4),
          608 : (5, 0, 2, 1, 4, 3),
          609 : (5, 0, 2, 3, 1, 4),
          610 : (5, 0, 2, 3, 4, 1),
          611 : (5, 0, 2, 4, 1, 3),
          612 : (5, 0, 2, 4, 3, 1),
          613 : (5, 0, 3, 1, 2, 4),
          614 : (5, 0, 3, 1, 4, 2),
          615 : (5, 0, 3, 2, 1, 4),
          616 : (5, 0, 3, 2, 4, 1),
          617 : (5, 0, 3, 4, 1, 2),
          618 : (5, 0, 3, 4, 2, 1),
          619 : (5, 0, 4, 1, 2, 3),
          620 : (5, 0, 4, 1, 3, 2),
          621 : (5, 0, 4, 2, 1, 3),
          622 : (5, 0, 4, 2, 3, 1),
          623 : (5, 0, 4, 3, 1, 2),
          624 : (5, 0, 4, 3, 2, 1),
          625 : (5, 1, 0, 2, 3, 4),
          626 : (5, 1, 0, 2, 4, 3),
          627 : (5, 1, 0, 3, 2, 4),
          628 : (5, 1, 0, 3, 4, 2),
          629 : (5, 1, 0, 4, 2, 3),
          630 : (5, 1, 0, 4, 3, 2),
          631 : (5, 1, 2, 0, 3, 4),
          632 : (5, 1, 2, 0, 4, 3),
          633 : (5, 1, 2, 3, 0, 4),
          634 : (5, 1, 2, 3, 4, 0),
          635 : (5, 1, 2, 4, 0, 3),
          636 : (5, 1, 2, 4, 3, 0),
          637 : (5, 1, 3, 0, 2, 4),
          638 : (5, 1, 3, 0, 4, 2),
          639 : (5, 1, 3, 2, 0, 4),
          640 : (5, 1, 3, 2, 4, 0),
          641 : (5, 1, 3, 4, 0, 2),
          642 : (5, 1, 3, 4, 2, 0),
          643 : (5, 1, 4, 0, 2, 3),
          644 : (5, 1, 4, 0, 3, 2),
          645 : (5, 1, 4, 2, 0, 3),
          646 : (5, 1, 4, 2, 3, 0),
          647 : (5, 1, 4, 3, 0, 2),
          648 : (5, 1, 4, 3, 2, 0),
          649 : (5, 2, 0, 1, 3, 4),
          650 : (5, 2, 0, 1, 4, 3),
          651 : (5, 2, 0, 3, 1, 4),
          652 : (5, 2, 0, 3, 4, 1),
          653 : (5, 2, 0, 4, 1, 3),
          654 : (5, 2, 0, 4, 3, 1),
          655 : (5, 2, 1, 0, 3, 4),
          656 : (5, 2, 1, 0, 4, 3),
          657 : (5, 2, 1, 3, 0, 4),
          658 : (5, 2, 1, 3, 4, 0),
          659 : (5, 2, 1, 4, 0, 3),
          660 : (5, 2, 1, 4, 3, 0),
          661 : (5, 2, 3, 0, 1, 4),
          662 : (5, 2, 3, 0, 4, 1),
          663 : (5, 2, 3, 1, 0, 4),
          664 : (5, 2, 3, 1, 4, 0),
          665 : (5, 2, 3, 4, 0, 1),
          666 : (5, 2, 3, 4, 1, 0),
          667 : (5, 2, 4, 0, 1, 3),
          668 : (5, 2, 4, 0, 3, 1),
          669 : (5, 2, 4, 1, 0, 3),
          670 : (5, 2, 4, 1, 3, 0),
          671 : (5, 2, 4, 3, 0, 1),
          672 : (5, 2, 4, 3, 1, 0),
          673 : (5, 3, 0, 1, 2, 4),
          674 : (5, 3, 0, 1, 4, 2),
          675 : (5, 3, 0, 2, 1, 4),
          676 : (5, 3, 0, 2, 4, 1),
          677 : (5, 3, 0, 4, 1, 2),
          678 : (5, 3, 0, 4, 2, 1),
          679 : (5, 3, 1, 0, 2, 4),
          680 : (5, 3, 1, 0, 4, 2),
          681 : (5, 3, 1, 2, 0, 4),
          682 : (5, 3, 1, 2, 4, 0),
          683 : (5, 3, 1, 4, 0, 2),
          684 : (5, 3, 1, 4, 2, 0),
          685 : (5, 3, 2, 0, 1, 4),
          686 : (5, 3, 2, 0, 4, 1),
          687 : (5, 3, 2, 1, 0, 4),
          688 : (5, 3, 2, 1, 4, 0),
          689 : (5, 3, 2, 4, 0, 1),
          690 : (5, 3, 2, 4, 1, 0),
          691 : (5, 3, 4, 0, 1, 2),
          692 : (5, 3, 4, 0, 2, 1),
          693 : (5, 3, 4, 1, 0, 2),
          694 : (5, 3, 4, 1, 2, 0),
          695 : (5, 3, 4, 2, 0, 1),
          696 : (5, 3, 4, 2, 1, 0),
          697 : (5, 4, 0, 1, 2, 3),
          698 : (5, 4, 0, 1, 3, 2),
          699 : (5, 4, 0, 2, 1, 3),
          700 : (5, 4, 0, 2, 3, 1),
          701 : (5, 4, 0, 3, 1, 2),
          702 : (5, 4, 0, 3, 2, 1),
          703 : (5, 4, 1, 0, 2, 3),
          704 : (5, 4, 1, 0, 3, 2),
          705 : (5, 4, 1, 2, 0, 3),
          706 : (5, 4, 1, 2, 3, 0),
          707 : (5, 4, 1, 3, 0, 2),
          708 : (5, 4, 1, 3, 2, 0),
          709 : (5, 4, 2, 0, 1, 3),
          710 : (5, 4, 2, 0, 3, 1),
          711 : (5, 4, 2, 1, 0, 3),
          712 : (5, 4, 2, 1, 3, 0),
          713 : (5, 4, 2, 3, 0, 1),
          714 : (5, 4, 2, 3, 1, 0),
          715 : (5, 4, 3, 0, 1, 2),
          716 : (5, 4, 3, 0, 2, 1),
          717 : (5, 4, 3, 1, 0, 2),
          718 : (5, 4, 3, 1, 2, 0),
          719 : (5, 4, 3, 2, 0, 1),
          720 : (5, 4, 3, 2, 1, 0)}

map_6_5 ={ 1 : (0, 0, 1, 2, 3, 4),
           2 : (0, 0, 1, 2, 4, 3),
           3 : (0, 0, 1, 3, 2, 4),
           4 : (0, 0, 1, 3, 4, 2),
           5 : (0, 0, 1, 4, 2, 3),
           6 : (0, 0, 1, 4, 3, 2),
           7 : (0, 0, 2, 1, 3, 4),
           8 : (0, 0, 2, 1, 4, 3),
           9 : (0, 0, 2, 3, 1, 4),
          10 : (0, 0, 2, 3, 4, 1),
          11 : (0, 0, 2, 4, 1, 3),
          12 : (0, 0, 2, 4, 3, 1),
          13 : (0, 0, 3, 1, 2, 4),
          14 : (0, 0, 3, 1, 4, 2),
          15 : (0, 0, 3, 2, 1, 4),
          16 : (0, 0, 3, 2, 4, 1),
          17 : (0, 0, 3, 4, 1, 2),
          18 : (0, 0, 3, 4, 2, 1),
          19 : (0, 0, 4, 1, 2, 3),
          20 : (0, 0, 4, 1, 3, 2),
          21 : (0, 0, 4, 2, 1, 3),
          22 : (0, 0, 4, 2, 3, 1),
          23 : (0, 0, 4, 3, 1, 2),
          24 : (0, 0, 4, 3, 2, 1),
          25 : (0, 1, 0, 2, 3, 4),
          26 : (0, 1, 0, 2, 4, 3),
          27 : (0, 1, 0, 3, 2, 4),
          28 : (0, 1, 0, 3, 4, 2),
          29 : (0, 1, 0, 4, 2, 3),
          30 : (0, 1, 0, 4, 3, 2),
          31 : (0, 1, 1, 2, 3, 4),
          32 : (0, 1, 1, 2, 4, 3),
          33 : (0, 1, 1, 3, 2, 4),
          34 : (0, 1, 1, 3, 4, 2),
          35 : (0, 1, 1, 4, 2, 3),
          36 : (0, 1, 1, 4, 3, 2),
          37 : (0, 1, 2, 0, 3, 4),
          38 : (0, 1, 2, 0, 4, 3),
          39 : (0, 1, 2, 1, 3, 4),
          40 : (0, 1, 2, 1, 4, 3),
          41 : (0, 1, 2, 2, 3, 4),
          42 : (0, 1, 2, 2, 4, 3),
          43 : (0, 1, 2, 3, 0, 4),
          44 : (0, 1, 2, 3, 1, 4),
          45 : (0, 1, 2, 3, 2, 4),
          46 : (0, 1, 2, 3, 3, 4),
          47 : (0, 1, 2, 3, 4, 0),
          48 : (0, 1, 2, 3, 4, 1),
          49 : (0, 1, 2, 3, 4, 2),
          50 : (0, 1, 2, 3, 4, 3),
          51 : (0, 1, 2, 3, 4, 4),
          52 : (0, 1, 2, 4, 0, 3),
          53 : (0, 1, 2, 4, 1, 3),
          54 : (0, 1, 2, 4, 2, 3),
          55 : (0, 1, 2, 4, 3, 0),
          56 : (0, 1, 2, 4, 3, 1),
          57 : (0, 1, 2, 4, 3, 2),
          58 : (0, 1, 2, 4, 3, 3),
          59 : (0, 1, 2, 4, 3, 4),
          60 : (0, 1, 2, 4, 4, 3),
          61 : (0, 1, 3, 0, 2, 4),
          62 : (0, 1, 3, 0, 4, 2),
          63 : (0, 1, 3, 1, 2, 4),
          64 : (0, 1, 3, 1, 4, 2),
          65 : (0, 1, 3, 2, 0, 4),
          66 : (0, 1, 3, 2, 1, 4),
          67 : (0, 1, 3, 2, 2, 4),
          68 : (0, 1, 3, 2, 3, 4),
          69 : (0, 1, 3, 2, 4, 0),
          70 : (0, 1, 3, 2, 4, 1),
          71 : (0, 1, 3, 2, 4, 2),
          72 : (0, 1, 3, 2, 4, 3),
          73 : (0, 1, 3, 2, 4, 4),
          74 : (0, 1, 3, 3, 2, 4),
          75 : (0, 1, 3, 3, 4, 2),
          76 : (0, 1, 3, 4, 0, 2),
          77 : (0, 1, 3, 4, 1, 2),
          78 : (0, 1, 3, 4, 2, 0),
          79 : (0, 1, 3, 4, 2, 1),
          80 : (0, 1, 3, 4, 2, 2),
          81 : (0, 1, 3, 4, 2, 3),
          82 : (0, 1, 3, 4, 2, 4),
          83 : (0, 1, 3, 4, 3, 2),
          84 : (0, 1, 3, 4, 4, 2),
          85 : (0, 1, 4, 0, 2, 3),
          86 : (0, 1, 4, 0, 3, 2),
          87 : (0, 1, 4, 1, 2, 3),
          88 : (0, 1, 4, 1, 3, 2),
          89 : (0, 1, 4, 2, 0, 3),
          90 : (0, 1, 4, 2, 1, 3),
          91 : (0, 1, 4, 2, 2, 3),
          92 : (0, 1, 4, 2, 3, 0),
          93 : (0, 1, 4, 2, 3, 1),
          94 : (0, 1, 4, 2, 3, 2),
          95 : (0, 1, 4, 2, 3, 3),
          96 : (0, 1, 4, 2, 3, 4),
          97 : (0, 1, 4, 2, 4, 3),
          98 : (0, 1, 4, 3, 0, 2),
          99 : (0, 1, 4, 3, 1, 2),
          100 : (0, 1, 4, 3, 2, 0),
          101 : (0, 1, 4, 3, 2, 1),
          102 : (0, 1, 4, 3, 2, 2),
          103 : (0, 1, 4, 3, 2, 3),
          104 : (0, 1, 4, 3, 2, 4),
          105 : (0, 1, 4, 3, 3, 2),
          106 : (0, 1, 4, 3, 4, 2),
          107 : (0, 1, 4, 4, 2, 3),
          108 : (0, 1, 4, 4, 3, 2),
          109 : (0, 2, 0, 1, 3, 4),
          110 : (0, 2, 0, 1, 4, 3),
          111 : (0, 2, 0, 3, 1, 4),
          112 : (0, 2, 0, 3, 4, 1),
          113 : (0, 2, 0, 4, 1, 3),
          114 : (0, 2, 0, 4, 3, 1),
          115 : (0, 2, 1, 0, 3, 4),
          116 : (0, 2, 1, 0, 4, 3),
          117 : (0, 2, 1, 1, 3, 4),
          118 : (0, 2, 1, 1, 4, 3),
          119 : (0, 2, 1, 2, 3, 4),
          120 : (0, 2, 1, 2, 4, 3),
          121 : (0, 2, 1, 3, 0, 4),
          122 : (0, 2, 1, 3, 1, 4),
          123 : (0, 2, 1, 3, 2, 4),
          124 : (0, 2, 1, 3, 3, 4),
          125 : (0, 2, 1, 3, 4, 0),
          126 : (0, 2, 1, 3, 4, 1),
          127 : (0, 2, 1, 3, 4, 2),
          128 : (0, 2, 1, 3, 4, 3),
          129 : (0, 2, 1, 3, 4, 4),
          130 : (0, 2, 1, 4, 0, 3),
          131 : (0, 2, 1, 4, 1, 3),
          132 : (0, 2, 1, 4, 2, 3),
          133 : (0, 2, 1, 4, 3, 0),
          134 : (0, 2, 1, 4, 3, 1),
          135 : (0, 2, 1, 4, 3, 2),
          136 : (0, 2, 1, 4, 3, 3),
          137 : (0, 2, 1, 4, 3, 4),
          138 : (0, 2, 1, 4, 4, 3),
          139 : (0, 2, 2, 1, 3, 4),
          140 : (0, 2, 2, 1, 4, 3),
          141 : (0, 2, 2, 3, 1, 4),
          142 : (0, 2, 2, 3, 4, 1),
          143 : (0, 2, 2, 4, 1, 3),
          144 : (0, 2, 2, 4, 3, 1),
          145 : (0, 2, 3, 0, 1, 4),
          146 : (0, 2, 3, 0, 4, 1),
          147 : (0, 2, 3, 1, 0, 4),
          148 : (0, 2, 3, 1, 1, 4),
          149 : (0, 2, 3, 1, 2, 4),
          150 : (0, 2, 3, 1, 3, 4),
          151 : (0, 2, 3, 1, 4, 0),
          152 : (0, 2, 3, 1, 4, 1),
          153 : (0, 2, 3, 1, 4, 2),
          154 : (0, 2, 3, 1, 4, 3),
          155 : (0, 2, 3, 1, 4, 4),
          156 : (0, 2, 3, 2, 1, 4),
          157 : (0, 2, 3, 2, 4, 1),
          158 : (0, 2, 3, 3, 1, 4),
          159 : (0, 2, 3, 3, 4, 1),
          160 : (0, 2, 3, 4, 0, 1),
          161 : (0, 2, 3, 4, 1, 0),
          162 : (0, 2, 3, 4, 1, 1),
          163 : (0, 2, 3, 4, 1, 2),
          164 : (0, 2, 3, 4, 1, 3),
          165 : (0, 2, 3, 4, 1, 4),
          166 : (0, 2, 3, 4, 2, 1),
          167 : (0, 2, 3, 4, 3, 1),
          168 : (0, 2, 3, 4, 4, 1),
          169 : (0, 2, 4, 0, 1, 3),
          170 : (0, 2, 4, 0, 3, 1),
          171 : (0, 2, 4, 1, 0, 3),
          172 : (0, 2, 4, 1, 1, 3),
          173 : (0, 2, 4, 1, 2, 3),
          174 : (0, 2, 4, 1, 3, 0),
          175 : (0, 2, 4, 1, 3, 1),
          176 : (0, 2, 4, 1, 3, 2),
          177 : (0, 2, 4, 1, 3, 3),
          178 : (0, 2, 4, 1, 3, 4),
          179 : (0, 2, 4, 1, 4, 3),
          180 : (0, 2, 4, 2, 1, 3),
          181 : (0, 2, 4, 2, 3, 1),
          182 : (0, 2, 4, 3, 0, 1),
          183 : (0, 2, 4, 3, 1, 0),
          184 : (0, 2, 4, 3, 1, 1),
          185 : (0, 2, 4, 3, 1, 2),
          186 : (0, 2, 4, 3, 1, 3),
          187 : (0, 2, 4, 3, 1, 4),
          188 : (0, 2, 4, 3, 2, 1),
          189 : (0, 2, 4, 3, 3, 1),
          190 : (0, 2, 4, 3, 4, 1),
          191 : (0, 2, 4, 4, 1, 3),
          192 : (0, 2, 4, 4, 3, 1),
          193 : (0, 3, 0, 1, 2, 4),
          194 : (0, 3, 0, 1, 4, 2),
          195 : (0, 3, 0, 2, 1, 4),
          196 : (0, 3, 0, 2, 4, 1),
          197 : (0, 3, 0, 4, 1, 2),
          198 : (0, 3, 0, 4, 2, 1),
          199 : (0, 3, 1, 0, 2, 4),
          200 : (0, 3, 1, 0, 4, 2),
          201 : (0, 3, 1, 1, 2, 4),
          202 : (0, 3, 1, 1, 4, 2),
          203 : (0, 3, 1, 2, 0, 4),
          204 : (0, 3, 1, 2, 1, 4),
          205 : (0, 3, 1, 2, 2, 4),
          206 : (0, 3, 1, 2, 3, 4),
          207 : (0, 3, 1, 2, 4, 0),
          208 : (0, 3, 1, 2, 4, 1),
          209 : (0, 3, 1, 2, 4, 2),
          210 : (0, 3, 1, 2, 4, 3),
          211 : (0, 3, 1, 2, 4, 4),
          212 : (0, 3, 1, 3, 2, 4),
          213 : (0, 3, 1, 3, 4, 2),
          214 : (0, 3, 1, 4, 0, 2),
          215 : (0, 3, 1, 4, 1, 2),
          216 : (0, 3, 1, 4, 2, 0),
          217 : (0, 3, 1, 4, 2, 1),
          218 : (0, 3, 1, 4, 2, 2),
          219 : (0, 3, 1, 4, 2, 3),
          220 : (0, 3, 1, 4, 2, 4),
          221 : (0, 3, 1, 4, 3, 2),
          222 : (0, 3, 1, 4, 4, 2),
          223 : (0, 3, 2, 0, 1, 4),
          224 : (0, 3, 2, 0, 4, 1),
          225 : (0, 3, 2, 1, 0, 4),
          226 : (0, 3, 2, 1, 1, 4),
          227 : (0, 3, 2, 1, 2, 4),
          228 : (0, 3, 2, 1, 3, 4),
          229 : (0, 3, 2, 1, 4, 0),
          230 : (0, 3, 2, 1, 4, 1),
          231 : (0, 3, 2, 1, 4, 2),
          232 : (0, 3, 2, 1, 4, 3),
          233 : (0, 3, 2, 1, 4, 4),
          234 : (0, 3, 2, 2, 1, 4),
          235 : (0, 3, 2, 2, 4, 1),
          236 : (0, 3, 2, 3, 1, 4),
          237 : (0, 3, 2, 3, 4, 1),
          238 : (0, 3, 2, 4, 0, 1),
          239 : (0, 3, 2, 4, 1, 0),
          240 : (0, 3, 2, 4, 1, 1),
          241 : (0, 3, 2, 4, 1, 2),
          242 : (0, 3, 2, 4, 1, 3),
          243 : (0, 3, 2, 4, 1, 4),
          244 : (0, 3, 2, 4, 2, 1),
          245 : (0, 3, 2, 4, 3, 1),
          246 : (0, 3, 2, 4, 4, 1),
          247 : (0, 3, 3, 1, 2, 4),
          248 : (0, 3, 3, 1, 4, 2),
          249 : (0, 3, 3, 2, 1, 4),
          250 : (0, 3, 3, 2, 4, 1),
          251 : (0, 3, 3, 4, 1, 2),
          252 : (0, 3, 3, 4, 2, 1),
          253 : (0, 3, 4, 0, 1, 2),
          254 : (0, 3, 4, 0, 2, 1),
          255 : (0, 3, 4, 1, 0, 2),
          256 : (0, 3, 4, 1, 1, 2),
          257 : (0, 3, 4, 1, 2, 0),
          258 : (0, 3, 4, 1, 2, 1),
          259 : (0, 3, 4, 1, 2, 2),
          260 : (0, 3, 4, 1, 2, 3),
          261 : (0, 3, 4, 1, 2, 4),
          262 : (0, 3, 4, 1, 3, 2),
          263 : (0, 3, 4, 1, 4, 2),
          264 : (0, 3, 4, 2, 0, 1),
          265 : (0, 3, 4, 2, 1, 0),
          266 : (0, 3, 4, 2, 1, 1),
          267 : (0, 3, 4, 2, 1, 2),
          268 : (0, 3, 4, 2, 1, 3),
          269 : (0, 3, 4, 2, 1, 4),
          270 : (0, 3, 4, 2, 2, 1),
          271 : (0, 3, 4, 2, 3, 1),
          272 : (0, 3, 4, 2, 4, 1),
          273 : (0, 3, 4, 3, 1, 2),
          274 : (0, 3, 4, 3, 2, 1),
          275 : (0, 3, 4, 4, 1, 2),
          276 : (0, 3, 4, 4, 2, 1),
          277 : (0, 4, 0, 1, 2, 3),
          278 : (0, 4, 0, 1, 3, 2),
          279 : (0, 4, 0, 2, 1, 3),
          280 : (0, 4, 0, 2, 3, 1),
          281 : (0, 4, 0, 3, 1, 2),
          282 : (0, 4, 0, 3, 2, 1),
          283 : (0, 4, 1, 0, 2, 3),
          284 : (0, 4, 1, 0, 3, 2),
          285 : (0, 4, 1, 1, 2, 3),
          286 : (0, 4, 1, 1, 3, 2),
          287 : (0, 4, 1, 2, 0, 3),
          288 : (0, 4, 1, 2, 1, 3),
          289 : (0, 4, 1, 2, 2, 3),
          290 : (0, 4, 1, 2, 3, 0),
          291 : (0, 4, 1, 2, 3, 1),
          292 : (0, 4, 1, 2, 3, 2),
          293 : (0, 4, 1, 2, 3, 3),
          294 : (0, 4, 1, 2, 3, 4),
          295 : (0, 4, 1, 2, 4, 3),
          296 : (0, 4, 1, 3, 0, 2),
          297 : (0, 4, 1, 3, 1, 2),
          298 : (0, 4, 1, 3, 2, 0),
          299 : (0, 4, 1, 3, 2, 1),
          300 : (0, 4, 1, 3, 2, 2),
          301 : (0, 4, 1, 3, 2, 3),
          302 : (0, 4, 1, 3, 2, 4),
          303 : (0, 4, 1, 3, 3, 2),
          304 : (0, 4, 1, 3, 4, 2),
          305 : (0, 4, 1, 4, 2, 3),
          306 : (0, 4, 1, 4, 3, 2),
          307 : (0, 4, 2, 0, 1, 3),
          308 : (0, 4, 2, 0, 3, 1),
          309 : (0, 4, 2, 1, 0, 3),
          310 : (0, 4, 2, 1, 1, 3),
          311 : (0, 4, 2, 1, 2, 3),
          312 : (0, 4, 2, 1, 3, 0),
          313 : (0, 4, 2, 1, 3, 1),
          314 : (0, 4, 2, 1, 3, 2),
          315 : (0, 4, 2, 1, 3, 3),
          316 : (0, 4, 2, 1, 3, 4),
          317 : (0, 4, 2, 1, 4, 3),
          318 : (0, 4, 2, 2, 1, 3),
          319 : (0, 4, 2, 2, 3, 1),
          320 : (0, 4, 2, 3, 0, 1),
          321 : (0, 4, 2, 3, 1, 0),
          322 : (0, 4, 2, 3, 1, 1),
          323 : (0, 4, 2, 3, 1, 2),
          324 : (0, 4, 2, 3, 1, 3),
          325 : (0, 4, 2, 3, 1, 4),
          326 : (0, 4, 2, 3, 2, 1),
          327 : (0, 4, 2, 3, 3, 1),
          328 : (0, 4, 2, 3, 4, 1),
          329 : (0, 4, 2, 4, 1, 3),
          330 : (0, 4, 2, 4, 3, 1),
          331 : (0, 4, 3, 0, 1, 2),
          332 : (0, 4, 3, 0, 2, 1),
          333 : (0, 4, 3, 1, 0, 2),
          334 : (0, 4, 3, 1, 1, 2),
          335 : (0, 4, 3, 1, 2, 0),
          336 : (0, 4, 3, 1, 2, 1),
          337 : (0, 4, 3, 1, 2, 2),
          338 : (0, 4, 3, 1, 2, 3),
          339 : (0, 4, 3, 1, 2, 4),
          340 : (0, 4, 3, 1, 3, 2),
          341 : (0, 4, 3, 1, 4, 2),
          342 : (0, 4, 3, 2, 0, 1),
          343 : (0, 4, 3, 2, 1, 0),
          344 : (0, 4, 3, 2, 1, 1),
          345 : (0, 4, 3, 2, 1, 2),
          346 : (0, 4, 3, 2, 1, 3),
          347 : (0, 4, 3, 2, 1, 4),
          348 : (0, 4, 3, 2, 2, 1),
          349 : (0, 4, 3, 2, 3, 1),
          350 : (0, 4, 3, 2, 4, 1),
          351 : (0, 4, 3, 3, 1, 2),
          352 : (0, 4, 3, 3, 2, 1),
          353 : (0, 4, 3, 4, 1, 2),
          354 : (0, 4, 3, 4, 2, 1),
          355 : (0, 4, 4, 1, 2, 3),
          356 : (0, 4, 4, 1, 3, 2),
          357 : (0, 4, 4, 2, 1, 3),
          358 : (0, 4, 4, 2, 3, 1),
          359 : (0, 4, 4, 3, 1, 2),
          360 : (0, 4, 4, 3, 2, 1),
          361 : (1, 0, 0, 2, 3, 4),
          362 : (1, 0, 0, 2, 4, 3),
          363 : (1, 0, 0, 3, 2, 4),
          364 : (1, 0, 0, 3, 4, 2),
          365 : (1, 0, 0, 4, 2, 3),
          366 : (1, 0, 0, 4, 3, 2),
          367 : (1, 0, 1, 2, 3, 4),
          368 : (1, 0, 1, 2, 4, 3),
          369 : (1, 0, 1, 3, 2, 4),
          370 : (1, 0, 1, 3, 4, 2),
          371 : (1, 0, 1, 4, 2, 3),
          372 : (1, 0, 1, 4, 3, 2),
          373 : (1, 0, 2, 0, 3, 4),
          374 : (1, 0, 2, 0, 4, 3),
          375 : (1, 0, 2, 1, 3, 4),
          376 : (1, 0, 2, 1, 4, 3),
          377 : (1, 0, 2, 2, 3, 4),
          378 : (1, 0, 2, 2, 4, 3),
          379 : (1, 0, 2, 3, 0, 4),
          380 : (1, 0, 2, 3, 1, 4),
          381 : (1, 0, 2, 3, 2, 4),
          382 : (1, 0, 2, 3, 3, 4),
          383 : (1, 0, 2, 3, 4, 0),
          384 : (1, 0, 2, 3, 4, 1),
          385 : (1, 0, 2, 3, 4, 2),
          386 : (1, 0, 2, 3, 4, 3),
          387 : (1, 0, 2, 3, 4, 4),
          388 : (1, 0, 2, 4, 0, 3),
          389 : (1, 0, 2, 4, 1, 3),
          390 : (1, 0, 2, 4, 2, 3),
          391 : (1, 0, 2, 4, 3, 0),
          392 : (1, 0, 2, 4, 3, 1),
          393 : (1, 0, 2, 4, 3, 2),
          394 : (1, 0, 2, 4, 3, 3),
          395 : (1, 0, 2, 4, 3, 4),
          396 : (1, 0, 2, 4, 4, 3),
          397 : (1, 0, 3, 0, 2, 4),
          398 : (1, 0, 3, 0, 4, 2),
          399 : (1, 0, 3, 1, 2, 4),
          400 : (1, 0, 3, 1, 4, 2),
          401 : (1, 0, 3, 2, 0, 4),
          402 : (1, 0, 3, 2, 1, 4),
          403 : (1, 0, 3, 2, 2, 4),
          404 : (1, 0, 3, 2, 3, 4),
          405 : (1, 0, 3, 2, 4, 0),
          406 : (1, 0, 3, 2, 4, 1),
          407 : (1, 0, 3, 2, 4, 2),
          408 : (1, 0, 3, 2, 4, 3),
          409 : (1, 0, 3, 2, 4, 4),
          410 : (1, 0, 3, 3, 2, 4),
          411 : (1, 0, 3, 3, 4, 2),
          412 : (1, 0, 3, 4, 0, 2),
          413 : (1, 0, 3, 4, 1, 2),
          414 : (1, 0, 3, 4, 2, 0),
          415 : (1, 0, 3, 4, 2, 1),
          416 : (1, 0, 3, 4, 2, 2),
          417 : (1, 0, 3, 4, 2, 3),
          418 : (1, 0, 3, 4, 2, 4),
          419 : (1, 0, 3, 4, 3, 2),
          420 : (1, 0, 3, 4, 4, 2),
          421 : (1, 0, 4, 0, 2, 3),
          422 : (1, 0, 4, 0, 3, 2),
          423 : (1, 0, 4, 1, 2, 3),
          424 : (1, 0, 4, 1, 3, 2),
          425 : (1, 0, 4, 2, 0, 3),
          426 : (1, 0, 4, 2, 1, 3),
          427 : (1, 0, 4, 2, 2, 3),
          428 : (1, 0, 4, 2, 3, 0),
          429 : (1, 0, 4, 2, 3, 1),
          430 : (1, 0, 4, 2, 3, 2),
          431 : (1, 0, 4, 2, 3, 3),
          432 : (1, 0, 4, 2, 3, 4),
          433 : (1, 0, 4, 2, 4, 3),
          434 : (1, 0, 4, 3, 0, 2),
          435 : (1, 0, 4, 3, 1, 2),
          436 : (1, 0, 4, 3, 2, 0),
          437 : (1, 0, 4, 3, 2, 1),
          438 : (1, 0, 4, 3, 2, 2),
          439 : (1, 0, 4, 3, 2, 3),
          440 : (1, 0, 4, 3, 2, 4),
          441 : (1, 0, 4, 3, 3, 2),
          442 : (1, 0, 4, 3, 4, 2),
          443 : (1, 0, 4, 4, 2, 3),
          444 : (1, 0, 4, 4, 3, 2),
          445 : (1, 1, 0, 2, 3, 4),
          446 : (1, 1, 0, 2, 4, 3),
          447 : (1, 1, 0, 3, 2, 4),
          448 : (1, 1, 0, 3, 4, 2),
          449 : (1, 1, 0, 4, 2, 3),
          450 : (1, 1, 0, 4, 3, 2),
          451 : (1, 1, 2, 0, 3, 4),
          452 : (1, 1, 2, 0, 4, 3),
          453 : (1, 1, 2, 3, 0, 4),
          454 : (1, 1, 2, 3, 4, 0),
          455 : (1, 1, 2, 4, 0, 3),
          456 : (1, 1, 2, 4, 3, 0),
          457 : (1, 1, 3, 0, 2, 4),
          458 : (1, 1, 3, 0, 4, 2),
          459 : (1, 1, 3, 2, 0, 4),
          460 : (1, 1, 3, 2, 4, 0),
          461 : (1, 1, 3, 4, 0, 2),
          462 : (1, 1, 3, 4, 2, 0),
          463 : (1, 1, 4, 0, 2, 3),
          464 : (1, 1, 4, 0, 3, 2),
          465 : (1, 1, 4, 2, 0, 3),
          466 : (1, 1, 4, 2, 3, 0),
          467 : (1, 1, 4, 3, 0, 2),
          468 : (1, 1, 4, 3, 2, 0),
          469 : (1, 2, 0, 0, 3, 4),
          470 : (1, 2, 0, 0, 4, 3),
          471 : (1, 2, 0, 1, 3, 4),
          472 : (1, 2, 0, 1, 4, 3),
          473 : (1, 2, 0, 2, 3, 4),
          474 : (1, 2, 0, 2, 4, 3),
          475 : (1, 2, 0, 3, 0, 4),
          476 : (1, 2, 0, 3, 1, 4),
          477 : (1, 2, 0, 3, 2, 4),
          478 : (1, 2, 0, 3, 3, 4),
          479 : (1, 2, 0, 3, 4, 0),
          480 : (1, 2, 0, 3, 4, 1),
          481 : (1, 2, 0, 3, 4, 2),
          482 : (1, 2, 0, 3, 4, 3),
          483 : (1, 2, 0, 3, 4, 4),
          484 : (1, 2, 0, 4, 0, 3),
          485 : (1, 2, 0, 4, 1, 3),
          486 : (1, 2, 0, 4, 2, 3),
          487 : (1, 2, 0, 4, 3, 0),
          488 : (1, 2, 0, 4, 3, 1),
          489 : (1, 2, 0, 4, 3, 2),
          490 : (1, 2, 0, 4, 3, 3),
          491 : (1, 2, 0, 4, 3, 4),
          492 : (1, 2, 0, 4, 4, 3),
          493 : (1, 2, 1, 0, 3, 4),
          494 : (1, 2, 1, 0, 4, 3),
          495 : (1, 2, 1, 3, 0, 4),
          496 : (1, 2, 1, 3, 4, 0),
          497 : (1, 2, 1, 4, 0, 3),
          498 : (1, 2, 1, 4, 3, 0),
          499 : (1, 2, 2, 0, 3, 4),
          500 : (1, 2, 2, 0, 4, 3),
          501 : (1, 2, 2, 3, 0, 4),
          502 : (1, 2, 2, 3, 4, 0),
          503 : (1, 2, 2, 4, 0, 3),
          504 : (1, 2, 2, 4, 3, 0),
          505 : (1, 2, 3, 0, 0, 4),
          506 : (1, 2, 3, 0, 1, 4),
          507 : (1, 2, 3, 0, 2, 4),
          508 : (1, 2, 3, 0, 3, 4),
          509 : (1, 2, 3, 0, 4, 0),
          510 : (1, 2, 3, 0, 4, 1),
          511 : (1, 2, 3, 0, 4, 2),
          512 : (1, 2, 3, 0, 4, 3),
          513 : (1, 2, 3, 0, 4, 4),
          514 : (1, 2, 3, 1, 0, 4),
          515 : (1, 2, 3, 1, 4, 0),
          516 : (1, 2, 3, 2, 0, 4),
          517 : (1, 2, 3, 2, 4, 0),
          518 : (1, 2, 3, 3, 0, 4),
          519 : (1, 2, 3, 3, 4, 0),
          520 : (1, 2, 3, 4, 0, 0),
          521 : (1, 2, 3, 4, 0, 1),
          522 : (1, 2, 3, 4, 0, 2),
          523 : (1, 2, 3, 4, 0, 3),
          524 : (1, 2, 3, 4, 0, 4),
          525 : (1, 2, 3, 4, 1, 0),
          526 : (1, 2, 3, 4, 2, 0),
          527 : (1, 2, 3, 4, 3, 0),
          528 : (1, 2, 3, 4, 4, 0),
          529 : (1, 2, 4, 0, 0, 3),
          530 : (1, 2, 4, 0, 1, 3),
          531 : (1, 2, 4, 0, 2, 3),
          532 : (1, 2, 4, 0, 3, 0),
          533 : (1, 2, 4, 0, 3, 1),
          534 : (1, 2, 4, 0, 3, 2),
          535 : (1, 2, 4, 0, 3, 3),
          536 : (1, 2, 4, 0, 3, 4),
          537 : (1, 2, 4, 0, 4, 3),
          538 : (1, 2, 4, 1, 0, 3),
          539 : (1, 2, 4, 1, 3, 0),
          540 : (1, 2, 4, 2, 0, 3),
          541 : (1, 2, 4, 2, 3, 0),
          542 : (1, 2, 4, 3, 0, 0),
          543 : (1, 2, 4, 3, 0, 1),
          544 : (1, 2, 4, 3, 0, 2),
          545 : (1, 2, 4, 3, 0, 3),
          546 : (1, 2, 4, 3, 0, 4),
          547 : (1, 2, 4, 3, 1, 0),
          548 : (1, 2, 4, 3, 2, 0),
          549 : (1, 2, 4, 3, 3, 0),
          550 : (1, 2, 4, 3, 4, 0),
          551 : (1, 2, 4, 4, 0, 3),
          552 : (1, 2, 4, 4, 3, 0),
          553 : (1, 3, 0, 0, 2, 4),
          554 : (1, 3, 0, 0, 4, 2),
          555 : (1, 3, 0, 1, 2, 4),
          556 : (1, 3, 0, 1, 4, 2),
          557 : (1, 3, 0, 2, 0, 4),
          558 : (1, 3, 0, 2, 1, 4),
          559 : (1, 3, 0, 2, 2, 4),
          560 : (1, 3, 0, 2, 3, 4),
          561 : (1, 3, 0, 2, 4, 0),
          562 : (1, 3, 0, 2, 4, 1),
          563 : (1, 3, 0, 2, 4, 2),
          564 : (1, 3, 0, 2, 4, 3),
          565 : (1, 3, 0, 2, 4, 4),
          566 : (1, 3, 0, 3, 2, 4),
          567 : (1, 3, 0, 3, 4, 2),
          568 : (1, 3, 0, 4, 0, 2),
          569 : (1, 3, 0, 4, 1, 2),
          570 : (1, 3, 0, 4, 2, 0),
          571 : (1, 3, 0, 4, 2, 1),
          572 : (1, 3, 0, 4, 2, 2),
          573 : (1, 3, 0, 4, 2, 3),
          574 : (1, 3, 0, 4, 2, 4),
          575 : (1, 3, 0, 4, 3, 2),
          576 : (1, 3, 0, 4, 4, 2),
          577 : (1, 3, 1, 0, 2, 4),
          578 : (1, 3, 1, 0, 4, 2),
          579 : (1, 3, 1, 2, 0, 4),
          580 : (1, 3, 1, 2, 4, 0),
          581 : (1, 3, 1, 4, 0, 2),
          582 : (1, 3, 1, 4, 2, 0),
          583 : (1, 3, 2, 0, 0, 4),
          584 : (1, 3, 2, 0, 1, 4),
          585 : (1, 3, 2, 0, 2, 4),
          586 : (1, 3, 2, 0, 3, 4),
          587 : (1, 3, 2, 0, 4, 0),
          588 : (1, 3, 2, 0, 4, 1),
          589 : (1, 3, 2, 0, 4, 2),
          590 : (1, 3, 2, 0, 4, 3),
          591 : (1, 3, 2, 0, 4, 4),
          592 : (1, 3, 2, 1, 0, 4),
          593 : (1, 3, 2, 1, 4, 0),
          594 : (1, 3, 2, 2, 0, 4),
          595 : (1, 3, 2, 2, 4, 0),
          596 : (1, 3, 2, 3, 0, 4),
          597 : (1, 3, 2, 3, 4, 0),
          598 : (1, 3, 2, 4, 0, 0),
          599 : (1, 3, 2, 4, 0, 1),
          600 : (1, 3, 2, 4, 0, 2),
          601 : (1, 3, 2, 4, 0, 3),
          602 : (1, 3, 2, 4, 0, 4),
          603 : (1, 3, 2, 4, 1, 0),
          604 : (1, 3, 2, 4, 2, 0),
          605 : (1, 3, 2, 4, 3, 0),
          606 : (1, 3, 2, 4, 4, 0),
          607 : (1, 3, 3, 0, 2, 4),
          608 : (1, 3, 3, 0, 4, 2),
          609 : (1, 3, 3, 2, 0, 4),
          610 : (1, 3, 3, 2, 4, 0),
          611 : (1, 3, 3, 4, 0, 2),
          612 : (1, 3, 3, 4, 2, 0),
          613 : (1, 3, 4, 0, 0, 2),
          614 : (1, 3, 4, 0, 1, 2),
          615 : (1, 3, 4, 0, 2, 0),
          616 : (1, 3, 4, 0, 2, 1),
          617 : (1, 3, 4, 0, 2, 2),
          618 : (1, 3, 4, 0, 2, 3),
          619 : (1, 3, 4, 0, 2, 4),
          620 : (1, 3, 4, 0, 3, 2),
          621 : (1, 3, 4, 0, 4, 2),
          622 : (1, 3, 4, 1, 0, 2),
          623 : (1, 3, 4, 1, 2, 0),
          624 : (1, 3, 4, 2, 0, 0),
          625 : (1, 3, 4, 2, 0, 1),
          626 : (1, 3, 4, 2, 0, 2),
          627 : (1, 3, 4, 2, 0, 3),
          628 : (1, 3, 4, 2, 0, 4),
          629 : (1, 3, 4, 2, 1, 0),
          630 : (1, 3, 4, 2, 2, 0),
          631 : (1, 3, 4, 2, 3, 0),
          632 : (1, 3, 4, 2, 4, 0),
          633 : (1, 3, 4, 3, 0, 2),
          634 : (1, 3, 4, 3, 2, 0),
          635 : (1, 3, 4, 4, 0, 2),
          636 : (1, 3, 4, 4, 2, 0),
          637 : (1, 4, 0, 0, 2, 3),
          638 : (1, 4, 0, 0, 3, 2),
          639 : (1, 4, 0, 1, 2, 3),
          640 : (1, 4, 0, 1, 3, 2),
          641 : (1, 4, 0, 2, 0, 3),
          642 : (1, 4, 0, 2, 1, 3),
          643 : (1, 4, 0, 2, 2, 3),
          644 : (1, 4, 0, 2, 3, 0),
          645 : (1, 4, 0, 2, 3, 1),
          646 : (1, 4, 0, 2, 3, 2),
          647 : (1, 4, 0, 2, 3, 3),
          648 : (1, 4, 0, 2, 3, 4),
          649 : (1, 4, 0, 2, 4, 3),
          650 : (1, 4, 0, 3, 0, 2),
          651 : (1, 4, 0, 3, 1, 2),
          652 : (1, 4, 0, 3, 2, 0),
          653 : (1, 4, 0, 3, 2, 1),
          654 : (1, 4, 0, 3, 2, 2),
          655 : (1, 4, 0, 3, 2, 3),
          656 : (1, 4, 0, 3, 2, 4),
          657 : (1, 4, 0, 3, 3, 2),
          658 : (1, 4, 0, 3, 4, 2),
          659 : (1, 4, 0, 4, 2, 3),
          660 : (1, 4, 0, 4, 3, 2),
          661 : (1, 4, 1, 0, 2, 3),
          662 : (1, 4, 1, 0, 3, 2),
          663 : (1, 4, 1, 2, 0, 3),
          664 : (1, 4, 1, 2, 3, 0),
          665 : (1, 4, 1, 3, 0, 2),
          666 : (1, 4, 1, 3, 2, 0),
          667 : (1, 4, 2, 0, 0, 3),
          668 : (1, 4, 2, 0, 1, 3),
          669 : (1, 4, 2, 0, 2, 3),
          670 : (1, 4, 2, 0, 3, 0),
          671 : (1, 4, 2, 0, 3, 1),
          672 : (1, 4, 2, 0, 3, 2),
          673 : (1, 4, 2, 0, 3, 3),
          674 : (1, 4, 2, 0, 3, 4),
          675 : (1, 4, 2, 0, 4, 3),
          676 : (1, 4, 2, 1, 0, 3),
          677 : (1, 4, 2, 1, 3, 0),
          678 : (1, 4, 2, 2, 0, 3),
          679 : (1, 4, 2, 2, 3, 0),
          680 : (1, 4, 2, 3, 0, 0),
          681 : (1, 4, 2, 3, 0, 1),
          682 : (1, 4, 2, 3, 0, 2),
          683 : (1, 4, 2, 3, 0, 3),
          684 : (1, 4, 2, 3, 0, 4),
          685 : (1, 4, 2, 3, 1, 0),
          686 : (1, 4, 2, 3, 2, 0),
          687 : (1, 4, 2, 3, 3, 0),
          688 : (1, 4, 2, 3, 4, 0),
          689 : (1, 4, 2, 4, 0, 3),
          690 : (1, 4, 2, 4, 3, 0),
          691 : (1, 4, 3, 0, 0, 2),
          692 : (1, 4, 3, 0, 1, 2),
          693 : (1, 4, 3, 0, 2, 0),
          694 : (1, 4, 3, 0, 2, 1),
          695 : (1, 4, 3, 0, 2, 2),
          696 : (1, 4, 3, 0, 2, 3),
          697 : (1, 4, 3, 0, 2, 4),
          698 : (1, 4, 3, 0, 3, 2),
          699 : (1, 4, 3, 0, 4, 2),
          700 : (1, 4, 3, 1, 0, 2),
          701 : (1, 4, 3, 1, 2, 0),
          702 : (1, 4, 3, 2, 0, 0),
          703 : (1, 4, 3, 2, 0, 1),
          704 : (1, 4, 3, 2, 0, 2),
          705 : (1, 4, 3, 2, 0, 3),
          706 : (1, 4, 3, 2, 0, 4),
          707 : (1, 4, 3, 2, 1, 0),
          708 : (1, 4, 3, 2, 2, 0),
          709 : (1, 4, 3, 2, 3, 0),
          710 : (1, 4, 3, 2, 4, 0),
          711 : (1, 4, 3, 3, 0, 2),
          712 : (1, 4, 3, 3, 2, 0),
          713 : (1, 4, 3, 4, 0, 2),
          714 : (1, 4, 3, 4, 2, 0),
          715 : (1, 4, 4, 0, 2, 3),
          716 : (1, 4, 4, 0, 3, 2),
          717 : (1, 4, 4, 2, 0, 3),
          718 : (1, 4, 4, 2, 3, 0),
          719 : (1, 4, 4, 3, 0, 2),
          720 : (1, 4, 4, 3, 2, 0),
          721 : (2, 0, 0, 1, 3, 4),
          722 : (2, 0, 0, 1, 4, 3),
          723 : (2, 0, 0, 3, 1, 4),
          724 : (2, 0, 0, 3, 4, 1),
          725 : (2, 0, 0, 4, 1, 3),
          726 : (2, 0, 0, 4, 3, 1),
          727 : (2, 0, 1, 0, 3, 4),
          728 : (2, 0, 1, 0, 4, 3),
          729 : (2, 0, 1, 1, 3, 4),
          730 : (2, 0, 1, 1, 4, 3),
          731 : (2, 0, 1, 2, 3, 4),
          732 : (2, 0, 1, 2, 4, 3),
          733 : (2, 0, 1, 3, 0, 4),
          734 : (2, 0, 1, 3, 1, 4),
          735 : (2, 0, 1, 3, 2, 4),
          736 : (2, 0, 1, 3, 3, 4),
          737 : (2, 0, 1, 3, 4, 0),
          738 : (2, 0, 1, 3, 4, 1),
          739 : (2, 0, 1, 3, 4, 2),
          740 : (2, 0, 1, 3, 4, 3),
          741 : (2, 0, 1, 3, 4, 4),
          742 : (2, 0, 1, 4, 0, 3),
          743 : (2, 0, 1, 4, 1, 3),
          744 : (2, 0, 1, 4, 2, 3),
          745 : (2, 0, 1, 4, 3, 0),
          746 : (2, 0, 1, 4, 3, 1),
          747 : (2, 0, 1, 4, 3, 2),
          748 : (2, 0, 1, 4, 3, 3),
          749 : (2, 0, 1, 4, 3, 4),
          750 : (2, 0, 1, 4, 4, 3),
          751 : (2, 0, 2, 1, 3, 4),
          752 : (2, 0, 2, 1, 4, 3),
          753 : (2, 0, 2, 3, 1, 4),
          754 : (2, 0, 2, 3, 4, 1),
          755 : (2, 0, 2, 4, 1, 3),
          756 : (2, 0, 2, 4, 3, 1),
          757 : (2, 0, 3, 0, 1, 4),
          758 : (2, 0, 3, 0, 4, 1),
          759 : (2, 0, 3, 1, 0, 4),
          760 : (2, 0, 3, 1, 1, 4),
          761 : (2, 0, 3, 1, 2, 4),
          762 : (2, 0, 3, 1, 3, 4),
          763 : (2, 0, 3, 1, 4, 0),
          764 : (2, 0, 3, 1, 4, 1),
          765 : (2, 0, 3, 1, 4, 2),
          766 : (2, 0, 3, 1, 4, 3),
          767 : (2, 0, 3, 1, 4, 4),
          768 : (2, 0, 3, 2, 1, 4),
          769 : (2, 0, 3, 2, 4, 1),
          770 : (2, 0, 3, 3, 1, 4),
          771 : (2, 0, 3, 3, 4, 1),
          772 : (2, 0, 3, 4, 0, 1),
          773 : (2, 0, 3, 4, 1, 0),
          774 : (2, 0, 3, 4, 1, 1),
          775 : (2, 0, 3, 4, 1, 2),
          776 : (2, 0, 3, 4, 1, 3),
          777 : (2, 0, 3, 4, 1, 4),
          778 : (2, 0, 3, 4, 2, 1),
          779 : (2, 0, 3, 4, 3, 1),
          780 : (2, 0, 3, 4, 4, 1),
          781 : (2, 0, 4, 0, 1, 3),
          782 : (2, 0, 4, 0, 3, 1),
          783 : (2, 0, 4, 1, 0, 3),
          784 : (2, 0, 4, 1, 1, 3),
          785 : (2, 0, 4, 1, 2, 3),
          786 : (2, 0, 4, 1, 3, 0),
          787 : (2, 0, 4, 1, 3, 1),
          788 : (2, 0, 4, 1, 3, 2),
          789 : (2, 0, 4, 1, 3, 3),
          790 : (2, 0, 4, 1, 3, 4),
          791 : (2, 0, 4, 1, 4, 3),
          792 : (2, 0, 4, 2, 1, 3),
          793 : (2, 0, 4, 2, 3, 1),
          794 : (2, 0, 4, 3, 0, 1),
          795 : (2, 0, 4, 3, 1, 0),
          796 : (2, 0, 4, 3, 1, 1),
          797 : (2, 0, 4, 3, 1, 2),
          798 : (2, 0, 4, 3, 1, 3),
          799 : (2, 0, 4, 3, 1, 4),
          800 : (2, 0, 4, 3, 2, 1),
          801 : (2, 0, 4, 3, 3, 1),
          802 : (2, 0, 4, 3, 4, 1),
          803 : (2, 0, 4, 4, 1, 3),
          804 : (2, 0, 4, 4, 3, 1),
          805 : (2, 1, 0, 0, 3, 4),
          806 : (2, 1, 0, 0, 4, 3),
          807 : (2, 1, 0, 1, 3, 4),
          808 : (2, 1, 0, 1, 4, 3),
          809 : (2, 1, 0, 2, 3, 4),
          810 : (2, 1, 0, 2, 4, 3),
          811 : (2, 1, 0, 3, 0, 4),
          812 : (2, 1, 0, 3, 1, 4),
          813 : (2, 1, 0, 3, 2, 4),
          814 : (2, 1, 0, 3, 3, 4),
          815 : (2, 1, 0, 3, 4, 0),
          816 : (2, 1, 0, 3, 4, 1),
          817 : (2, 1, 0, 3, 4, 2),
          818 : (2, 1, 0, 3, 4, 3),
          819 : (2, 1, 0, 3, 4, 4),
          820 : (2, 1, 0, 4, 0, 3),
          821 : (2, 1, 0, 4, 1, 3),
          822 : (2, 1, 0, 4, 2, 3),
          823 : (2, 1, 0, 4, 3, 0),
          824 : (2, 1, 0, 4, 3, 1),
          825 : (2, 1, 0, 4, 3, 2),
          826 : (2, 1, 0, 4, 3, 3),
          827 : (2, 1, 0, 4, 3, 4),
          828 : (2, 1, 0, 4, 4, 3),
          829 : (2, 1, 1, 0, 3, 4),
          830 : (2, 1, 1, 0, 4, 3),
          831 : (2, 1, 1, 3, 0, 4),
          832 : (2, 1, 1, 3, 4, 0),
          833 : (2, 1, 1, 4, 0, 3),
          834 : (2, 1, 1, 4, 3, 0),
          835 : (2, 1, 2, 0, 3, 4),
          836 : (2, 1, 2, 0, 4, 3),
          837 : (2, 1, 2, 3, 0, 4),
          838 : (2, 1, 2, 3, 4, 0),
          839 : (2, 1, 2, 4, 0, 3),
          840 : (2, 1, 2, 4, 3, 0),
          841 : (2, 1, 3, 0, 0, 4),
          842 : (2, 1, 3, 0, 1, 4),
          843 : (2, 1, 3, 0, 2, 4),
          844 : (2, 1, 3, 0, 3, 4),
          845 : (2, 1, 3, 0, 4, 0),
          846 : (2, 1, 3, 0, 4, 1),
          847 : (2, 1, 3, 0, 4, 2),
          848 : (2, 1, 3, 0, 4, 3),
          849 : (2, 1, 3, 0, 4, 4),
          850 : (2, 1, 3, 1, 0, 4),
          851 : (2, 1, 3, 1, 4, 0),
          852 : (2, 1, 3, 2, 0, 4),
          853 : (2, 1, 3, 2, 4, 0),
          854 : (2, 1, 3, 3, 0, 4),
          855 : (2, 1, 3, 3, 4, 0),
          856 : (2, 1, 3, 4, 0, 0),
          857 : (2, 1, 3, 4, 0, 1),
          858 : (2, 1, 3, 4, 0, 2),
          859 : (2, 1, 3, 4, 0, 3),
          860 : (2, 1, 3, 4, 0, 4),
          861 : (2, 1, 3, 4, 1, 0),
          862 : (2, 1, 3, 4, 2, 0),
          863 : (2, 1, 3, 4, 3, 0),
          864 : (2, 1, 3, 4, 4, 0),
          865 : (2, 1, 4, 0, 0, 3),
          866 : (2, 1, 4, 0, 1, 3),
          867 : (2, 1, 4, 0, 2, 3),
          868 : (2, 1, 4, 0, 3, 0),
          869 : (2, 1, 4, 0, 3, 1),
          870 : (2, 1, 4, 0, 3, 2),
          871 : (2, 1, 4, 0, 3, 3),
          872 : (2, 1, 4, 0, 3, 4),
          873 : (2, 1, 4, 0, 4, 3),
          874 : (2, 1, 4, 1, 0, 3),
          875 : (2, 1, 4, 1, 3, 0),
          876 : (2, 1, 4, 2, 0, 3),
          877 : (2, 1, 4, 2, 3, 0),
          878 : (2, 1, 4, 3, 0, 0),
          879 : (2, 1, 4, 3, 0, 1),
          880 : (2, 1, 4, 3, 0, 2),
          881 : (2, 1, 4, 3, 0, 3),
          882 : (2, 1, 4, 3, 0, 4),
          883 : (2, 1, 4, 3, 1, 0),
          884 : (2, 1, 4, 3, 2, 0),
          885 : (2, 1, 4, 3, 3, 0),
          886 : (2, 1, 4, 3, 4, 0),
          887 : (2, 1, 4, 4, 0, 3),
          888 : (2, 1, 4, 4, 3, 0),
          889 : (2, 2, 0, 1, 3, 4),
          890 : (2, 2, 0, 1, 4, 3),
          891 : (2, 2, 0, 3, 1, 4),
          892 : (2, 2, 0, 3, 4, 1),
          893 : (2, 2, 0, 4, 1, 3),
          894 : (2, 2, 0, 4, 3, 1),
          895 : (2, 2, 1, 0, 3, 4),
          896 : (2, 2, 1, 0, 4, 3),
          897 : (2, 2, 1, 3, 0, 4),
          898 : (2, 2, 1, 3, 4, 0),
          899 : (2, 2, 1, 4, 0, 3),
          900 : (2, 2, 1, 4, 3, 0),
          901 : (2, 2, 3, 0, 1, 4),
          902 : (2, 2, 3, 0, 4, 1),
          903 : (2, 2, 3, 1, 0, 4),
          904 : (2, 2, 3, 1, 4, 0),
          905 : (2, 2, 3, 4, 0, 1),
          906 : (2, 2, 3, 4, 1, 0),
          907 : (2, 2, 4, 0, 1, 3),
          908 : (2, 2, 4, 0, 3, 1),
          909 : (2, 2, 4, 1, 0, 3),
          910 : (2, 2, 4, 1, 3, 0),
          911 : (2, 2, 4, 3, 0, 1),
          912 : (2, 2, 4, 3, 1, 0),
          913 : (2, 3, 0, 0, 1, 4),
          914 : (2, 3, 0, 0, 4, 1),
          915 : (2, 3, 0, 1, 0, 4),
          916 : (2, 3, 0, 1, 1, 4),
          917 : (2, 3, 0, 1, 2, 4),
          918 : (2, 3, 0, 1, 3, 4),
          919 : (2, 3, 0, 1, 4, 0),
          920 : (2, 3, 0, 1, 4, 1),
          921 : (2, 3, 0, 1, 4, 2),
          922 : (2, 3, 0, 1, 4, 3),
          923 : (2, 3, 0, 1, 4, 4),
          924 : (2, 3, 0, 2, 1, 4),
          925 : (2, 3, 0, 2, 4, 1),
          926 : (2, 3, 0, 3, 1, 4),
          927 : (2, 3, 0, 3, 4, 1),
          928 : (2, 3, 0, 4, 0, 1),
          929 : (2, 3, 0, 4, 1, 0),
          930 : (2, 3, 0, 4, 1, 1),
          931 : (2, 3, 0, 4, 1, 2),
          932 : (2, 3, 0, 4, 1, 3),
          933 : (2, 3, 0, 4, 1, 4),
          934 : (2, 3, 0, 4, 2, 1),
          935 : (2, 3, 0, 4, 3, 1),
          936 : (2, 3, 0, 4, 4, 1),
          937 : (2, 3, 1, 0, 0, 4),
          938 : (2, 3, 1, 0, 1, 4),
          939 : (2, 3, 1, 0, 2, 4),
          940 : (2, 3, 1, 0, 3, 4),
          941 : (2, 3, 1, 0, 4, 0),
          942 : (2, 3, 1, 0, 4, 1),
          943 : (2, 3, 1, 0, 4, 2),
          944 : (2, 3, 1, 0, 4, 3),
          945 : (2, 3, 1, 0, 4, 4),
          946 : (2, 3, 1, 1, 0, 4),
          947 : (2, 3, 1, 1, 4, 0),
          948 : (2, 3, 1, 2, 0, 4),
          949 : (2, 3, 1, 2, 4, 0),
          950 : (2, 3, 1, 3, 0, 4),
          951 : (2, 3, 1, 3, 4, 0),
          952 : (2, 3, 1, 4, 0, 0),
          953 : (2, 3, 1, 4, 0, 1),
          954 : (2, 3, 1, 4, 0, 2),
          955 : (2, 3, 1, 4, 0, 3),
          956 : (2, 3, 1, 4, 0, 4),
          957 : (2, 3, 1, 4, 1, 0),
          958 : (2, 3, 1, 4, 2, 0),
          959 : (2, 3, 1, 4, 3, 0),
          960 : (2, 3, 1, 4, 4, 0),
          961 : (2, 3, 2, 0, 1, 4),
          962 : (2, 3, 2, 0, 4, 1),
          963 : (2, 3, 2, 1, 0, 4),
          964 : (2, 3, 2, 1, 4, 0),
          965 : (2, 3, 2, 4, 0, 1),
          966 : (2, 3, 2, 4, 1, 0),
          967 : (2, 3, 3, 0, 1, 4),
          968 : (2, 3, 3, 0, 4, 1),
          969 : (2, 3, 3, 1, 0, 4),
          970 : (2, 3, 3, 1, 4, 0),
          971 : (2, 3, 3, 4, 0, 1),
          972 : (2, 3, 3, 4, 1, 0),
          973 : (2, 3, 4, 0, 0, 1),
          974 : (2, 3, 4, 0, 1, 0),
          975 : (2, 3, 4, 0, 1, 1),
          976 : (2, 3, 4, 0, 1, 2),
          977 : (2, 3, 4, 0, 1, 3),
          978 : (2, 3, 4, 0, 1, 4),
          979 : (2, 3, 4, 0, 2, 1),
          980 : (2, 3, 4, 0, 3, 1),
          981 : (2, 3, 4, 0, 4, 1),
          982 : (2, 3, 4, 1, 0, 0),
          983 : (2, 3, 4, 1, 0, 1),
          984 : (2, 3, 4, 1, 0, 2),
          985 : (2, 3, 4, 1, 0, 3),
          986 : (2, 3, 4, 1, 0, 4),
          987 : (2, 3, 4, 1, 1, 0),
          988 : (2, 3, 4, 1, 2, 0),
          989 : (2, 3, 4, 1, 3, 0),
          990 : (2, 3, 4, 1, 4, 0),
          991 : (2, 3, 4, 2, 0, 1),
          992 : (2, 3, 4, 2, 1, 0),
          993 : (2, 3, 4, 3, 0, 1),
          994 : (2, 3, 4, 3, 1, 0),
          995 : (2, 3, 4, 4, 0, 1),
          996 : (2, 3, 4, 4, 1, 0),
          997 : (2, 4, 0, 0, 1, 3),
          998 : (2, 4, 0, 0, 3, 1),
          999 : (2, 4, 0, 1, 0, 3),
          1000 : (2, 4, 0, 1, 1, 3),
          1001 : (2, 4, 0, 1, 2, 3),
          1002 : (2, 4, 0, 1, 3, 0),
          1003 : (2, 4, 0, 1, 3, 1),
          1004 : (2, 4, 0, 1, 3, 2),
          1005 : (2, 4, 0, 1, 3, 3),
          1006 : (2, 4, 0, 1, 3, 4),
          1007 : (2, 4, 0, 1, 4, 3),
          1008 : (2, 4, 0, 2, 1, 3),
          1009 : (2, 4, 0, 2, 3, 1),
          1010 : (2, 4, 0, 3, 0, 1),
          1011 : (2, 4, 0, 3, 1, 0),
          1012 : (2, 4, 0, 3, 1, 1),
          1013 : (2, 4, 0, 3, 1, 2),
          1014 : (2, 4, 0, 3, 1, 3),
          1015 : (2, 4, 0, 3, 1, 4),
          1016 : (2, 4, 0, 3, 2, 1),
          1017 : (2, 4, 0, 3, 3, 1),
          1018 : (2, 4, 0, 3, 4, 1),
          1019 : (2, 4, 0, 4, 1, 3),
          1020 : (2, 4, 0, 4, 3, 1),
          1021 : (2, 4, 1, 0, 0, 3),
          1022 : (2, 4, 1, 0, 1, 3),
          1023 : (2, 4, 1, 0, 2, 3),
          1024 : (2, 4, 1, 0, 3, 0),
          1025 : (2, 4, 1, 0, 3, 1),
          1026 : (2, 4, 1, 0, 3, 2),
          1027 : (2, 4, 1, 0, 3, 3),
          1028 : (2, 4, 1, 0, 3, 4),
          1029 : (2, 4, 1, 0, 4, 3),
          1030 : (2, 4, 1, 1, 0, 3),
          1031 : (2, 4, 1, 1, 3, 0),
          1032 : (2, 4, 1, 2, 0, 3),
          1033 : (2, 4, 1, 2, 3, 0),
          1034 : (2, 4, 1, 3, 0, 0),
          1035 : (2, 4, 1, 3, 0, 1),
          1036 : (2, 4, 1, 3, 0, 2),
          1037 : (2, 4, 1, 3, 0, 3),
          1038 : (2, 4, 1, 3, 0, 4),
          1039 : (2, 4, 1, 3, 1, 0),
          1040 : (2, 4, 1, 3, 2, 0),
          1041 : (2, 4, 1, 3, 3, 0),
          1042 : (2, 4, 1, 3, 4, 0),
          1043 : (2, 4, 1, 4, 0, 3),
          1044 : (2, 4, 1, 4, 3, 0),
          1045 : (2, 4, 2, 0, 1, 3),
          1046 : (2, 4, 2, 0, 3, 1),
          1047 : (2, 4, 2, 1, 0, 3),
          1048 : (2, 4, 2, 1, 3, 0),
          1049 : (2, 4, 2, 3, 0, 1),
          1050 : (2, 4, 2, 3, 1, 0),
          1051 : (2, 4, 3, 0, 0, 1),
          1052 : (2, 4, 3, 0, 1, 0),
          1053 : (2, 4, 3, 0, 1, 1),
          1054 : (2, 4, 3, 0, 1, 2),
          1055 : (2, 4, 3, 0, 1, 3),
          1056 : (2, 4, 3, 0, 1, 4),
          1057 : (2, 4, 3, 0, 2, 1),
          1058 : (2, 4, 3, 0, 3, 1),
          1059 : (2, 4, 3, 0, 4, 1),
          1060 : (2, 4, 3, 1, 0, 0),
          1061 : (2, 4, 3, 1, 0, 1),
          1062 : (2, 4, 3, 1, 0, 2),
          1063 : (2, 4, 3, 1, 0, 3),
          1064 : (2, 4, 3, 1, 0, 4),
          1065 : (2, 4, 3, 1, 1, 0),
          1066 : (2, 4, 3, 1, 2, 0),
          1067 : (2, 4, 3, 1, 3, 0),
          1068 : (2, 4, 3, 1, 4, 0),
          1069 : (2, 4, 3, 2, 0, 1),
          1070 : (2, 4, 3, 2, 1, 0),
          1071 : (2, 4, 3, 3, 0, 1),
          1072 : (2, 4, 3, 3, 1, 0),
          1073 : (2, 4, 3, 4, 0, 1),
          1074 : (2, 4, 3, 4, 1, 0),
          1075 : (2, 4, 4, 0, 1, 3),
          1076 : (2, 4, 4, 0, 3, 1),
          1077 : (2, 4, 4, 1, 0, 3),
          1078 : (2, 4, 4, 1, 3, 0),
          1079 : (2, 4, 4, 3, 0, 1),
          1080 : (2, 4, 4, 3, 1, 0),
          1081 : (3, 0, 0, 1, 2, 4),
          1082 : (3, 0, 0, 1, 4, 2),
          1083 : (3, 0, 0, 2, 1, 4),
          1084 : (3, 0, 0, 2, 4, 1),
          1085 : (3, 0, 0, 4, 1, 2),
          1086 : (3, 0, 0, 4, 2, 1),
          1087 : (3, 0, 1, 0, 2, 4),
          1088 : (3, 0, 1, 0, 4, 2),
          1089 : (3, 0, 1, 1, 2, 4),
          1090 : (3, 0, 1, 1, 4, 2),
          1091 : (3, 0, 1, 2, 0, 4),
          1092 : (3, 0, 1, 2, 1, 4),
          1093 : (3, 0, 1, 2, 2, 4),
          1094 : (3, 0, 1, 2, 3, 4),
          1095 : (3, 0, 1, 2, 4, 0),
          1096 : (3, 0, 1, 2, 4, 1),
          1097 : (3, 0, 1, 2, 4, 2),
          1098 : (3, 0, 1, 2, 4, 3),
          1099 : (3, 0, 1, 2, 4, 4),
          1100 : (3, 0, 1, 3, 2, 4),
          1101 : (3, 0, 1, 3, 4, 2),
          1102 : (3, 0, 1, 4, 0, 2),
          1103 : (3, 0, 1, 4, 1, 2),
          1104 : (3, 0, 1, 4, 2, 0),
          1105 : (3, 0, 1, 4, 2, 1),
          1106 : (3, 0, 1, 4, 2, 2),
          1107 : (3, 0, 1, 4, 2, 3),
          1108 : (3, 0, 1, 4, 2, 4),
          1109 : (3, 0, 1, 4, 3, 2),
          1110 : (3, 0, 1, 4, 4, 2),
          1111 : (3, 0, 2, 0, 1, 4),
          1112 : (3, 0, 2, 0, 4, 1),
          1113 : (3, 0, 2, 1, 0, 4),
          1114 : (3, 0, 2, 1, 1, 4),
          1115 : (3, 0, 2, 1, 2, 4),
          1116 : (3, 0, 2, 1, 3, 4),
          1117 : (3, 0, 2, 1, 4, 0),
          1118 : (3, 0, 2, 1, 4, 1),
          1119 : (3, 0, 2, 1, 4, 2),
          1120 : (3, 0, 2, 1, 4, 3),
          1121 : (3, 0, 2, 1, 4, 4),
          1122 : (3, 0, 2, 2, 1, 4),
          1123 : (3, 0, 2, 2, 4, 1),
          1124 : (3, 0, 2, 3, 1, 4),
          1125 : (3, 0, 2, 3, 4, 1),
          1126 : (3, 0, 2, 4, 0, 1),
          1127 : (3, 0, 2, 4, 1, 0),
          1128 : (3, 0, 2, 4, 1, 1),
          1129 : (3, 0, 2, 4, 1, 2),
          1130 : (3, 0, 2, 4, 1, 3),
          1131 : (3, 0, 2, 4, 1, 4),
          1132 : (3, 0, 2, 4, 2, 1),
          1133 : (3, 0, 2, 4, 3, 1),
          1134 : (3, 0, 2, 4, 4, 1),
          1135 : (3, 0, 3, 1, 2, 4),
          1136 : (3, 0, 3, 1, 4, 2),
          1137 : (3, 0, 3, 2, 1, 4),
          1138 : (3, 0, 3, 2, 4, 1),
          1139 : (3, 0, 3, 4, 1, 2),
          1140 : (3, 0, 3, 4, 2, 1),
          1141 : (3, 0, 4, 0, 1, 2),
          1142 : (3, 0, 4, 0, 2, 1),
          1143 : (3, 0, 4, 1, 0, 2),
          1144 : (3, 0, 4, 1, 1, 2),
          1145 : (3, 0, 4, 1, 2, 0),
          1146 : (3, 0, 4, 1, 2, 1),
          1147 : (3, 0, 4, 1, 2, 2),
          1148 : (3, 0, 4, 1, 2, 3),
          1149 : (3, 0, 4, 1, 2, 4),
          1150 : (3, 0, 4, 1, 3, 2),
          1151 : (3, 0, 4, 1, 4, 2),
          1152 : (3, 0, 4, 2, 0, 1),
          1153 : (3, 0, 4, 2, 1, 0),
          1154 : (3, 0, 4, 2, 1, 1),
          1155 : (3, 0, 4, 2, 1, 2),
          1156 : (3, 0, 4, 2, 1, 3),
          1157 : (3, 0, 4, 2, 1, 4),
          1158 : (3, 0, 4, 2, 2, 1),
          1159 : (3, 0, 4, 2, 3, 1),
          1160 : (3, 0, 4, 2, 4, 1),
          1161 : (3, 0, 4, 3, 1, 2),
          1162 : (3, 0, 4, 3, 2, 1),
          1163 : (3, 0, 4, 4, 1, 2),
          1164 : (3, 0, 4, 4, 2, 1),
          1165 : (3, 1, 0, 0, 2, 4),
          1166 : (3, 1, 0, 0, 4, 2),
          1167 : (3, 1, 0, 1, 2, 4),
          1168 : (3, 1, 0, 1, 4, 2),
          1169 : (3, 1, 0, 2, 0, 4),
          1170 : (3, 1, 0, 2, 1, 4),
          1171 : (3, 1, 0, 2, 2, 4),
          1172 : (3, 1, 0, 2, 3, 4),
          1173 : (3, 1, 0, 2, 4, 0),
          1174 : (3, 1, 0, 2, 4, 1),
          1175 : (3, 1, 0, 2, 4, 2),
          1176 : (3, 1, 0, 2, 4, 3),
          1177 : (3, 1, 0, 2, 4, 4),
          1178 : (3, 1, 0, 3, 2, 4),
          1179 : (3, 1, 0, 3, 4, 2),
          1180 : (3, 1, 0, 4, 0, 2),
          1181 : (3, 1, 0, 4, 1, 2),
          1182 : (3, 1, 0, 4, 2, 0),
          1183 : (3, 1, 0, 4, 2, 1),
          1184 : (3, 1, 0, 4, 2, 2),
          1185 : (3, 1, 0, 4, 2, 3),
          1186 : (3, 1, 0, 4, 2, 4),
          1187 : (3, 1, 0, 4, 3, 2),
          1188 : (3, 1, 0, 4, 4, 2),
          1189 : (3, 1, 1, 0, 2, 4),
          1190 : (3, 1, 1, 0, 4, 2),
          1191 : (3, 1, 1, 2, 0, 4),
          1192 : (3, 1, 1, 2, 4, 0),
          1193 : (3, 1, 1, 4, 0, 2),
          1194 : (3, 1, 1, 4, 2, 0),
          1195 : (3, 1, 2, 0, 0, 4),
          1196 : (3, 1, 2, 0, 1, 4),
          1197 : (3, 1, 2, 0, 2, 4),
          1198 : (3, 1, 2, 0, 3, 4),
          1199 : (3, 1, 2, 0, 4, 0),
          1200 : (3, 1, 2, 0, 4, 1),
          1201 : (3, 1, 2, 0, 4, 2),
          1202 : (3, 1, 2, 0, 4, 3),
          1203 : (3, 1, 2, 0, 4, 4),
          1204 : (3, 1, 2, 1, 0, 4),
          1205 : (3, 1, 2, 1, 4, 0),
          1206 : (3, 1, 2, 2, 0, 4),
          1207 : (3, 1, 2, 2, 4, 0),
          1208 : (3, 1, 2, 3, 0, 4),
          1209 : (3, 1, 2, 3, 4, 0),
          1210 : (3, 1, 2, 4, 0, 0),
          1211 : (3, 1, 2, 4, 0, 1),
          1212 : (3, 1, 2, 4, 0, 2),
          1213 : (3, 1, 2, 4, 0, 3),
          1214 : (3, 1, 2, 4, 0, 4),
          1215 : (3, 1, 2, 4, 1, 0),
          1216 : (3, 1, 2, 4, 2, 0),
          1217 : (3, 1, 2, 4, 3, 0),
          1218 : (3, 1, 2, 4, 4, 0),
          1219 : (3, 1, 3, 0, 2, 4),
          1220 : (3, 1, 3, 0, 4, 2),
          1221 : (3, 1, 3, 2, 0, 4),
          1222 : (3, 1, 3, 2, 4, 0),
          1223 : (3, 1, 3, 4, 0, 2),
          1224 : (3, 1, 3, 4, 2, 0),
          1225 : (3, 1, 4, 0, 0, 2),
          1226 : (3, 1, 4, 0, 1, 2),
          1227 : (3, 1, 4, 0, 2, 0),
          1228 : (3, 1, 4, 0, 2, 1),
          1229 : (3, 1, 4, 0, 2, 2),
          1230 : (3, 1, 4, 0, 2, 3),
          1231 : (3, 1, 4, 0, 2, 4),
          1232 : (3, 1, 4, 0, 3, 2),
          1233 : (3, 1, 4, 0, 4, 2),
          1234 : (3, 1, 4, 1, 0, 2),
          1235 : (3, 1, 4, 1, 2, 0),
          1236 : (3, 1, 4, 2, 0, 0),
          1237 : (3, 1, 4, 2, 0, 1),
          1238 : (3, 1, 4, 2, 0, 2),
          1239 : (3, 1, 4, 2, 0, 3),
          1240 : (3, 1, 4, 2, 0, 4),
          1241 : (3, 1, 4, 2, 1, 0),
          1242 : (3, 1, 4, 2, 2, 0),
          1243 : (3, 1, 4, 2, 3, 0),
          1244 : (3, 1, 4, 2, 4, 0),
          1245 : (3, 1, 4, 3, 0, 2),
          1246 : (3, 1, 4, 3, 2, 0),
          1247 : (3, 1, 4, 4, 0, 2),
          1248 : (3, 1, 4, 4, 2, 0),
          1249 : (3, 2, 0, 0, 1, 4),
          1250 : (3, 2, 0, 0, 4, 1),
          1251 : (3, 2, 0, 1, 0, 4),
          1252 : (3, 2, 0, 1, 1, 4),
          1253 : (3, 2, 0, 1, 2, 4),
          1254 : (3, 2, 0, 1, 3, 4),
          1255 : (3, 2, 0, 1, 4, 0),
          1256 : (3, 2, 0, 1, 4, 1),
          1257 : (3, 2, 0, 1, 4, 2),
          1258 : (3, 2, 0, 1, 4, 3),
          1259 : (3, 2, 0, 1, 4, 4),
          1260 : (3, 2, 0, 2, 1, 4),
          1261 : (3, 2, 0, 2, 4, 1),
          1262 : (3, 2, 0, 3, 1, 4),
          1263 : (3, 2, 0, 3, 4, 1),
          1264 : (3, 2, 0, 4, 0, 1),
          1265 : (3, 2, 0, 4, 1, 0),
          1266 : (3, 2, 0, 4, 1, 1),
          1267 : (3, 2, 0, 4, 1, 2),
          1268 : (3, 2, 0, 4, 1, 3),
          1269 : (3, 2, 0, 4, 1, 4),
          1270 : (3, 2, 0, 4, 2, 1),
          1271 : (3, 2, 0, 4, 3, 1),
          1272 : (3, 2, 0, 4, 4, 1),
          1273 : (3, 2, 1, 0, 0, 4),
          1274 : (3, 2, 1, 0, 1, 4),
          1275 : (3, 2, 1, 0, 2, 4),
          1276 : (3, 2, 1, 0, 3, 4),
          1277 : (3, 2, 1, 0, 4, 0),
          1278 : (3, 2, 1, 0, 4, 1),
          1279 : (3, 2, 1, 0, 4, 2),
          1280 : (3, 2, 1, 0, 4, 3),
          1281 : (3, 2, 1, 0, 4, 4),
          1282 : (3, 2, 1, 1, 0, 4),
          1283 : (3, 2, 1, 1, 4, 0),
          1284 : (3, 2, 1, 2, 0, 4),
          1285 : (3, 2, 1, 2, 4, 0),
          1286 : (3, 2, 1, 3, 0, 4),
          1287 : (3, 2, 1, 3, 4, 0),
          1288 : (3, 2, 1, 4, 0, 0),
          1289 : (3, 2, 1, 4, 0, 1),
          1290 : (3, 2, 1, 4, 0, 2),
          1291 : (3, 2, 1, 4, 0, 3),
          1292 : (3, 2, 1, 4, 0, 4),
          1293 : (3, 2, 1, 4, 1, 0),
          1294 : (3, 2, 1, 4, 2, 0),
          1295 : (3, 2, 1, 4, 3, 0),
          1296 : (3, 2, 1, 4, 4, 0),
          1297 : (3, 2, 2, 0, 1, 4),
          1298 : (3, 2, 2, 0, 4, 1),
          1299 : (3, 2, 2, 1, 0, 4),
          1300 : (3, 2, 2, 1, 4, 0),
          1301 : (3, 2, 2, 4, 0, 1),
          1302 : (3, 2, 2, 4, 1, 0),
          1303 : (3, 2, 3, 0, 1, 4),
          1304 : (3, 2, 3, 0, 4, 1),
          1305 : (3, 2, 3, 1, 0, 4),
          1306 : (3, 2, 3, 1, 4, 0),
          1307 : (3, 2, 3, 4, 0, 1),
          1308 : (3, 2, 3, 4, 1, 0),
          1309 : (3, 2, 4, 0, 0, 1),
          1310 : (3, 2, 4, 0, 1, 0),
          1311 : (3, 2, 4, 0, 1, 1),
          1312 : (3, 2, 4, 0, 1, 2),
          1313 : (3, 2, 4, 0, 1, 3),
          1314 : (3, 2, 4, 0, 1, 4),
          1315 : (3, 2, 4, 0, 2, 1),
          1316 : (3, 2, 4, 0, 3, 1),
          1317 : (3, 2, 4, 0, 4, 1),
          1318 : (3, 2, 4, 1, 0, 0),
          1319 : (3, 2, 4, 1, 0, 1),
          1320 : (3, 2, 4, 1, 0, 2),
          1321 : (3, 2, 4, 1, 0, 3),
          1322 : (3, 2, 4, 1, 0, 4),
          1323 : (3, 2, 4, 1, 1, 0),
          1324 : (3, 2, 4, 1, 2, 0),
          1325 : (3, 2, 4, 1, 3, 0),
          1326 : (3, 2, 4, 1, 4, 0),
          1327 : (3, 2, 4, 2, 0, 1),
          1328 : (3, 2, 4, 2, 1, 0),
          1329 : (3, 2, 4, 3, 0, 1),
          1330 : (3, 2, 4, 3, 1, 0),
          1331 : (3, 2, 4, 4, 0, 1),
          1332 : (3, 2, 4, 4, 1, 0),
          1333 : (3, 3, 0, 1, 2, 4),
          1334 : (3, 3, 0, 1, 4, 2),
          1335 : (3, 3, 0, 2, 1, 4),
          1336 : (3, 3, 0, 2, 4, 1),
          1337 : (3, 3, 0, 4, 1, 2),
          1338 : (3, 3, 0, 4, 2, 1),
          1339 : (3, 3, 1, 0, 2, 4),
          1340 : (3, 3, 1, 0, 4, 2),
          1341 : (3, 3, 1, 2, 0, 4),
          1342 : (3, 3, 1, 2, 4, 0),
          1343 : (3, 3, 1, 4, 0, 2),
          1344 : (3, 3, 1, 4, 2, 0),
          1345 : (3, 3, 2, 0, 1, 4),
          1346 : (3, 3, 2, 0, 4, 1),
          1347 : (3, 3, 2, 1, 0, 4),
          1348 : (3, 3, 2, 1, 4, 0),
          1349 : (3, 3, 2, 4, 0, 1),
          1350 : (3, 3, 2, 4, 1, 0),
          1351 : (3, 3, 4, 0, 1, 2),
          1352 : (3, 3, 4, 0, 2, 1),
          1353 : (3, 3, 4, 1, 0, 2),
          1354 : (3, 3, 4, 1, 2, 0),
          1355 : (3, 3, 4, 2, 0, 1),
          1356 : (3, 3, 4, 2, 1, 0),
          1357 : (3, 4, 0, 0, 1, 2),
          1358 : (3, 4, 0, 0, 2, 1),
          1359 : (3, 4, 0, 1, 0, 2),
          1360 : (3, 4, 0, 1, 1, 2),
          1361 : (3, 4, 0, 1, 2, 0),
          1362 : (3, 4, 0, 1, 2, 1),
          1363 : (3, 4, 0, 1, 2, 2),
          1364 : (3, 4, 0, 1, 2, 3),
          1365 : (3, 4, 0, 1, 2, 4),
          1366 : (3, 4, 0, 1, 3, 2),
          1367 : (3, 4, 0, 1, 4, 2),
          1368 : (3, 4, 0, 2, 0, 1),
          1369 : (3, 4, 0, 2, 1, 0),
          1370 : (3, 4, 0, 2, 1, 1),
          1371 : (3, 4, 0, 2, 1, 2),
          1372 : (3, 4, 0, 2, 1, 3),
          1373 : (3, 4, 0, 2, 1, 4),
          1374 : (3, 4, 0, 2, 2, 1),
          1375 : (3, 4, 0, 2, 3, 1),
          1376 : (3, 4, 0, 2, 4, 1),
          1377 : (3, 4, 0, 3, 1, 2),
          1378 : (3, 4, 0, 3, 2, 1),
          1379 : (3, 4, 0, 4, 1, 2),
          1380 : (3, 4, 0, 4, 2, 1),
          1381 : (3, 4, 1, 0, 0, 2),
          1382 : (3, 4, 1, 0, 1, 2),
          1383 : (3, 4, 1, 0, 2, 0),
          1384 : (3, 4, 1, 0, 2, 1),
          1385 : (3, 4, 1, 0, 2, 2),
          1386 : (3, 4, 1, 0, 2, 3),
          1387 : (3, 4, 1, 0, 2, 4),
          1388 : (3, 4, 1, 0, 3, 2),
          1389 : (3, 4, 1, 0, 4, 2),
          1390 : (3, 4, 1, 1, 0, 2),
          1391 : (3, 4, 1, 1, 2, 0),
          1392 : (3, 4, 1, 2, 0, 0),
          1393 : (3, 4, 1, 2, 0, 1),
          1394 : (3, 4, 1, 2, 0, 2),
          1395 : (3, 4, 1, 2, 0, 3),
          1396 : (3, 4, 1, 2, 0, 4),
          1397 : (3, 4, 1, 2, 1, 0),
          1398 : (3, 4, 1, 2, 2, 0),
          1399 : (3, 4, 1, 2, 3, 0),
          1400 : (3, 4, 1, 2, 4, 0),
          1401 : (3, 4, 1, 3, 0, 2),
          1402 : (3, 4, 1, 3, 2, 0),
          1403 : (3, 4, 1, 4, 0, 2),
          1404 : (3, 4, 1, 4, 2, 0),
          1405 : (3, 4, 2, 0, 0, 1),
          1406 : (3, 4, 2, 0, 1, 0),
          1407 : (3, 4, 2, 0, 1, 1),
          1408 : (3, 4, 2, 0, 1, 2),
          1409 : (3, 4, 2, 0, 1, 3),
          1410 : (3, 4, 2, 0, 1, 4),
          1411 : (3, 4, 2, 0, 2, 1),
          1412 : (3, 4, 2, 0, 3, 1),
          1413 : (3, 4, 2, 0, 4, 1),
          1414 : (3, 4, 2, 1, 0, 0),
          1415 : (3, 4, 2, 1, 0, 1),
          1416 : (3, 4, 2, 1, 0, 2),
          1417 : (3, 4, 2, 1, 0, 3),
          1418 : (3, 4, 2, 1, 0, 4),
          1419 : (3, 4, 2, 1, 1, 0),
          1420 : (3, 4, 2, 1, 2, 0),
          1421 : (3, 4, 2, 1, 3, 0),
          1422 : (3, 4, 2, 1, 4, 0),
          1423 : (3, 4, 2, 2, 0, 1),
          1424 : (3, 4, 2, 2, 1, 0),
          1425 : (3, 4, 2, 3, 0, 1),
          1426 : (3, 4, 2, 3, 1, 0),
          1427 : (3, 4, 2, 4, 0, 1),
          1428 : (3, 4, 2, 4, 1, 0),
          1429 : (3, 4, 3, 0, 1, 2),
          1430 : (3, 4, 3, 0, 2, 1),
          1431 : (3, 4, 3, 1, 0, 2),
          1432 : (3, 4, 3, 1, 2, 0),
          1433 : (3, 4, 3, 2, 0, 1),
          1434 : (3, 4, 3, 2, 1, 0),
          1435 : (3, 4, 4, 0, 1, 2),
          1436 : (3, 4, 4, 0, 2, 1),
          1437 : (3, 4, 4, 1, 0, 2),
          1438 : (3, 4, 4, 1, 2, 0),
          1439 : (3, 4, 4, 2, 0, 1),
          1440 : (3, 4, 4, 2, 1, 0),
          1441 : (4, 0, 0, 1, 2, 3),
          1442 : (4, 0, 0, 1, 3, 2),
          1443 : (4, 0, 0, 2, 1, 3),
          1444 : (4, 0, 0, 2, 3, 1),
          1445 : (4, 0, 0, 3, 1, 2),
          1446 : (4, 0, 0, 3, 2, 1),
          1447 : (4, 0, 1, 0, 2, 3),
          1448 : (4, 0, 1, 0, 3, 2),
          1449 : (4, 0, 1, 1, 2, 3),
          1450 : (4, 0, 1, 1, 3, 2),
          1451 : (4, 0, 1, 2, 0, 3),
          1452 : (4, 0, 1, 2, 1, 3),
          1453 : (4, 0, 1, 2, 2, 3),
          1454 : (4, 0, 1, 2, 3, 0),
          1455 : (4, 0, 1, 2, 3, 1),
          1456 : (4, 0, 1, 2, 3, 2),
          1457 : (4, 0, 1, 2, 3, 3),
          1458 : (4, 0, 1, 2, 3, 4),
          1459 : (4, 0, 1, 2, 4, 3),
          1460 : (4, 0, 1, 3, 0, 2),
          1461 : (4, 0, 1, 3, 1, 2),
          1462 : (4, 0, 1, 3, 2, 0),
          1463 : (4, 0, 1, 3, 2, 1),
          1464 : (4, 0, 1, 3, 2, 2),
          1465 : (4, 0, 1, 3, 2, 3),
          1466 : (4, 0, 1, 3, 2, 4),
          1467 : (4, 0, 1, 3, 3, 2),
          1468 : (4, 0, 1, 3, 4, 2),
          1469 : (4, 0, 1, 4, 2, 3),
          1470 : (4, 0, 1, 4, 3, 2),
          1471 : (4, 0, 2, 0, 1, 3),
          1472 : (4, 0, 2, 0, 3, 1),
          1473 : (4, 0, 2, 1, 0, 3),
          1474 : (4, 0, 2, 1, 1, 3),
          1475 : (4, 0, 2, 1, 2, 3),
          1476 : (4, 0, 2, 1, 3, 0),
          1477 : (4, 0, 2, 1, 3, 1),
          1478 : (4, 0, 2, 1, 3, 2),
          1479 : (4, 0, 2, 1, 3, 3),
          1480 : (4, 0, 2, 1, 3, 4),
          1481 : (4, 0, 2, 1, 4, 3),
          1482 : (4, 0, 2, 2, 1, 3),
          1483 : (4, 0, 2, 2, 3, 1),
          1484 : (4, 0, 2, 3, 0, 1),
          1485 : (4, 0, 2, 3, 1, 0),
          1486 : (4, 0, 2, 3, 1, 1),
          1487 : (4, 0, 2, 3, 1, 2),
          1488 : (4, 0, 2, 3, 1, 3),
          1489 : (4, 0, 2, 3, 1, 4),
          1490 : (4, 0, 2, 3, 2, 1),
          1491 : (4, 0, 2, 3, 3, 1),
          1492 : (4, 0, 2, 3, 4, 1),
          1493 : (4, 0, 2, 4, 1, 3),
          1494 : (4, 0, 2, 4, 3, 1),
          1495 : (4, 0, 3, 0, 1, 2),
          1496 : (4, 0, 3, 0, 2, 1),
          1497 : (4, 0, 3, 1, 0, 2),
          1498 : (4, 0, 3, 1, 1, 2),
          1499 : (4, 0, 3, 1, 2, 0),
          1500 : (4, 0, 3, 1, 2, 1),
          1501 : (4, 0, 3, 1, 2, 2),
          1502 : (4, 0, 3, 1, 2, 3),
          1503 : (4, 0, 3, 1, 2, 4),
          1504 : (4, 0, 3, 1, 3, 2),
          1505 : (4, 0, 3, 1, 4, 2),
          1506 : (4, 0, 3, 2, 0, 1),
          1507 : (4, 0, 3, 2, 1, 0),
          1508 : (4, 0, 3, 2, 1, 1),
          1509 : (4, 0, 3, 2, 1, 2),
          1510 : (4, 0, 3, 2, 1, 3),
          1511 : (4, 0, 3, 2, 1, 4),
          1512 : (4, 0, 3, 2, 2, 1),
          1513 : (4, 0, 3, 2, 3, 1),
          1514 : (4, 0, 3, 2, 4, 1),
          1515 : (4, 0, 3, 3, 1, 2),
          1516 : (4, 0, 3, 3, 2, 1),
          1517 : (4, 0, 3, 4, 1, 2),
          1518 : (4, 0, 3, 4, 2, 1),
          1519 : (4, 0, 4, 1, 2, 3),
          1520 : (4, 0, 4, 1, 3, 2),
          1521 : (4, 0, 4, 2, 1, 3),
          1522 : (4, 0, 4, 2, 3, 1),
          1523 : (4, 0, 4, 3, 1, 2),
          1524 : (4, 0, 4, 3, 2, 1),
          1525 : (4, 1, 0, 0, 2, 3),
          1526 : (4, 1, 0, 0, 3, 2),
          1527 : (4, 1, 0, 1, 2, 3),
          1528 : (4, 1, 0, 1, 3, 2),
          1529 : (4, 1, 0, 2, 0, 3),
          1530 : (4, 1, 0, 2, 1, 3),
          1531 : (4, 1, 0, 2, 2, 3),
          1532 : (4, 1, 0, 2, 3, 0),
          1533 : (4, 1, 0, 2, 3, 1),
          1534 : (4, 1, 0, 2, 3, 2),
          1535 : (4, 1, 0, 2, 3, 3),
          1536 : (4, 1, 0, 2, 3, 4),
          1537 : (4, 1, 0, 2, 4, 3),
          1538 : (4, 1, 0, 3, 0, 2),
          1539 : (4, 1, 0, 3, 1, 2),
          1540 : (4, 1, 0, 3, 2, 0),
          1541 : (4, 1, 0, 3, 2, 1),
          1542 : (4, 1, 0, 3, 2, 2),
          1543 : (4, 1, 0, 3, 2, 3),
          1544 : (4, 1, 0, 3, 2, 4),
          1545 : (4, 1, 0, 3, 3, 2),
          1546 : (4, 1, 0, 3, 4, 2),
          1547 : (4, 1, 0, 4, 2, 3),
          1548 : (4, 1, 0, 4, 3, 2),
          1549 : (4, 1, 1, 0, 2, 3),
          1550 : (4, 1, 1, 0, 3, 2),
          1551 : (4, 1, 1, 2, 0, 3),
          1552 : (4, 1, 1, 2, 3, 0),
          1553 : (4, 1, 1, 3, 0, 2),
          1554 : (4, 1, 1, 3, 2, 0),
          1555 : (4, 1, 2, 0, 0, 3),
          1556 : (4, 1, 2, 0, 1, 3),
          1557 : (4, 1, 2, 0, 2, 3),
          1558 : (4, 1, 2, 0, 3, 0),
          1559 : (4, 1, 2, 0, 3, 1),
          1560 : (4, 1, 2, 0, 3, 2),
          1561 : (4, 1, 2, 0, 3, 3),
          1562 : (4, 1, 2, 0, 3, 4),
          1563 : (4, 1, 2, 0, 4, 3),
          1564 : (4, 1, 2, 1, 0, 3),
          1565 : (4, 1, 2, 1, 3, 0),
          1566 : (4, 1, 2, 2, 0, 3),
          1567 : (4, 1, 2, 2, 3, 0),
          1568 : (4, 1, 2, 3, 0, 0),
          1569 : (4, 1, 2, 3, 0, 1),
          1570 : (4, 1, 2, 3, 0, 2),
          1571 : (4, 1, 2, 3, 0, 3),
          1572 : (4, 1, 2, 3, 0, 4),
          1573 : (4, 1, 2, 3, 1, 0),
          1574 : (4, 1, 2, 3, 2, 0),
          1575 : (4, 1, 2, 3, 3, 0),
          1576 : (4, 1, 2, 3, 4, 0),
          1577 : (4, 1, 2, 4, 0, 3),
          1578 : (4, 1, 2, 4, 3, 0),
          1579 : (4, 1, 3, 0, 0, 2),
          1580 : (4, 1, 3, 0, 1, 2),
          1581 : (4, 1, 3, 0, 2, 0),
          1582 : (4, 1, 3, 0, 2, 1),
          1583 : (4, 1, 3, 0, 2, 2),
          1584 : (4, 1, 3, 0, 2, 3),
          1585 : (4, 1, 3, 0, 2, 4),
          1586 : (4, 1, 3, 0, 3, 2),
          1587 : (4, 1, 3, 0, 4, 2),
          1588 : (4, 1, 3, 1, 0, 2),
          1589 : (4, 1, 3, 1, 2, 0),
          1590 : (4, 1, 3, 2, 0, 0),
          1591 : (4, 1, 3, 2, 0, 1),
          1592 : (4, 1, 3, 2, 0, 2),
          1593 : (4, 1, 3, 2, 0, 3),
          1594 : (4, 1, 3, 2, 0, 4),
          1595 : (4, 1, 3, 2, 1, 0),
          1596 : (4, 1, 3, 2, 2, 0),
          1597 : (4, 1, 3, 2, 3, 0),
          1598 : (4, 1, 3, 2, 4, 0),
          1599 : (4, 1, 3, 3, 0, 2),
          1600 : (4, 1, 3, 3, 2, 0),
          1601 : (4, 1, 3, 4, 0, 2),
          1602 : (4, 1, 3, 4, 2, 0),
          1603 : (4, 1, 4, 0, 2, 3),
          1604 : (4, 1, 4, 0, 3, 2),
          1605 : (4, 1, 4, 2, 0, 3),
          1606 : (4, 1, 4, 2, 3, 0),
          1607 : (4, 1, 4, 3, 0, 2),
          1608 : (4, 1, 4, 3, 2, 0),
          1609 : (4, 2, 0, 0, 1, 3),
          1610 : (4, 2, 0, 0, 3, 1),
          1611 : (4, 2, 0, 1, 0, 3),
          1612 : (4, 2, 0, 1, 1, 3),
          1613 : (4, 2, 0, 1, 2, 3),
          1614 : (4, 2, 0, 1, 3, 0),
          1615 : (4, 2, 0, 1, 3, 1),
          1616 : (4, 2, 0, 1, 3, 2),
          1617 : (4, 2, 0, 1, 3, 3),
          1618 : (4, 2, 0, 1, 3, 4),
          1619 : (4, 2, 0, 1, 4, 3),
          1620 : (4, 2, 0, 2, 1, 3),
          1621 : (4, 2, 0, 2, 3, 1),
          1622 : (4, 2, 0, 3, 0, 1),
          1623 : (4, 2, 0, 3, 1, 0),
          1624 : (4, 2, 0, 3, 1, 1),
          1625 : (4, 2, 0, 3, 1, 2),
          1626 : (4, 2, 0, 3, 1, 3),
          1627 : (4, 2, 0, 3, 1, 4),
          1628 : (4, 2, 0, 3, 2, 1),
          1629 : (4, 2, 0, 3, 3, 1),
          1630 : (4, 2, 0, 3, 4, 1),
          1631 : (4, 2, 0, 4, 1, 3),
          1632 : (4, 2, 0, 4, 3, 1),
          1633 : (4, 2, 1, 0, 0, 3),
          1634 : (4, 2, 1, 0, 1, 3),
          1635 : (4, 2, 1, 0, 2, 3),
          1636 : (4, 2, 1, 0, 3, 0),
          1637 : (4, 2, 1, 0, 3, 1),
          1638 : (4, 2, 1, 0, 3, 2),
          1639 : (4, 2, 1, 0, 3, 3),
          1640 : (4, 2, 1, 0, 3, 4),
          1641 : (4, 2, 1, 0, 4, 3),
          1642 : (4, 2, 1, 1, 0, 3),
          1643 : (4, 2, 1, 1, 3, 0),
          1644 : (4, 2, 1, 2, 0, 3),
          1645 : (4, 2, 1, 2, 3, 0),
          1646 : (4, 2, 1, 3, 0, 0),
          1647 : (4, 2, 1, 3, 0, 1),
          1648 : (4, 2, 1, 3, 0, 2),
          1649 : (4, 2, 1, 3, 0, 3),
          1650 : (4, 2, 1, 3, 0, 4),
          1651 : (4, 2, 1, 3, 1, 0),
          1652 : (4, 2, 1, 3, 2, 0),
          1653 : (4, 2, 1, 3, 3, 0),
          1654 : (4, 2, 1, 3, 4, 0),
          1655 : (4, 2, 1, 4, 0, 3),
          1656 : (4, 2, 1, 4, 3, 0),
          1657 : (4, 2, 2, 0, 1, 3),
          1658 : (4, 2, 2, 0, 3, 1),
          1659 : (4, 2, 2, 1, 0, 3),
          1660 : (4, 2, 2, 1, 3, 0),
          1661 : (4, 2, 2, 3, 0, 1),
          1662 : (4, 2, 2, 3, 1, 0),
          1663 : (4, 2, 3, 0, 0, 1),
          1664 : (4, 2, 3, 0, 1, 0),
          1665 : (4, 2, 3, 0, 1, 1),
          1666 : (4, 2, 3, 0, 1, 2),
          1667 : (4, 2, 3, 0, 1, 3),
          1668 : (4, 2, 3, 0, 1, 4),
          1669 : (4, 2, 3, 0, 2, 1),
          1670 : (4, 2, 3, 0, 3, 1),
          1671 : (4, 2, 3, 0, 4, 1),
          1672 : (4, 2, 3, 1, 0, 0),
          1673 : (4, 2, 3, 1, 0, 1),
          1674 : (4, 2, 3, 1, 0, 2),
          1675 : (4, 2, 3, 1, 0, 3),
          1676 : (4, 2, 3, 1, 0, 4),
          1677 : (4, 2, 3, 1, 1, 0),
          1678 : (4, 2, 3, 1, 2, 0),
          1679 : (4, 2, 3, 1, 3, 0),
          1680 : (4, 2, 3, 1, 4, 0),
          1681 : (4, 2, 3, 2, 0, 1),
          1682 : (4, 2, 3, 2, 1, 0),
          1683 : (4, 2, 3, 3, 0, 1),
          1684 : (4, 2, 3, 3, 1, 0),
          1685 : (4, 2, 3, 4, 0, 1),
          1686 : (4, 2, 3, 4, 1, 0),
          1687 : (4, 2, 4, 0, 1, 3),
          1688 : (4, 2, 4, 0, 3, 1),
          1689 : (4, 2, 4, 1, 0, 3),
          1690 : (4, 2, 4, 1, 3, 0),
          1691 : (4, 2, 4, 3, 0, 1),
          1692 : (4, 2, 4, 3, 1, 0),
          1693 : (4, 3, 0, 0, 1, 2),
          1694 : (4, 3, 0, 0, 2, 1),
          1695 : (4, 3, 0, 1, 0, 2),
          1696 : (4, 3, 0, 1, 1, 2),
          1697 : (4, 3, 0, 1, 2, 0),
          1698 : (4, 3, 0, 1, 2, 1),
          1699 : (4, 3, 0, 1, 2, 2),
          1700 : (4, 3, 0, 1, 2, 3),
          1701 : (4, 3, 0, 1, 2, 4),
          1702 : (4, 3, 0, 1, 3, 2),
          1703 : (4, 3, 0, 1, 4, 2),
          1704 : (4, 3, 0, 2, 0, 1),
          1705 : (4, 3, 0, 2, 1, 0),
          1706 : (4, 3, 0, 2, 1, 1),
          1707 : (4, 3, 0, 2, 1, 2),
          1708 : (4, 3, 0, 2, 1, 3),
          1709 : (4, 3, 0, 2, 1, 4),
          1710 : (4, 3, 0, 2, 2, 1),
          1711 : (4, 3, 0, 2, 3, 1),
          1712 : (4, 3, 0, 2, 4, 1),
          1713 : (4, 3, 0, 3, 1, 2),
          1714 : (4, 3, 0, 3, 2, 1),
          1715 : (4, 3, 0, 4, 1, 2),
          1716 : (4, 3, 0, 4, 2, 1),
          1717 : (4, 3, 1, 0, 0, 2),
          1718 : (4, 3, 1, 0, 1, 2),
          1719 : (4, 3, 1, 0, 2, 0),
          1720 : (4, 3, 1, 0, 2, 1),
          1721 : (4, 3, 1, 0, 2, 2),
          1722 : (4, 3, 1, 0, 2, 3),
          1723 : (4, 3, 1, 0, 2, 4),
          1724 : (4, 3, 1, 0, 3, 2),
          1725 : (4, 3, 1, 0, 4, 2),
          1726 : (4, 3, 1, 1, 0, 2),
          1727 : (4, 3, 1, 1, 2, 0),
          1728 : (4, 3, 1, 2, 0, 0),
          1729 : (4, 3, 1, 2, 0, 1),
          1730 : (4, 3, 1, 2, 0, 2),
          1731 : (4, 3, 1, 2, 0, 3),
          1732 : (4, 3, 1, 2, 0, 4),
          1733 : (4, 3, 1, 2, 1, 0),
          1734 : (4, 3, 1, 2, 2, 0),
          1735 : (4, 3, 1, 2, 3, 0),
          1736 : (4, 3, 1, 2, 4, 0),
          1737 : (4, 3, 1, 3, 0, 2),
          1738 : (4, 3, 1, 3, 2, 0),
          1739 : (4, 3, 1, 4, 0, 2),
          1740 : (4, 3, 1, 4, 2, 0),
          1741 : (4, 3, 2, 0, 0, 1),
          1742 : (4, 3, 2, 0, 1, 0),
          1743 : (4, 3, 2, 0, 1, 1),
          1744 : (4, 3, 2, 0, 1, 2),
          1745 : (4, 3, 2, 0, 1, 3),
          1746 : (4, 3, 2, 0, 1, 4),
          1747 : (4, 3, 2, 0, 2, 1),
          1748 : (4, 3, 2, 0, 3, 1),
          1749 : (4, 3, 2, 0, 4, 1),
          1750 : (4, 3, 2, 1, 0, 0),
          1751 : (4, 3, 2, 1, 0, 1),
          1752 : (4, 3, 2, 1, 0, 2),
          1753 : (4, 3, 2, 1, 0, 3),
          1754 : (4, 3, 2, 1, 0, 4),
          1755 : (4, 3, 2, 1, 1, 0),
          1756 : (4, 3, 2, 1, 2, 0),
          1757 : (4, 3, 2, 1, 3, 0),
          1758 : (4, 3, 2, 1, 4, 0),
          1759 : (4, 3, 2, 2, 0, 1),
          1760 : (4, 3, 2, 2, 1, 0),
          1761 : (4, 3, 2, 3, 0, 1),
          1762 : (4, 3, 2, 3, 1, 0),
          1763 : (4, 3, 2, 4, 0, 1),
          1764 : (4, 3, 2, 4, 1, 0),
          1765 : (4, 3, 3, 0, 1, 2),
          1766 : (4, 3, 3, 0, 2, 1),
          1767 : (4, 3, 3, 1, 0, 2),
          1768 : (4, 3, 3, 1, 2, 0),
          1769 : (4, 3, 3, 2, 0, 1),
          1770 : (4, 3, 3, 2, 1, 0),
          1771 : (4, 3, 4, 0, 1, 2),
          1772 : (4, 3, 4, 0, 2, 1),
          1773 : (4, 3, 4, 1, 0, 2),
          1774 : (4, 3, 4, 1, 2, 0),
          1775 : (4, 3, 4, 2, 0, 1),
          1776 : (4, 3, 4, 2, 1, 0),
          1777 : (4, 4, 0, 1, 2, 3),
          1778 : (4, 4, 0, 1, 3, 2),
          1779 : (4, 4, 0, 2, 1, 3),
          1780 : (4, 4, 0, 2, 3, 1),
          1781 : (4, 4, 0, 3, 1, 2),
          1782 : (4, 4, 0, 3, 2, 1),
          1783 : (4, 4, 1, 0, 2, 3),
          1784 : (4, 4, 1, 0, 3, 2),
          1785 : (4, 4, 1, 2, 0, 3),
          1786 : (4, 4, 1, 2, 3, 0),
          1787 : (4, 4, 1, 3, 0, 2),
          1788 : (4, 4, 1, 3, 2, 0),
          1789 : (4, 4, 2, 0, 1, 3),
          1790 : (4, 4, 2, 0, 3, 1),
          1791 : (4, 4, 2, 1, 0, 3),
          1792 : (4, 4, 2, 1, 3, 0),
          1793 : (4, 4, 2, 3, 0, 1),
          1794 : (4, 4, 2, 3, 1, 0),
          1795 : (4, 4, 3, 0, 1, 2),
          1796 : (4, 4, 3, 0, 2, 1),
          1797 : (4, 4, 3, 1, 0, 2),
          1798 : (4, 4, 3, 1, 2, 0),
          1799 : (4, 4, 3, 2, 0, 1),
          1800 : (4, 4, 3, 2, 1, 0)}

map_6_4 ={ 1 : (0, 0, 0, 1, 2, 3),
           2 : (0, 0, 0, 1, 3, 2),
           3 : (0, 0, 0, 2, 1, 3),
           4 : (0, 0, 0, 2, 3, 1),
           5 : (0, 0, 0, 3, 1, 2),
           6 : (0, 0, 0, 3, 2, 1),
           7 : (0, 0, 1, 0, 2, 3),
           8 : (0, 0, 1, 0, 3, 2),
           9 : (0, 0, 1, 1, 2, 3),
          10 : (0, 0, 1, 1, 3, 2),
          11 : (0, 0, 1, 2, 0, 3),
          12 : (0, 0, 1, 2, 1, 3),
          13 : (0, 0, 1, 2, 2, 3),
          14 : (0, 0, 1, 2, 3, 0),
          15 : (0, 0, 1, 2, 3, 1),
          16 : (0, 0, 1, 2, 3, 2),
          17 : (0, 0, 1, 2, 3, 3),
          18 : (0, 0, 1, 3, 0, 2),
          19 : (0, 0, 1, 3, 1, 2),
          20 : (0, 0, 1, 3, 2, 0),
          21 : (0, 0, 1, 3, 2, 1),
          22 : (0, 0, 1, 3, 2, 2),
          23 : (0, 0, 1, 3, 2, 3),
          24 : (0, 0, 1, 3, 3, 2),
          25 : (0, 0, 2, 0, 1, 3),
          26 : (0, 0, 2, 0, 3, 1),
          27 : (0, 0, 2, 1, 0, 3),
          28 : (0, 0, 2, 1, 1, 3),
          29 : (0, 0, 2, 1, 2, 3),
          30 : (0, 0, 2, 1, 3, 0),
          31 : (0, 0, 2, 1, 3, 1),
          32 : (0, 0, 2, 1, 3, 2),
          33 : (0, 0, 2, 1, 3, 3),
          34 : (0, 0, 2, 2, 1, 3),
          35 : (0, 0, 2, 2, 3, 1),
          36 : (0, 0, 2, 3, 0, 1),
          37 : (0, 0, 2, 3, 1, 0),
          38 : (0, 0, 2, 3, 1, 1),
          39 : (0, 0, 2, 3, 1, 2),
          40 : (0, 0, 2, 3, 1, 3),
          41 : (0, 0, 2, 3, 2, 1),
          42 : (0, 0, 2, 3, 3, 1),
          43 : (0, 0, 3, 0, 1, 2),
          44 : (0, 0, 3, 0, 2, 1),
          45 : (0, 0, 3, 1, 0, 2),
          46 : (0, 0, 3, 1, 1, 2),
          47 : (0, 0, 3, 1, 2, 0),
          48 : (0, 0, 3, 1, 2, 1),
          49 : (0, 0, 3, 1, 2, 2),
          50 : (0, 0, 3, 1, 2, 3),
          51 : (0, 0, 3, 1, 3, 2),
          52 : (0, 0, 3, 2, 0, 1),
          53 : (0, 0, 3, 2, 1, 0),
          54 : (0, 0, 3, 2, 1, 1),
          55 : (0, 0, 3, 2, 1, 2),
          56 : (0, 0, 3, 2, 1, 3),
          57 : (0, 0, 3, 2, 2, 1),
          58 : (0, 0, 3, 2, 3, 1),
          59 : (0, 0, 3, 3, 1, 2),
          60 : (0, 0, 3, 3, 2, 1),
          61 : (0, 1, 0, 0, 2, 3),
          62 : (0, 1, 0, 0, 3, 2),
          63 : (0, 1, 0, 1, 2, 3),
          64 : (0, 1, 0, 1, 3, 2),
          65 : (0, 1, 0, 2, 0, 3),
          66 : (0, 1, 0, 2, 1, 3),
          67 : (0, 1, 0, 2, 2, 3),
          68 : (0, 1, 0, 2, 3, 0),
          69 : (0, 1, 0, 2, 3, 1),
          70 : (0, 1, 0, 2, 3, 2),
          71 : (0, 1, 0, 2, 3, 3),
          72 : (0, 1, 0, 3, 0, 2),
          73 : (0, 1, 0, 3, 1, 2),
          74 : (0, 1, 0, 3, 2, 0),
          75 : (0, 1, 0, 3, 2, 1),
          76 : (0, 1, 0, 3, 2, 2),
          77 : (0, 1, 0, 3, 2, 3),
          78 : (0, 1, 0, 3, 3, 2),
          79 : (0, 1, 1, 0, 2, 3),
          80 : (0, 1, 1, 0, 3, 2),
          81 : (0, 1, 1, 1, 2, 3),
          82 : (0, 1, 1, 1, 3, 2),
          83 : (0, 1, 1, 2, 0, 3),
          84 : (0, 1, 1, 2, 1, 3),
          85 : (0, 1, 1, 2, 2, 3),
          86 : (0, 1, 1, 2, 3, 0),
          87 : (0, 1, 1, 2, 3, 1),
          88 : (0, 1, 1, 2, 3, 2),
          89 : (0, 1, 1, 2, 3, 3),
          90 : (0, 1, 1, 3, 0, 2),
          91 : (0, 1, 1, 3, 1, 2),
          92 : (0, 1, 1, 3, 2, 0),
          93 : (0, 1, 1, 3, 2, 1),
          94 : (0, 1, 1, 3, 2, 2),
          95 : (0, 1, 1, 3, 2, 3),
          96 : (0, 1, 1, 3, 3, 2),
          97 : (0, 1, 2, 0, 0, 3),
          98 : (0, 1, 2, 0, 1, 3),
          99 : (0, 1, 2, 0, 2, 3),
          100 : (0, 1, 2, 0, 3, 0),
          101 : (0, 1, 2, 0, 3, 1),
          102 : (0, 1, 2, 0, 3, 2),
          103 : (0, 1, 2, 0, 3, 3),
          104 : (0, 1, 2, 1, 0, 3),
          105 : (0, 1, 2, 1, 1, 3),
          106 : (0, 1, 2, 1, 2, 3),
          107 : (0, 1, 2, 1, 3, 0),
          108 : (0, 1, 2, 1, 3, 1),
          109 : (0, 1, 2, 1, 3, 2),
          110 : (0, 1, 2, 1, 3, 3),
          111 : (0, 1, 2, 2, 0, 3),
          112 : (0, 1, 2, 2, 1, 3),
          113 : (0, 1, 2, 2, 2, 3),
          114 : (0, 1, 2, 2, 3, 0),
          115 : (0, 1, 2, 2, 3, 1),
          116 : (0, 1, 2, 2, 3, 2),
          117 : (0, 1, 2, 2, 3, 3),
          118 : (0, 1, 2, 3, 0, 0),
          119 : (0, 1, 2, 3, 0, 1),
          120 : (0, 1, 2, 3, 0, 2),
          121 : (0, 1, 2, 3, 0, 3),
          122 : (0, 1, 2, 3, 1, 0),
          123 : (0, 1, 2, 3, 1, 1),
          124 : (0, 1, 2, 3, 1, 2),
          125 : (0, 1, 2, 3, 1, 3),
          126 : (0, 1, 2, 3, 2, 0),
          127 : (0, 1, 2, 3, 2, 1),
          128 : (0, 1, 2, 3, 2, 2),
          129 : (0, 1, 2, 3, 2, 3),
          130 : (0, 1, 2, 3, 3, 0),
          131 : (0, 1, 2, 3, 3, 1),
          132 : (0, 1, 2, 3, 3, 2),
          133 : (0, 1, 2, 3, 3, 3),
          134 : (0, 1, 3, 0, 0, 2),
          135 : (0, 1, 3, 0, 1, 2),
          136 : (0, 1, 3, 0, 2, 0),
          137 : (0, 1, 3, 0, 2, 1),
          138 : (0, 1, 3, 0, 2, 2),
          139 : (0, 1, 3, 0, 2, 3),
          140 : (0, 1, 3, 0, 3, 2),
          141 : (0, 1, 3, 1, 0, 2),
          142 : (0, 1, 3, 1, 1, 2),
          143 : (0, 1, 3, 1, 2, 0),
          144 : (0, 1, 3, 1, 2, 1),
          145 : (0, 1, 3, 1, 2, 2),
          146 : (0, 1, 3, 1, 2, 3),
          147 : (0, 1, 3, 1, 3, 2),
          148 : (0, 1, 3, 2, 0, 0),
          149 : (0, 1, 3, 2, 0, 1),
          150 : (0, 1, 3, 2, 0, 2),
          151 : (0, 1, 3, 2, 0, 3),
          152 : (0, 1, 3, 2, 1, 0),
          153 : (0, 1, 3, 2, 1, 1),
          154 : (0, 1, 3, 2, 1, 2),
          155 : (0, 1, 3, 2, 1, 3),
          156 : (0, 1, 3, 2, 2, 0),
          157 : (0, 1, 3, 2, 2, 1),
          158 : (0, 1, 3, 2, 2, 2),
          159 : (0, 1, 3, 2, 2, 3),
          160 : (0, 1, 3, 2, 3, 0),
          161 : (0, 1, 3, 2, 3, 1),
          162 : (0, 1, 3, 2, 3, 2),
          163 : (0, 1, 3, 2, 3, 3),
          164 : (0, 1, 3, 3, 0, 2),
          165 : (0, 1, 3, 3, 1, 2),
          166 : (0, 1, 3, 3, 2, 0),
          167 : (0, 1, 3, 3, 2, 1),
          168 : (0, 1, 3, 3, 2, 2),
          169 : (0, 1, 3, 3, 2, 3),
          170 : (0, 1, 3, 3, 3, 2),
          171 : (0, 2, 0, 0, 1, 3),
          172 : (0, 2, 0, 0, 3, 1),
          173 : (0, 2, 0, 1, 0, 3),
          174 : (0, 2, 0, 1, 1, 3),
          175 : (0, 2, 0, 1, 2, 3),
          176 : (0, 2, 0, 1, 3, 0),
          177 : (0, 2, 0, 1, 3, 1),
          178 : (0, 2, 0, 1, 3, 2),
          179 : (0, 2, 0, 1, 3, 3),
          180 : (0, 2, 0, 2, 1, 3),
          181 : (0, 2, 0, 2, 3, 1),
          182 : (0, 2, 0, 3, 0, 1),
          183 : (0, 2, 0, 3, 1, 0),
          184 : (0, 2, 0, 3, 1, 1),
          185 : (0, 2, 0, 3, 1, 2),
          186 : (0, 2, 0, 3, 1, 3),
          187 : (0, 2, 0, 3, 2, 1),
          188 : (0, 2, 0, 3, 3, 1),
          189 : (0, 2, 1, 0, 0, 3),
          190 : (0, 2, 1, 0, 1, 3),
          191 : (0, 2, 1, 0, 2, 3),
          192 : (0, 2, 1, 0, 3, 0),
          193 : (0, 2, 1, 0, 3, 1),
          194 : (0, 2, 1, 0, 3, 2),
          195 : (0, 2, 1, 0, 3, 3),
          196 : (0, 2, 1, 1, 0, 3),
          197 : (0, 2, 1, 1, 1, 3),
          198 : (0, 2, 1, 1, 2, 3),
          199 : (0, 2, 1, 1, 3, 0),
          200 : (0, 2, 1, 1, 3, 1),
          201 : (0, 2, 1, 1, 3, 2),
          202 : (0, 2, 1, 1, 3, 3),
          203 : (0, 2, 1, 2, 0, 3),
          204 : (0, 2, 1, 2, 1, 3),
          205 : (0, 2, 1, 2, 2, 3),
          206 : (0, 2, 1, 2, 3, 0),
          207 : (0, 2, 1, 2, 3, 1),
          208 : (0, 2, 1, 2, 3, 2),
          209 : (0, 2, 1, 2, 3, 3),
          210 : (0, 2, 1, 3, 0, 0),
          211 : (0, 2, 1, 3, 0, 1),
          212 : (0, 2, 1, 3, 0, 2),
          213 : (0, 2, 1, 3, 0, 3),
          214 : (0, 2, 1, 3, 1, 0),
          215 : (0, 2, 1, 3, 1, 1),
          216 : (0, 2, 1, 3, 1, 2),
          217 : (0, 2, 1, 3, 1, 3),
          218 : (0, 2, 1, 3, 2, 0),
          219 : (0, 2, 1, 3, 2, 1),
          220 : (0, 2, 1, 3, 2, 2),
          221 : (0, 2, 1, 3, 2, 3),
          222 : (0, 2, 1, 3, 3, 0),
          223 : (0, 2, 1, 3, 3, 1),
          224 : (0, 2, 1, 3, 3, 2),
          225 : (0, 2, 1, 3, 3, 3),
          226 : (0, 2, 2, 0, 1, 3),
          227 : (0, 2, 2, 0, 3, 1),
          228 : (0, 2, 2, 1, 0, 3),
          229 : (0, 2, 2, 1, 1, 3),
          230 : (0, 2, 2, 1, 2, 3),
          231 : (0, 2, 2, 1, 3, 0),
          232 : (0, 2, 2, 1, 3, 1),
          233 : (0, 2, 2, 1, 3, 2),
          234 : (0, 2, 2, 1, 3, 3),
          235 : (0, 2, 2, 2, 1, 3),
          236 : (0, 2, 2, 2, 3, 1),
          237 : (0, 2, 2, 3, 0, 1),
          238 : (0, 2, 2, 3, 1, 0),
          239 : (0, 2, 2, 3, 1, 1),
          240 : (0, 2, 2, 3, 1, 2),
          241 : (0, 2, 2, 3, 1, 3),
          242 : (0, 2, 2, 3, 2, 1),
          243 : (0, 2, 2, 3, 3, 1),
          244 : (0, 2, 3, 0, 0, 1),
          245 : (0, 2, 3, 0, 1, 0),
          246 : (0, 2, 3, 0, 1, 1),
          247 : (0, 2, 3, 0, 1, 2),
          248 : (0, 2, 3, 0, 1, 3),
          249 : (0, 2, 3, 0, 2, 1),
          250 : (0, 2, 3, 0, 3, 1),
          251 : (0, 2, 3, 1, 0, 0),
          252 : (0, 2, 3, 1, 0, 1),
          253 : (0, 2, 3, 1, 0, 2),
          254 : (0, 2, 3, 1, 0, 3),
          255 : (0, 2, 3, 1, 1, 0),
          256 : (0, 2, 3, 1, 1, 1),
          257 : (0, 2, 3, 1, 1, 2),
          258 : (0, 2, 3, 1, 1, 3),
          259 : (0, 2, 3, 1, 2, 0),
          260 : (0, 2, 3, 1, 2, 1),
          261 : (0, 2, 3, 1, 2, 2),
          262 : (0, 2, 3, 1, 2, 3),
          263 : (0, 2, 3, 1, 3, 0),
          264 : (0, 2, 3, 1, 3, 1),
          265 : (0, 2, 3, 1, 3, 2),
          266 : (0, 2, 3, 1, 3, 3),
          267 : (0, 2, 3, 2, 0, 1),
          268 : (0, 2, 3, 2, 1, 0),
          269 : (0, 2, 3, 2, 1, 1),
          270 : (0, 2, 3, 2, 1, 2),
          271 : (0, 2, 3, 2, 1, 3),
          272 : (0, 2, 3, 2, 2, 1),
          273 : (0, 2, 3, 2, 3, 1),
          274 : (0, 2, 3, 3, 0, 1),
          275 : (0, 2, 3, 3, 1, 0),
          276 : (0, 2, 3, 3, 1, 1),
          277 : (0, 2, 3, 3, 1, 2),
          278 : (0, 2, 3, 3, 1, 3),
          279 : (0, 2, 3, 3, 2, 1),
          280 : (0, 2, 3, 3, 3, 1),
          281 : (0, 3, 0, 0, 1, 2),
          282 : (0, 3, 0, 0, 2, 1),
          283 : (0, 3, 0, 1, 0, 2),
          284 : (0, 3, 0, 1, 1, 2),
          285 : (0, 3, 0, 1, 2, 0),
          286 : (0, 3, 0, 1, 2, 1),
          287 : (0, 3, 0, 1, 2, 2),
          288 : (0, 3, 0, 1, 2, 3),
          289 : (0, 3, 0, 1, 3, 2),
          290 : (0, 3, 0, 2, 0, 1),
          291 : (0, 3, 0, 2, 1, 0),
          292 : (0, 3, 0, 2, 1, 1),
          293 : (0, 3, 0, 2, 1, 2),
          294 : (0, 3, 0, 2, 1, 3),
          295 : (0, 3, 0, 2, 2, 1),
          296 : (0, 3, 0, 2, 3, 1),
          297 : (0, 3, 0, 3, 1, 2),
          298 : (0, 3, 0, 3, 2, 1),
          299 : (0, 3, 1, 0, 0, 2),
          300 : (0, 3, 1, 0, 1, 2),
          301 : (0, 3, 1, 0, 2, 0),
          302 : (0, 3, 1, 0, 2, 1),
          303 : (0, 3, 1, 0, 2, 2),
          304 : (0, 3, 1, 0, 2, 3),
          305 : (0, 3, 1, 0, 3, 2),
          306 : (0, 3, 1, 1, 0, 2),
          307 : (0, 3, 1, 1, 1, 2),
          308 : (0, 3, 1, 1, 2, 0),
          309 : (0, 3, 1, 1, 2, 1),
          310 : (0, 3, 1, 1, 2, 2),
          311 : (0, 3, 1, 1, 2, 3),
          312 : (0, 3, 1, 1, 3, 2),
          313 : (0, 3, 1, 2, 0, 0),
          314 : (0, 3, 1, 2, 0, 1),
          315 : (0, 3, 1, 2, 0, 2),
          316 : (0, 3, 1, 2, 0, 3),
          317 : (0, 3, 1, 2, 1, 0),
          318 : (0, 3, 1, 2, 1, 1),
          319 : (0, 3, 1, 2, 1, 2),
          320 : (0, 3, 1, 2, 1, 3),
          321 : (0, 3, 1, 2, 2, 0),
          322 : (0, 3, 1, 2, 2, 1),
          323 : (0, 3, 1, 2, 2, 2),
          324 : (0, 3, 1, 2, 2, 3),
          325 : (0, 3, 1, 2, 3, 0),
          326 : (0, 3, 1, 2, 3, 1),
          327 : (0, 3, 1, 2, 3, 2),
          328 : (0, 3, 1, 2, 3, 3),
          329 : (0, 3, 1, 3, 0, 2),
          330 : (0, 3, 1, 3, 1, 2),
          331 : (0, 3, 1, 3, 2, 0),
          332 : (0, 3, 1, 3, 2, 1),
          333 : (0, 3, 1, 3, 2, 2),
          334 : (0, 3, 1, 3, 2, 3),
          335 : (0, 3, 1, 3, 3, 2),
          336 : (0, 3, 2, 0, 0, 1),
          337 : (0, 3, 2, 0, 1, 0),
          338 : (0, 3, 2, 0, 1, 1),
          339 : (0, 3, 2, 0, 1, 2),
          340 : (0, 3, 2, 0, 1, 3),
          341 : (0, 3, 2, 0, 2, 1),
          342 : (0, 3, 2, 0, 3, 1),
          343 : (0, 3, 2, 1, 0, 0),
          344 : (0, 3, 2, 1, 0, 1),
          345 : (0, 3, 2, 1, 0, 2),
          346 : (0, 3, 2, 1, 0, 3),
          347 : (0, 3, 2, 1, 1, 0),
          348 : (0, 3, 2, 1, 1, 1),
          349 : (0, 3, 2, 1, 1, 2),
          350 : (0, 3, 2, 1, 1, 3),
          351 : (0, 3, 2, 1, 2, 0),
          352 : (0, 3, 2, 1, 2, 1),
          353 : (0, 3, 2, 1, 2, 2),
          354 : (0, 3, 2, 1, 2, 3),
          355 : (0, 3, 2, 1, 3, 0),
          356 : (0, 3, 2, 1, 3, 1),
          357 : (0, 3, 2, 1, 3, 2),
          358 : (0, 3, 2, 1, 3, 3),
          359 : (0, 3, 2, 2, 0, 1),
          360 : (0, 3, 2, 2, 1, 0),
          361 : (0, 3, 2, 2, 1, 1),
          362 : (0, 3, 2, 2, 1, 2),
          363 : (0, 3, 2, 2, 1, 3),
          364 : (0, 3, 2, 2, 2, 1),
          365 : (0, 3, 2, 2, 3, 1),
          366 : (0, 3, 2, 3, 0, 1),
          367 : (0, 3, 2, 3, 1, 0),
          368 : (0, 3, 2, 3, 1, 1),
          369 : (0, 3, 2, 3, 1, 2),
          370 : (0, 3, 2, 3, 1, 3),
          371 : (0, 3, 2, 3, 2, 1),
          372 : (0, 3, 2, 3, 3, 1),
          373 : (0, 3, 3, 0, 1, 2),
          374 : (0, 3, 3, 0, 2, 1),
          375 : (0, 3, 3, 1, 0, 2),
          376 : (0, 3, 3, 1, 1, 2),
          377 : (0, 3, 3, 1, 2, 0),
          378 : (0, 3, 3, 1, 2, 1),
          379 : (0, 3, 3, 1, 2, 2),
          380 : (0, 3, 3, 1, 2, 3),
          381 : (0, 3, 3, 1, 3, 2),
          382 : (0, 3, 3, 2, 0, 1),
          383 : (0, 3, 3, 2, 1, 0),
          384 : (0, 3, 3, 2, 1, 1),
          385 : (0, 3, 3, 2, 1, 2),
          386 : (0, 3, 3, 2, 1, 3),
          387 : (0, 3, 3, 2, 2, 1),
          388 : (0, 3, 3, 2, 3, 1),
          389 : (0, 3, 3, 3, 1, 2),
          390 : (0, 3, 3, 3, 2, 1),
          391 : (1, 0, 0, 0, 2, 3),
          392 : (1, 0, 0, 0, 3, 2),
          393 : (1, 0, 0, 1, 2, 3),
          394 : (1, 0, 0, 1, 3, 2),
          395 : (1, 0, 0, 2, 0, 3),
          396 : (1, 0, 0, 2, 1, 3),
          397 : (1, 0, 0, 2, 2, 3),
          398 : (1, 0, 0, 2, 3, 0),
          399 : (1, 0, 0, 2, 3, 1),
          400 : (1, 0, 0, 2, 3, 2),
          401 : (1, 0, 0, 2, 3, 3),
          402 : (1, 0, 0, 3, 0, 2),
          403 : (1, 0, 0, 3, 1, 2),
          404 : (1, 0, 0, 3, 2, 0),
          405 : (1, 0, 0, 3, 2, 1),
          406 : (1, 0, 0, 3, 2, 2),
          407 : (1, 0, 0, 3, 2, 3),
          408 : (1, 0, 0, 3, 3, 2),
          409 : (1, 0, 1, 0, 2, 3),
          410 : (1, 0, 1, 0, 3, 2),
          411 : (1, 0, 1, 1, 2, 3),
          412 : (1, 0, 1, 1, 3, 2),
          413 : (1, 0, 1, 2, 0, 3),
          414 : (1, 0, 1, 2, 1, 3),
          415 : (1, 0, 1, 2, 2, 3),
          416 : (1, 0, 1, 2, 3, 0),
          417 : (1, 0, 1, 2, 3, 1),
          418 : (1, 0, 1, 2, 3, 2),
          419 : (1, 0, 1, 2, 3, 3),
          420 : (1, 0, 1, 3, 0, 2),
          421 : (1, 0, 1, 3, 1, 2),
          422 : (1, 0, 1, 3, 2, 0),
          423 : (1, 0, 1, 3, 2, 1),
          424 : (1, 0, 1, 3, 2, 2),
          425 : (1, 0, 1, 3, 2, 3),
          426 : (1, 0, 1, 3, 3, 2),
          427 : (1, 0, 2, 0, 0, 3),
          428 : (1, 0, 2, 0, 1, 3),
          429 : (1, 0, 2, 0, 2, 3),
          430 : (1, 0, 2, 0, 3, 0),
          431 : (1, 0, 2, 0, 3, 1),
          432 : (1, 0, 2, 0, 3, 2),
          433 : (1, 0, 2, 0, 3, 3),
          434 : (1, 0, 2, 1, 0, 3),
          435 : (1, 0, 2, 1, 1, 3),
          436 : (1, 0, 2, 1, 2, 3),
          437 : (1, 0, 2, 1, 3, 0),
          438 : (1, 0, 2, 1, 3, 1),
          439 : (1, 0, 2, 1, 3, 2),
          440 : (1, 0, 2, 1, 3, 3),
          441 : (1, 0, 2, 2, 0, 3),
          442 : (1, 0, 2, 2, 1, 3),
          443 : (1, 0, 2, 2, 2, 3),
          444 : (1, 0, 2, 2, 3, 0),
          445 : (1, 0, 2, 2, 3, 1),
          446 : (1, 0, 2, 2, 3, 2),
          447 : (1, 0, 2, 2, 3, 3),
          448 : (1, 0, 2, 3, 0, 0),
          449 : (1, 0, 2, 3, 0, 1),
          450 : (1, 0, 2, 3, 0, 2),
          451 : (1, 0, 2, 3, 0, 3),
          452 : (1, 0, 2, 3, 1, 0),
          453 : (1, 0, 2, 3, 1, 1),
          454 : (1, 0, 2, 3, 1, 2),
          455 : (1, 0, 2, 3, 1, 3),
          456 : (1, 0, 2, 3, 2, 0),
          457 : (1, 0, 2, 3, 2, 1),
          458 : (1, 0, 2, 3, 2, 2),
          459 : (1, 0, 2, 3, 2, 3),
          460 : (1, 0, 2, 3, 3, 0),
          461 : (1, 0, 2, 3, 3, 1),
          462 : (1, 0, 2, 3, 3, 2),
          463 : (1, 0, 2, 3, 3, 3),
          464 : (1, 0, 3, 0, 0, 2),
          465 : (1, 0, 3, 0, 1, 2),
          466 : (1, 0, 3, 0, 2, 0),
          467 : (1, 0, 3, 0, 2, 1),
          468 : (1, 0, 3, 0, 2, 2),
          469 : (1, 0, 3, 0, 2, 3),
          470 : (1, 0, 3, 0, 3, 2),
          471 : (1, 0, 3, 1, 0, 2),
          472 : (1, 0, 3, 1, 1, 2),
          473 : (1, 0, 3, 1, 2, 0),
          474 : (1, 0, 3, 1, 2, 1),
          475 : (1, 0, 3, 1, 2, 2),
          476 : (1, 0, 3, 1, 2, 3),
          477 : (1, 0, 3, 1, 3, 2),
          478 : (1, 0, 3, 2, 0, 0),
          479 : (1, 0, 3, 2, 0, 1),
          480 : (1, 0, 3, 2, 0, 2),
          481 : (1, 0, 3, 2, 0, 3),
          482 : (1, 0, 3, 2, 1, 0),
          483 : (1, 0, 3, 2, 1, 1),
          484 : (1, 0, 3, 2, 1, 2),
          485 : (1, 0, 3, 2, 1, 3),
          486 : (1, 0, 3, 2, 2, 0),
          487 : (1, 0, 3, 2, 2, 1),
          488 : (1, 0, 3, 2, 2, 2),
          489 : (1, 0, 3, 2, 2, 3),
          490 : (1, 0, 3, 2, 3, 0),
          491 : (1, 0, 3, 2, 3, 1),
          492 : (1, 0, 3, 2, 3, 2),
          493 : (1, 0, 3, 2, 3, 3),
          494 : (1, 0, 3, 3, 0, 2),
          495 : (1, 0, 3, 3, 1, 2),
          496 : (1, 0, 3, 3, 2, 0),
          497 : (1, 0, 3, 3, 2, 1),
          498 : (1, 0, 3, 3, 2, 2),
          499 : (1, 0, 3, 3, 2, 3),
          500 : (1, 0, 3, 3, 3, 2),
          501 : (1, 1, 0, 0, 2, 3),
          502 : (1, 1, 0, 0, 3, 2),
          503 : (1, 1, 0, 1, 2, 3),
          504 : (1, 1, 0, 1, 3, 2),
          505 : (1, 1, 0, 2, 0, 3),
          506 : (1, 1, 0, 2, 1, 3),
          507 : (1, 1, 0, 2, 2, 3),
          508 : (1, 1, 0, 2, 3, 0),
          509 : (1, 1, 0, 2, 3, 1),
          510 : (1, 1, 0, 2, 3, 2),
          511 : (1, 1, 0, 2, 3, 3),
          512 : (1, 1, 0, 3, 0, 2),
          513 : (1, 1, 0, 3, 1, 2),
          514 : (1, 1, 0, 3, 2, 0),
          515 : (1, 1, 0, 3, 2, 1),
          516 : (1, 1, 0, 3, 2, 2),
          517 : (1, 1, 0, 3, 2, 3),
          518 : (1, 1, 0, 3, 3, 2),
          519 : (1, 1, 1, 0, 2, 3),
          520 : (1, 1, 1, 0, 3, 2),
          521 : (1, 1, 1, 2, 0, 3),
          522 : (1, 1, 1, 2, 3, 0),
          523 : (1, 1, 1, 3, 0, 2),
          524 : (1, 1, 1, 3, 2, 0),
          525 : (1, 1, 2, 0, 0, 3),
          526 : (1, 1, 2, 0, 1, 3),
          527 : (1, 1, 2, 0, 2, 3),
          528 : (1, 1, 2, 0, 3, 0),
          529 : (1, 1, 2, 0, 3, 1),
          530 : (1, 1, 2, 0, 3, 2),
          531 : (1, 1, 2, 0, 3, 3),
          532 : (1, 1, 2, 1, 0, 3),
          533 : (1, 1, 2, 1, 3, 0),
          534 : (1, 1, 2, 2, 0, 3),
          535 : (1, 1, 2, 2, 3, 0),
          536 : (1, 1, 2, 3, 0, 0),
          537 : (1, 1, 2, 3, 0, 1),
          538 : (1, 1, 2, 3, 0, 2),
          539 : (1, 1, 2, 3, 0, 3),
          540 : (1, 1, 2, 3, 1, 0),
          541 : (1, 1, 2, 3, 2, 0),
          542 : (1, 1, 2, 3, 3, 0),
          543 : (1, 1, 3, 0, 0, 2),
          544 : (1, 1, 3, 0, 1, 2),
          545 : (1, 1, 3, 0, 2, 0),
          546 : (1, 1, 3, 0, 2, 1),
          547 : (1, 1, 3, 0, 2, 2),
          548 : (1, 1, 3, 0, 2, 3),
          549 : (1, 1, 3, 0, 3, 2),
          550 : (1, 1, 3, 1, 0, 2),
          551 : (1, 1, 3, 1, 2, 0),
          552 : (1, 1, 3, 2, 0, 0),
          553 : (1, 1, 3, 2, 0, 1),
          554 : (1, 1, 3, 2, 0, 2),
          555 : (1, 1, 3, 2, 0, 3),
          556 : (1, 1, 3, 2, 1, 0),
          557 : (1, 1, 3, 2, 2, 0),
          558 : (1, 1, 3, 2, 3, 0),
          559 : (1, 1, 3, 3, 0, 2),
          560 : (1, 1, 3, 3, 2, 0),
          561 : (1, 2, 0, 0, 0, 3),
          562 : (1, 2, 0, 0, 1, 3),
          563 : (1, 2, 0, 0, 2, 3),
          564 : (1, 2, 0, 0, 3, 0),
          565 : (1, 2, 0, 0, 3, 1),
          566 : (1, 2, 0, 0, 3, 2),
          567 : (1, 2, 0, 0, 3, 3),
          568 : (1, 2, 0, 1, 0, 3),
          569 : (1, 2, 0, 1, 1, 3),
          570 : (1, 2, 0, 1, 2, 3),
          571 : (1, 2, 0, 1, 3, 0),
          572 : (1, 2, 0, 1, 3, 1),
          573 : (1, 2, 0, 1, 3, 2),
          574 : (1, 2, 0, 1, 3, 3),
          575 : (1, 2, 0, 2, 0, 3),
          576 : (1, 2, 0, 2, 1, 3),
          577 : (1, 2, 0, 2, 2, 3),
          578 : (1, 2, 0, 2, 3, 0),
          579 : (1, 2, 0, 2, 3, 1),
          580 : (1, 2, 0, 2, 3, 2),
          581 : (1, 2, 0, 2, 3, 3),
          582 : (1, 2, 0, 3, 0, 0),
          583 : (1, 2, 0, 3, 0, 1),
          584 : (1, 2, 0, 3, 0, 2),
          585 : (1, 2, 0, 3, 0, 3),
          586 : (1, 2, 0, 3, 1, 0),
          587 : (1, 2, 0, 3, 1, 1),
          588 : (1, 2, 0, 3, 1, 2),
          589 : (1, 2, 0, 3, 1, 3),
          590 : (1, 2, 0, 3, 2, 0),
          591 : (1, 2, 0, 3, 2, 1),
          592 : (1, 2, 0, 3, 2, 2),
          593 : (1, 2, 0, 3, 2, 3),
          594 : (1, 2, 0, 3, 3, 0),
          595 : (1, 2, 0, 3, 3, 1),
          596 : (1, 2, 0, 3, 3, 2),
          597 : (1, 2, 0, 3, 3, 3),
          598 : (1, 2, 1, 0, 0, 3),
          599 : (1, 2, 1, 0, 1, 3),
          600 : (1, 2, 1, 0, 2, 3),
          601 : (1, 2, 1, 0, 3, 0),
          602 : (1, 2, 1, 0, 3, 1),
          603 : (1, 2, 1, 0, 3, 2),
          604 : (1, 2, 1, 0, 3, 3),
          605 : (1, 2, 1, 1, 0, 3),
          606 : (1, 2, 1, 1, 3, 0),
          607 : (1, 2, 1, 2, 0, 3),
          608 : (1, 2, 1, 2, 3, 0),
          609 : (1, 2, 1, 3, 0, 0),
          610 : (1, 2, 1, 3, 0, 1),
          611 : (1, 2, 1, 3, 0, 2),
          612 : (1, 2, 1, 3, 0, 3),
          613 : (1, 2, 1, 3, 1, 0),
          614 : (1, 2, 1, 3, 2, 0),
          615 : (1, 2, 1, 3, 3, 0),
          616 : (1, 2, 2, 0, 0, 3),
          617 : (1, 2, 2, 0, 1, 3),
          618 : (1, 2, 2, 0, 2, 3),
          619 : (1, 2, 2, 0, 3, 0),
          620 : (1, 2, 2, 0, 3, 1),
          621 : (1, 2, 2, 0, 3, 2),
          622 : (1, 2, 2, 0, 3, 3),
          623 : (1, 2, 2, 1, 0, 3),
          624 : (1, 2, 2, 1, 3, 0),
          625 : (1, 2, 2, 2, 0, 3),
          626 : (1, 2, 2, 2, 3, 0),
          627 : (1, 2, 2, 3, 0, 0),
          628 : (1, 2, 2, 3, 0, 1),
          629 : (1, 2, 2, 3, 0, 2),
          630 : (1, 2, 2, 3, 0, 3),
          631 : (1, 2, 2, 3, 1, 0),
          632 : (1, 2, 2, 3, 2, 0),
          633 : (1, 2, 2, 3, 3, 0),
          634 : (1, 2, 3, 0, 0, 0),
          635 : (1, 2, 3, 0, 0, 1),
          636 : (1, 2, 3, 0, 0, 2),
          637 : (1, 2, 3, 0, 0, 3),
          638 : (1, 2, 3, 0, 1, 0),
          639 : (1, 2, 3, 0, 1, 1),
          640 : (1, 2, 3, 0, 1, 2),
          641 : (1, 2, 3, 0, 1, 3),
          642 : (1, 2, 3, 0, 2, 0),
          643 : (1, 2, 3, 0, 2, 1),
          644 : (1, 2, 3, 0, 2, 2),
          645 : (1, 2, 3, 0, 2, 3),
          646 : (1, 2, 3, 0, 3, 0),
          647 : (1, 2, 3, 0, 3, 1),
          648 : (1, 2, 3, 0, 3, 2),
          649 : (1, 2, 3, 0, 3, 3),
          650 : (1, 2, 3, 1, 0, 0),
          651 : (1, 2, 3, 1, 0, 1),
          652 : (1, 2, 3, 1, 0, 2),
          653 : (1, 2, 3, 1, 0, 3),
          654 : (1, 2, 3, 1, 1, 0),
          655 : (1, 2, 3, 1, 2, 0),
          656 : (1, 2, 3, 1, 3, 0),
          657 : (1, 2, 3, 2, 0, 0),
          658 : (1, 2, 3, 2, 0, 1),
          659 : (1, 2, 3, 2, 0, 2),
          660 : (1, 2, 3, 2, 0, 3),
          661 : (1, 2, 3, 2, 1, 0),
          662 : (1, 2, 3, 2, 2, 0),
          663 : (1, 2, 3, 2, 3, 0),
          664 : (1, 2, 3, 3, 0, 0),
          665 : (1, 2, 3, 3, 0, 1),
          666 : (1, 2, 3, 3, 0, 2),
          667 : (1, 2, 3, 3, 0, 3),
          668 : (1, 2, 3, 3, 1, 0),
          669 : (1, 2, 3, 3, 2, 0),
          670 : (1, 2, 3, 3, 3, 0),
          671 : (1, 3, 0, 0, 0, 2),
          672 : (1, 3, 0, 0, 1, 2),
          673 : (1, 3, 0, 0, 2, 0),
          674 : (1, 3, 0, 0, 2, 1),
          675 : (1, 3, 0, 0, 2, 2),
          676 : (1, 3, 0, 0, 2, 3),
          677 : (1, 3, 0, 0, 3, 2),
          678 : (1, 3, 0, 1, 0, 2),
          679 : (1, 3, 0, 1, 1, 2),
          680 : (1, 3, 0, 1, 2, 0),
          681 : (1, 3, 0, 1, 2, 1),
          682 : (1, 3, 0, 1, 2, 2),
          683 : (1, 3, 0, 1, 2, 3),
          684 : (1, 3, 0, 1, 3, 2),
          685 : (1, 3, 0, 2, 0, 0),
          686 : (1, 3, 0, 2, 0, 1),
          687 : (1, 3, 0, 2, 0, 2),
          688 : (1, 3, 0, 2, 0, 3),
          689 : (1, 3, 0, 2, 1, 0),
          690 : (1, 3, 0, 2, 1, 1),
          691 : (1, 3, 0, 2, 1, 2),
          692 : (1, 3, 0, 2, 1, 3),
          693 : (1, 3, 0, 2, 2, 0),
          694 : (1, 3, 0, 2, 2, 1),
          695 : (1, 3, 0, 2, 2, 2),
          696 : (1, 3, 0, 2, 2, 3),
          697 : (1, 3, 0, 2, 3, 0),
          698 : (1, 3, 0, 2, 3, 1),
          699 : (1, 3, 0, 2, 3, 2),
          700 : (1, 3, 0, 2, 3, 3),
          701 : (1, 3, 0, 3, 0, 2),
          702 : (1, 3, 0, 3, 1, 2),
          703 : (1, 3, 0, 3, 2, 0),
          704 : (1, 3, 0, 3, 2, 1),
          705 : (1, 3, 0, 3, 2, 2),
          706 : (1, 3, 0, 3, 2, 3),
          707 : (1, 3, 0, 3, 3, 2),
          708 : (1, 3, 1, 0, 0, 2),
          709 : (1, 3, 1, 0, 1, 2),
          710 : (1, 3, 1, 0, 2, 0),
          711 : (1, 3, 1, 0, 2, 1),
          712 : (1, 3, 1, 0, 2, 2),
          713 : (1, 3, 1, 0, 2, 3),
          714 : (1, 3, 1, 0, 3, 2),
          715 : (1, 3, 1, 1, 0, 2),
          716 : (1, 3, 1, 1, 2, 0),
          717 : (1, 3, 1, 2, 0, 0),
          718 : (1, 3, 1, 2, 0, 1),
          719 : (1, 3, 1, 2, 0, 2),
          720 : (1, 3, 1, 2, 0, 3),
          721 : (1, 3, 1, 2, 1, 0),
          722 : (1, 3, 1, 2, 2, 0),
          723 : (1, 3, 1, 2, 3, 0),
          724 : (1, 3, 1, 3, 0, 2),
          725 : (1, 3, 1, 3, 2, 0),
          726 : (1, 3, 2, 0, 0, 0),
          727 : (1, 3, 2, 0, 0, 1),
          728 : (1, 3, 2, 0, 0, 2),
          729 : (1, 3, 2, 0, 0, 3),
          730 : (1, 3, 2, 0, 1, 0),
          731 : (1, 3, 2, 0, 1, 1),
          732 : (1, 3, 2, 0, 1, 2),
          733 : (1, 3, 2, 0, 1, 3),
          734 : (1, 3, 2, 0, 2, 0),
          735 : (1, 3, 2, 0, 2, 1),
          736 : (1, 3, 2, 0, 2, 2),
          737 : (1, 3, 2, 0, 2, 3),
          738 : (1, 3, 2, 0, 3, 0),
          739 : (1, 3, 2, 0, 3, 1),
          740 : (1, 3, 2, 0, 3, 2),
          741 : (1, 3, 2, 0, 3, 3),
          742 : (1, 3, 2, 1, 0, 0),
          743 : (1, 3, 2, 1, 0, 1),
          744 : (1, 3, 2, 1, 0, 2),
          745 : (1, 3, 2, 1, 0, 3),
          746 : (1, 3, 2, 1, 1, 0),
          747 : (1, 3, 2, 1, 2, 0),
          748 : (1, 3, 2, 1, 3, 0),
          749 : (1, 3, 2, 2, 0, 0),
          750 : (1, 3, 2, 2, 0, 1),
          751 : (1, 3, 2, 2, 0, 2),
          752 : (1, 3, 2, 2, 0, 3),
          753 : (1, 3, 2, 2, 1, 0),
          754 : (1, 3, 2, 2, 2, 0),
          755 : (1, 3, 2, 2, 3, 0),
          756 : (1, 3, 2, 3, 0, 0),
          757 : (1, 3, 2, 3, 0, 1),
          758 : (1, 3, 2, 3, 0, 2),
          759 : (1, 3, 2, 3, 0, 3),
          760 : (1, 3, 2, 3, 1, 0),
          761 : (1, 3, 2, 3, 2, 0),
          762 : (1, 3, 2, 3, 3, 0),
          763 : (1, 3, 3, 0, 0, 2),
          764 : (1, 3, 3, 0, 1, 2),
          765 : (1, 3, 3, 0, 2, 0),
          766 : (1, 3, 3, 0, 2, 1),
          767 : (1, 3, 3, 0, 2, 2),
          768 : (1, 3, 3, 0, 2, 3),
          769 : (1, 3, 3, 0, 3, 2),
          770 : (1, 3, 3, 1, 0, 2),
          771 : (1, 3, 3, 1, 2, 0),
          772 : (1, 3, 3, 2, 0, 0),
          773 : (1, 3, 3, 2, 0, 1),
          774 : (1, 3, 3, 2, 0, 2),
          775 : (1, 3, 3, 2, 0, 3),
          776 : (1, 3, 3, 2, 1, 0),
          777 : (1, 3, 3, 2, 2, 0),
          778 : (1, 3, 3, 2, 3, 0),
          779 : (1, 3, 3, 3, 0, 2),
          780 : (1, 3, 3, 3, 2, 0),
          781 : (2, 0, 0, 0, 1, 3),
          782 : (2, 0, 0, 0, 3, 1),
          783 : (2, 0, 0, 1, 0, 3),
          784 : (2, 0, 0, 1, 1, 3),
          785 : (2, 0, 0, 1, 2, 3),
          786 : (2, 0, 0, 1, 3, 0),
          787 : (2, 0, 0, 1, 3, 1),
          788 : (2, 0, 0, 1, 3, 2),
          789 : (2, 0, 0, 1, 3, 3),
          790 : (2, 0, 0, 2, 1, 3),
          791 : (2, 0, 0, 2, 3, 1),
          792 : (2, 0, 0, 3, 0, 1),
          793 : (2, 0, 0, 3, 1, 0),
          794 : (2, 0, 0, 3, 1, 1),
          795 : (2, 0, 0, 3, 1, 2),
          796 : (2, 0, 0, 3, 1, 3),
          797 : (2, 0, 0, 3, 2, 1),
          798 : (2, 0, 0, 3, 3, 1),
          799 : (2, 0, 1, 0, 0, 3),
          800 : (2, 0, 1, 0, 1, 3),
          801 : (2, 0, 1, 0, 2, 3),
          802 : (2, 0, 1, 0, 3, 0),
          803 : (2, 0, 1, 0, 3, 1),
          804 : (2, 0, 1, 0, 3, 2),
          805 : (2, 0, 1, 0, 3, 3),
          806 : (2, 0, 1, 1, 0, 3),
          807 : (2, 0, 1, 1, 1, 3),
          808 : (2, 0, 1, 1, 2, 3),
          809 : (2, 0, 1, 1, 3, 0),
          810 : (2, 0, 1, 1, 3, 1),
          811 : (2, 0, 1, 1, 3, 2),
          812 : (2, 0, 1, 1, 3, 3),
          813 : (2, 0, 1, 2, 0, 3),
          814 : (2, 0, 1, 2, 1, 3),
          815 : (2, 0, 1, 2, 2, 3),
          816 : (2, 0, 1, 2, 3, 0),
          817 : (2, 0, 1, 2, 3, 1),
          818 : (2, 0, 1, 2, 3, 2),
          819 : (2, 0, 1, 2, 3, 3),
          820 : (2, 0, 1, 3, 0, 0),
          821 : (2, 0, 1, 3, 0, 1),
          822 : (2, 0, 1, 3, 0, 2),
          823 : (2, 0, 1, 3, 0, 3),
          824 : (2, 0, 1, 3, 1, 0),
          825 : (2, 0, 1, 3, 1, 1),
          826 : (2, 0, 1, 3, 1, 2),
          827 : (2, 0, 1, 3, 1, 3),
          828 : (2, 0, 1, 3, 2, 0),
          829 : (2, 0, 1, 3, 2, 1),
          830 : (2, 0, 1, 3, 2, 2),
          831 : (2, 0, 1, 3, 2, 3),
          832 : (2, 0, 1, 3, 3, 0),
          833 : (2, 0, 1, 3, 3, 1),
          834 : (2, 0, 1, 3, 3, 2),
          835 : (2, 0, 1, 3, 3, 3),
          836 : (2, 0, 2, 0, 1, 3),
          837 : (2, 0, 2, 0, 3, 1),
          838 : (2, 0, 2, 1, 0, 3),
          839 : (2, 0, 2, 1, 1, 3),
          840 : (2, 0, 2, 1, 2, 3),
          841 : (2, 0, 2, 1, 3, 0),
          842 : (2, 0, 2, 1, 3, 1),
          843 : (2, 0, 2, 1, 3, 2),
          844 : (2, 0, 2, 1, 3, 3),
          845 : (2, 0, 2, 2, 1, 3),
          846 : (2, 0, 2, 2, 3, 1),
          847 : (2, 0, 2, 3, 0, 1),
          848 : (2, 0, 2, 3, 1, 0),
          849 : (2, 0, 2, 3, 1, 1),
          850 : (2, 0, 2, 3, 1, 2),
          851 : (2, 0, 2, 3, 1, 3),
          852 : (2, 0, 2, 3, 2, 1),
          853 : (2, 0, 2, 3, 3, 1),
          854 : (2, 0, 3, 0, 0, 1),
          855 : (2, 0, 3, 0, 1, 0),
          856 : (2, 0, 3, 0, 1, 1),
          857 : (2, 0, 3, 0, 1, 2),
          858 : (2, 0, 3, 0, 1, 3),
          859 : (2, 0, 3, 0, 2, 1),
          860 : (2, 0, 3, 0, 3, 1),
          861 : (2, 0, 3, 1, 0, 0),
          862 : (2, 0, 3, 1, 0, 1),
          863 : (2, 0, 3, 1, 0, 2),
          864 : (2, 0, 3, 1, 0, 3),
          865 : (2, 0, 3, 1, 1, 0),
          866 : (2, 0, 3, 1, 1, 1),
          867 : (2, 0, 3, 1, 1, 2),
          868 : (2, 0, 3, 1, 1, 3),
          869 : (2, 0, 3, 1, 2, 0),
          870 : (2, 0, 3, 1, 2, 1),
          871 : (2, 0, 3, 1, 2, 2),
          872 : (2, 0, 3, 1, 2, 3),
          873 : (2, 0, 3, 1, 3, 0),
          874 : (2, 0, 3, 1, 3, 1),
          875 : (2, 0, 3, 1, 3, 2),
          876 : (2, 0, 3, 1, 3, 3),
          877 : (2, 0, 3, 2, 0, 1),
          878 : (2, 0, 3, 2, 1, 0),
          879 : (2, 0, 3, 2, 1, 1),
          880 : (2, 0, 3, 2, 1, 2),
          881 : (2, 0, 3, 2, 1, 3),
          882 : (2, 0, 3, 2, 2, 1),
          883 : (2, 0, 3, 2, 3, 1),
          884 : (2, 0, 3, 3, 0, 1),
          885 : (2, 0, 3, 3, 1, 0),
          886 : (2, 0, 3, 3, 1, 1),
          887 : (2, 0, 3, 3, 1, 2),
          888 : (2, 0, 3, 3, 1, 3),
          889 : (2, 0, 3, 3, 2, 1),
          890 : (2, 0, 3, 3, 3, 1),
          891 : (2, 1, 0, 0, 0, 3),
          892 : (2, 1, 0, 0, 1, 3),
          893 : (2, 1, 0, 0, 2, 3),
          894 : (2, 1, 0, 0, 3, 0),
          895 : (2, 1, 0, 0, 3, 1),
          896 : (2, 1, 0, 0, 3, 2),
          897 : (2, 1, 0, 0, 3, 3),
          898 : (2, 1, 0, 1, 0, 3),
          899 : (2, 1, 0, 1, 1, 3),
          900 : (2, 1, 0, 1, 2, 3),
          901 : (2, 1, 0, 1, 3, 0),
          902 : (2, 1, 0, 1, 3, 1),
          903 : (2, 1, 0, 1, 3, 2),
          904 : (2, 1, 0, 1, 3, 3),
          905 : (2, 1, 0, 2, 0, 3),
          906 : (2, 1, 0, 2, 1, 3),
          907 : (2, 1, 0, 2, 2, 3),
          908 : (2, 1, 0, 2, 3, 0),
          909 : (2, 1, 0, 2, 3, 1),
          910 : (2, 1, 0, 2, 3, 2),
          911 : (2, 1, 0, 2, 3, 3),
          912 : (2, 1, 0, 3, 0, 0),
          913 : (2, 1, 0, 3, 0, 1),
          914 : (2, 1, 0, 3, 0, 2),
          915 : (2, 1, 0, 3, 0, 3),
          916 : (2, 1, 0, 3, 1, 0),
          917 : (2, 1, 0, 3, 1, 1),
          918 : (2, 1, 0, 3, 1, 2),
          919 : (2, 1, 0, 3, 1, 3),
          920 : (2, 1, 0, 3, 2, 0),
          921 : (2, 1, 0, 3, 2, 1),
          922 : (2, 1, 0, 3, 2, 2),
          923 : (2, 1, 0, 3, 2, 3),
          924 : (2, 1, 0, 3, 3, 0),
          925 : (2, 1, 0, 3, 3, 1),
          926 : (2, 1, 0, 3, 3, 2),
          927 : (2, 1, 0, 3, 3, 3),
          928 : (2, 1, 1, 0, 0, 3),
          929 : (2, 1, 1, 0, 1, 3),
          930 : (2, 1, 1, 0, 2, 3),
          931 : (2, 1, 1, 0, 3, 0),
          932 : (2, 1, 1, 0, 3, 1),
          933 : (2, 1, 1, 0, 3, 2),
          934 : (2, 1, 1, 0, 3, 3),
          935 : (2, 1, 1, 1, 0, 3),
          936 : (2, 1, 1, 1, 3, 0),
          937 : (2, 1, 1, 2, 0, 3),
          938 : (2, 1, 1, 2, 3, 0),
          939 : (2, 1, 1, 3, 0, 0),
          940 : (2, 1, 1, 3, 0, 1),
          941 : (2, 1, 1, 3, 0, 2),
          942 : (2, 1, 1, 3, 0, 3),
          943 : (2, 1, 1, 3, 1, 0),
          944 : (2, 1, 1, 3, 2, 0),
          945 : (2, 1, 1, 3, 3, 0),
          946 : (2, 1, 2, 0, 0, 3),
          947 : (2, 1, 2, 0, 1, 3),
          948 : (2, 1, 2, 0, 2, 3),
          949 : (2, 1, 2, 0, 3, 0),
          950 : (2, 1, 2, 0, 3, 1),
          951 : (2, 1, 2, 0, 3, 2),
          952 : (2, 1, 2, 0, 3, 3),
          953 : (2, 1, 2, 1, 0, 3),
          954 : (2, 1, 2, 1, 3, 0),
          955 : (2, 1, 2, 2, 0, 3),
          956 : (2, 1, 2, 2, 3, 0),
          957 : (2, 1, 2, 3, 0, 0),
          958 : (2, 1, 2, 3, 0, 1),
          959 : (2, 1, 2, 3, 0, 2),
          960 : (2, 1, 2, 3, 0, 3),
          961 : (2, 1, 2, 3, 1, 0),
          962 : (2, 1, 2, 3, 2, 0),
          963 : (2, 1, 2, 3, 3, 0),
          964 : (2, 1, 3, 0, 0, 0),
          965 : (2, 1, 3, 0, 0, 1),
          966 : (2, 1, 3, 0, 0, 2),
          967 : (2, 1, 3, 0, 0, 3),
          968 : (2, 1, 3, 0, 1, 0),
          969 : (2, 1, 3, 0, 1, 1),
          970 : (2, 1, 3, 0, 1, 2),
          971 : (2, 1, 3, 0, 1, 3),
          972 : (2, 1, 3, 0, 2, 0),
          973 : (2, 1, 3, 0, 2, 1),
          974 : (2, 1, 3, 0, 2, 2),
          975 : (2, 1, 3, 0, 2, 3),
          976 : (2, 1, 3, 0, 3, 0),
          977 : (2, 1, 3, 0, 3, 1),
          978 : (2, 1, 3, 0, 3, 2),
          979 : (2, 1, 3, 0, 3, 3),
          980 : (2, 1, 3, 1, 0, 0),
          981 : (2, 1, 3, 1, 0, 1),
          982 : (2, 1, 3, 1, 0, 2),
          983 : (2, 1, 3, 1, 0, 3),
          984 : (2, 1, 3, 1, 1, 0),
          985 : (2, 1, 3, 1, 2, 0),
          986 : (2, 1, 3, 1, 3, 0),
          987 : (2, 1, 3, 2, 0, 0),
          988 : (2, 1, 3, 2, 0, 1),
          989 : (2, 1, 3, 2, 0, 2),
          990 : (2, 1, 3, 2, 0, 3),
          991 : (2, 1, 3, 2, 1, 0),
          992 : (2, 1, 3, 2, 2, 0),
          993 : (2, 1, 3, 2, 3, 0),
          994 : (2, 1, 3, 3, 0, 0),
          995 : (2, 1, 3, 3, 0, 1),
          996 : (2, 1, 3, 3, 0, 2),
          997 : (2, 1, 3, 3, 0, 3),
          998 : (2, 1, 3, 3, 1, 0),
          999 : (2, 1, 3, 3, 2, 0),
          1000 : (2, 1, 3, 3, 3, 0),
          1001 : (2, 2, 0, 0, 1, 3),
          1002 : (2, 2, 0, 0, 3, 1),
          1003 : (2, 2, 0, 1, 0, 3),
          1004 : (2, 2, 0, 1, 1, 3),
          1005 : (2, 2, 0, 1, 2, 3),
          1006 : (2, 2, 0, 1, 3, 0),
          1007 : (2, 2, 0, 1, 3, 1),
          1008 : (2, 2, 0, 1, 3, 2),
          1009 : (2, 2, 0, 1, 3, 3),
          1010 : (2, 2, 0, 2, 1, 3),
          1011 : (2, 2, 0, 2, 3, 1),
          1012 : (2, 2, 0, 3, 0, 1),
          1013 : (2, 2, 0, 3, 1, 0),
          1014 : (2, 2, 0, 3, 1, 1),
          1015 : (2, 2, 0, 3, 1, 2),
          1016 : (2, 2, 0, 3, 1, 3),
          1017 : (2, 2, 0, 3, 2, 1),
          1018 : (2, 2, 0, 3, 3, 1),
          1019 : (2, 2, 1, 0, 0, 3),
          1020 : (2, 2, 1, 0, 1, 3),
          1021 : (2, 2, 1, 0, 2, 3),
          1022 : (2, 2, 1, 0, 3, 0),
          1023 : (2, 2, 1, 0, 3, 1),
          1024 : (2, 2, 1, 0, 3, 2),
          1025 : (2, 2, 1, 0, 3, 3),
          1026 : (2, 2, 1, 1, 0, 3),
          1027 : (2, 2, 1, 1, 3, 0),
          1028 : (2, 2, 1, 2, 0, 3),
          1029 : (2, 2, 1, 2, 3, 0),
          1030 : (2, 2, 1, 3, 0, 0),
          1031 : (2, 2, 1, 3, 0, 1),
          1032 : (2, 2, 1, 3, 0, 2),
          1033 : (2, 2, 1, 3, 0, 3),
          1034 : (2, 2, 1, 3, 1, 0),
          1035 : (2, 2, 1, 3, 2, 0),
          1036 : (2, 2, 1, 3, 3, 0),
          1037 : (2, 2, 2, 0, 1, 3),
          1038 : (2, 2, 2, 0, 3, 1),
          1039 : (2, 2, 2, 1, 0, 3),
          1040 : (2, 2, 2, 1, 3, 0),
          1041 : (2, 2, 2, 3, 0, 1),
          1042 : (2, 2, 2, 3, 1, 0),
          1043 : (2, 2, 3, 0, 0, 1),
          1044 : (2, 2, 3, 0, 1, 0),
          1045 : (2, 2, 3, 0, 1, 1),
          1046 : (2, 2, 3, 0, 1, 2),
          1047 : (2, 2, 3, 0, 1, 3),
          1048 : (2, 2, 3, 0, 2, 1),
          1049 : (2, 2, 3, 0, 3, 1),
          1050 : (2, 2, 3, 1, 0, 0),
          1051 : (2, 2, 3, 1, 0, 1),
          1052 : (2, 2, 3, 1, 0, 2),
          1053 : (2, 2, 3, 1, 0, 3),
          1054 : (2, 2, 3, 1, 1, 0),
          1055 : (2, 2, 3, 1, 2, 0),
          1056 : (2, 2, 3, 1, 3, 0),
          1057 : (2, 2, 3, 2, 0, 1),
          1058 : (2, 2, 3, 2, 1, 0),
          1059 : (2, 2, 3, 3, 0, 1),
          1060 : (2, 2, 3, 3, 1, 0),
          1061 : (2, 3, 0, 0, 0, 1),
          1062 : (2, 3, 0, 0, 1, 0),
          1063 : (2, 3, 0, 0, 1, 1),
          1064 : (2, 3, 0, 0, 1, 2),
          1065 : (2, 3, 0, 0, 1, 3),
          1066 : (2, 3, 0, 0, 2, 1),
          1067 : (2, 3, 0, 0, 3, 1),
          1068 : (2, 3, 0, 1, 0, 0),
          1069 : (2, 3, 0, 1, 0, 1),
          1070 : (2, 3, 0, 1, 0, 2),
          1071 : (2, 3, 0, 1, 0, 3),
          1072 : (2, 3, 0, 1, 1, 0),
          1073 : (2, 3, 0, 1, 1, 1),
          1074 : (2, 3, 0, 1, 1, 2),
          1075 : (2, 3, 0, 1, 1, 3),
          1076 : (2, 3, 0, 1, 2, 0),
          1077 : (2, 3, 0, 1, 2, 1),
          1078 : (2, 3, 0, 1, 2, 2),
          1079 : (2, 3, 0, 1, 2, 3),
          1080 : (2, 3, 0, 1, 3, 0),
          1081 : (2, 3, 0, 1, 3, 1),
          1082 : (2, 3, 0, 1, 3, 2),
          1083 : (2, 3, 0, 1, 3, 3),
          1084 : (2, 3, 0, 2, 0, 1),
          1085 : (2, 3, 0, 2, 1, 0),
          1086 : (2, 3, 0, 2, 1, 1),
          1087 : (2, 3, 0, 2, 1, 2),
          1088 : (2, 3, 0, 2, 1, 3),
          1089 : (2, 3, 0, 2, 2, 1),
          1090 : (2, 3, 0, 2, 3, 1),
          1091 : (2, 3, 0, 3, 0, 1),
          1092 : (2, 3, 0, 3, 1, 0),
          1093 : (2, 3, 0, 3, 1, 1),
          1094 : (2, 3, 0, 3, 1, 2),
          1095 : (2, 3, 0, 3, 1, 3),
          1096 : (2, 3, 0, 3, 2, 1),
          1097 : (2, 3, 0, 3, 3, 1),
          1098 : (2, 3, 1, 0, 0, 0),
          1099 : (2, 3, 1, 0, 0, 1),
          1100 : (2, 3, 1, 0, 0, 2),
          1101 : (2, 3, 1, 0, 0, 3),
          1102 : (2, 3, 1, 0, 1, 0),
          1103 : (2, 3, 1, 0, 1, 1),
          1104 : (2, 3, 1, 0, 1, 2),
          1105 : (2, 3, 1, 0, 1, 3),
          1106 : (2, 3, 1, 0, 2, 0),
          1107 : (2, 3, 1, 0, 2, 1),
          1108 : (2, 3, 1, 0, 2, 2),
          1109 : (2, 3, 1, 0, 2, 3),
          1110 : (2, 3, 1, 0, 3, 0),
          1111 : (2, 3, 1, 0, 3, 1),
          1112 : (2, 3, 1, 0, 3, 2),
          1113 : (2, 3, 1, 0, 3, 3),
          1114 : (2, 3, 1, 1, 0, 0),
          1115 : (2, 3, 1, 1, 0, 1),
          1116 : (2, 3, 1, 1, 0, 2),
          1117 : (2, 3, 1, 1, 0, 3),
          1118 : (2, 3, 1, 1, 1, 0),
          1119 : (2, 3, 1, 1, 2, 0),
          1120 : (2, 3, 1, 1, 3, 0),
          1121 : (2, 3, 1, 2, 0, 0),
          1122 : (2, 3, 1, 2, 0, 1),
          1123 : (2, 3, 1, 2, 0, 2),
          1124 : (2, 3, 1, 2, 0, 3),
          1125 : (2, 3, 1, 2, 1, 0),
          1126 : (2, 3, 1, 2, 2, 0),
          1127 : (2, 3, 1, 2, 3, 0),
          1128 : (2, 3, 1, 3, 0, 0),
          1129 : (2, 3, 1, 3, 0, 1),
          1130 : (2, 3, 1, 3, 0, 2),
          1131 : (2, 3, 1, 3, 0, 3),
          1132 : (2, 3, 1, 3, 1, 0),
          1133 : (2, 3, 1, 3, 2, 0),
          1134 : (2, 3, 1, 3, 3, 0),
          1135 : (2, 3, 2, 0, 0, 1),
          1136 : (2, 3, 2, 0, 1, 0),
          1137 : (2, 3, 2, 0, 1, 1),
          1138 : (2, 3, 2, 0, 1, 2),
          1139 : (2, 3, 2, 0, 1, 3),
          1140 : (2, 3, 2, 0, 2, 1),
          1141 : (2, 3, 2, 0, 3, 1),
          1142 : (2, 3, 2, 1, 0, 0),
          1143 : (2, 3, 2, 1, 0, 1),
          1144 : (2, 3, 2, 1, 0, 2),
          1145 : (2, 3, 2, 1, 0, 3),
          1146 : (2, 3, 2, 1, 1, 0),
          1147 : (2, 3, 2, 1, 2, 0),
          1148 : (2, 3, 2, 1, 3, 0),
          1149 : (2, 3, 2, 2, 0, 1),
          1150 : (2, 3, 2, 2, 1, 0),
          1151 : (2, 3, 2, 3, 0, 1),
          1152 : (2, 3, 2, 3, 1, 0),
          1153 : (2, 3, 3, 0, 0, 1),
          1154 : (2, 3, 3, 0, 1, 0),
          1155 : (2, 3, 3, 0, 1, 1),
          1156 : (2, 3, 3, 0, 1, 2),
          1157 : (2, 3, 3, 0, 1, 3),
          1158 : (2, 3, 3, 0, 2, 1),
          1159 : (2, 3, 3, 0, 3, 1),
          1160 : (2, 3, 3, 1, 0, 0),
          1161 : (2, 3, 3, 1, 0, 1),
          1162 : (2, 3, 3, 1, 0, 2),
          1163 : (2, 3, 3, 1, 0, 3),
          1164 : (2, 3, 3, 1, 1, 0),
          1165 : (2, 3, 3, 1, 2, 0),
          1166 : (2, 3, 3, 1, 3, 0),
          1167 : (2, 3, 3, 2, 0, 1),
          1168 : (2, 3, 3, 2, 1, 0),
          1169 : (2, 3, 3, 3, 0, 1),
          1170 : (2, 3, 3, 3, 1, 0),
          1171 : (3, 0, 0, 0, 1, 2),
          1172 : (3, 0, 0, 0, 2, 1),
          1173 : (3, 0, 0, 1, 0, 2),
          1174 : (3, 0, 0, 1, 1, 2),
          1175 : (3, 0, 0, 1, 2, 0),
          1176 : (3, 0, 0, 1, 2, 1),
          1177 : (3, 0, 0, 1, 2, 2),
          1178 : (3, 0, 0, 1, 2, 3),
          1179 : (3, 0, 0, 1, 3, 2),
          1180 : (3, 0, 0, 2, 0, 1),
          1181 : (3, 0, 0, 2, 1, 0),
          1182 : (3, 0, 0, 2, 1, 1),
          1183 : (3, 0, 0, 2, 1, 2),
          1184 : (3, 0, 0, 2, 1, 3),
          1185 : (3, 0, 0, 2, 2, 1),
          1186 : (3, 0, 0, 2, 3, 1),
          1187 : (3, 0, 0, 3, 1, 2),
          1188 : (3, 0, 0, 3, 2, 1),
          1189 : (3, 0, 1, 0, 0, 2),
          1190 : (3, 0, 1, 0, 1, 2),
          1191 : (3, 0, 1, 0, 2, 0),
          1192 : (3, 0, 1, 0, 2, 1),
          1193 : (3, 0, 1, 0, 2, 2),
          1194 : (3, 0, 1, 0, 2, 3),
          1195 : (3, 0, 1, 0, 3, 2),
          1196 : (3, 0, 1, 1, 0, 2),
          1197 : (3, 0, 1, 1, 1, 2),
          1198 : (3, 0, 1, 1, 2, 0),
          1199 : (3, 0, 1, 1, 2, 1),
          1200 : (3, 0, 1, 1, 2, 2),
          1201 : (3, 0, 1, 1, 2, 3),
          1202 : (3, 0, 1, 1, 3, 2),
          1203 : (3, 0, 1, 2, 0, 0),
          1204 : (3, 0, 1, 2, 0, 1),
          1205 : (3, 0, 1, 2, 0, 2),
          1206 : (3, 0, 1, 2, 0, 3),
          1207 : (3, 0, 1, 2, 1, 0),
          1208 : (3, 0, 1, 2, 1, 1),
          1209 : (3, 0, 1, 2, 1, 2),
          1210 : (3, 0, 1, 2, 1, 3),
          1211 : (3, 0, 1, 2, 2, 0),
          1212 : (3, 0, 1, 2, 2, 1),
          1213 : (3, 0, 1, 2, 2, 2),
          1214 : (3, 0, 1, 2, 2, 3),
          1215 : (3, 0, 1, 2, 3, 0),
          1216 : (3, 0, 1, 2, 3, 1),
          1217 : (3, 0, 1, 2, 3, 2),
          1218 : (3, 0, 1, 2, 3, 3),
          1219 : (3, 0, 1, 3, 0, 2),
          1220 : (3, 0, 1, 3, 1, 2),
          1221 : (3, 0, 1, 3, 2, 0),
          1222 : (3, 0, 1, 3, 2, 1),
          1223 : (3, 0, 1, 3, 2, 2),
          1224 : (3, 0, 1, 3, 2, 3),
          1225 : (3, 0, 1, 3, 3, 2),
          1226 : (3, 0, 2, 0, 0, 1),
          1227 : (3, 0, 2, 0, 1, 0),
          1228 : (3, 0, 2, 0, 1, 1),
          1229 : (3, 0, 2, 0, 1, 2),
          1230 : (3, 0, 2, 0, 1, 3),
          1231 : (3, 0, 2, 0, 2, 1),
          1232 : (3, 0, 2, 0, 3, 1),
          1233 : (3, 0, 2, 1, 0, 0),
          1234 : (3, 0, 2, 1, 0, 1),
          1235 : (3, 0, 2, 1, 0, 2),
          1236 : (3, 0, 2, 1, 0, 3),
          1237 : (3, 0, 2, 1, 1, 0),
          1238 : (3, 0, 2, 1, 1, 1),
          1239 : (3, 0, 2, 1, 1, 2),
          1240 : (3, 0, 2, 1, 1, 3),
          1241 : (3, 0, 2, 1, 2, 0),
          1242 : (3, 0, 2, 1, 2, 1),
          1243 : (3, 0, 2, 1, 2, 2),
          1244 : (3, 0, 2, 1, 2, 3),
          1245 : (3, 0, 2, 1, 3, 0),
          1246 : (3, 0, 2, 1, 3, 1),
          1247 : (3, 0, 2, 1, 3, 2),
          1248 : (3, 0, 2, 1, 3, 3),
          1249 : (3, 0, 2, 2, 0, 1),
          1250 : (3, 0, 2, 2, 1, 0),
          1251 : (3, 0, 2, 2, 1, 1),
          1252 : (3, 0, 2, 2, 1, 2),
          1253 : (3, 0, 2, 2, 1, 3),
          1254 : (3, 0, 2, 2, 2, 1),
          1255 : (3, 0, 2, 2, 3, 1),
          1256 : (3, 0, 2, 3, 0, 1),
          1257 : (3, 0, 2, 3, 1, 0),
          1258 : (3, 0, 2, 3, 1, 1),
          1259 : (3, 0, 2, 3, 1, 2),
          1260 : (3, 0, 2, 3, 1, 3),
          1261 : (3, 0, 2, 3, 2, 1),
          1262 : (3, 0, 2, 3, 3, 1),
          1263 : (3, 0, 3, 0, 1, 2),
          1264 : (3, 0, 3, 0, 2, 1),
          1265 : (3, 0, 3, 1, 0, 2),
          1266 : (3, 0, 3, 1, 1, 2),
          1267 : (3, 0, 3, 1, 2, 0),
          1268 : (3, 0, 3, 1, 2, 1),
          1269 : (3, 0, 3, 1, 2, 2),
          1270 : (3, 0, 3, 1, 2, 3),
          1271 : (3, 0, 3, 1, 3, 2),
          1272 : (3, 0, 3, 2, 0, 1),
          1273 : (3, 0, 3, 2, 1, 0),
          1274 : (3, 0, 3, 2, 1, 1),
          1275 : (3, 0, 3, 2, 1, 2),
          1276 : (3, 0, 3, 2, 1, 3),
          1277 : (3, 0, 3, 2, 2, 1),
          1278 : (3, 0, 3, 2, 3, 1),
          1279 : (3, 0, 3, 3, 1, 2),
          1280 : (3, 0, 3, 3, 2, 1),
          1281 : (3, 1, 0, 0, 0, 2),
          1282 : (3, 1, 0, 0, 1, 2),
          1283 : (3, 1, 0, 0, 2, 0),
          1284 : (3, 1, 0, 0, 2, 1),
          1285 : (3, 1, 0, 0, 2, 2),
          1286 : (3, 1, 0, 0, 2, 3),
          1287 : (3, 1, 0, 0, 3, 2),
          1288 : (3, 1, 0, 1, 0, 2),
          1289 : (3, 1, 0, 1, 1, 2),
          1290 : (3, 1, 0, 1, 2, 0),
          1291 : (3, 1, 0, 1, 2, 1),
          1292 : (3, 1, 0, 1, 2, 2),
          1293 : (3, 1, 0, 1, 2, 3),
          1294 : (3, 1, 0, 1, 3, 2),
          1295 : (3, 1, 0, 2, 0, 0),
          1296 : (3, 1, 0, 2, 0, 1),
          1297 : (3, 1, 0, 2, 0, 2),
          1298 : (3, 1, 0, 2, 0, 3),
          1299 : (3, 1, 0, 2, 1, 0),
          1300 : (3, 1, 0, 2, 1, 1),
          1301 : (3, 1, 0, 2, 1, 2),
          1302 : (3, 1, 0, 2, 1, 3),
          1303 : (3, 1, 0, 2, 2, 0),
          1304 : (3, 1, 0, 2, 2, 1),
          1305 : (3, 1, 0, 2, 2, 2),
          1306 : (3, 1, 0, 2, 2, 3),
          1307 : (3, 1, 0, 2, 3, 0),
          1308 : (3, 1, 0, 2, 3, 1),
          1309 : (3, 1, 0, 2, 3, 2),
          1310 : (3, 1, 0, 2, 3, 3),
          1311 : (3, 1, 0, 3, 0, 2),
          1312 : (3, 1, 0, 3, 1, 2),
          1313 : (3, 1, 0, 3, 2, 0),
          1314 : (3, 1, 0, 3, 2, 1),
          1315 : (3, 1, 0, 3, 2, 2),
          1316 : (3, 1, 0, 3, 2, 3),
          1317 : (3, 1, 0, 3, 3, 2),
          1318 : (3, 1, 1, 0, 0, 2),
          1319 : (3, 1, 1, 0, 1, 2),
          1320 : (3, 1, 1, 0, 2, 0),
          1321 : (3, 1, 1, 0, 2, 1),
          1322 : (3, 1, 1, 0, 2, 2),
          1323 : (3, 1, 1, 0, 2, 3),
          1324 : (3, 1, 1, 0, 3, 2),
          1325 : (3, 1, 1, 1, 0, 2),
          1326 : (3, 1, 1, 1, 2, 0),
          1327 : (3, 1, 1, 2, 0, 0),
          1328 : (3, 1, 1, 2, 0, 1),
          1329 : (3, 1, 1, 2, 0, 2),
          1330 : (3, 1, 1, 2, 0, 3),
          1331 : (3, 1, 1, 2, 1, 0),
          1332 : (3, 1, 1, 2, 2, 0),
          1333 : (3, 1, 1, 2, 3, 0),
          1334 : (3, 1, 1, 3, 0, 2),
          1335 : (3, 1, 1, 3, 2, 0),
          1336 : (3, 1, 2, 0, 0, 0),
          1337 : (3, 1, 2, 0, 0, 1),
          1338 : (3, 1, 2, 0, 0, 2),
          1339 : (3, 1, 2, 0, 0, 3),
          1340 : (3, 1, 2, 0, 1, 0),
          1341 : (3, 1, 2, 0, 1, 1),
          1342 : (3, 1, 2, 0, 1, 2),
          1343 : (3, 1, 2, 0, 1, 3),
          1344 : (3, 1, 2, 0, 2, 0),
          1345 : (3, 1, 2, 0, 2, 1),
          1346 : (3, 1, 2, 0, 2, 2),
          1347 : (3, 1, 2, 0, 2, 3),
          1348 : (3, 1, 2, 0, 3, 0),
          1349 : (3, 1, 2, 0, 3, 1),
          1350 : (3, 1, 2, 0, 3, 2),
          1351 : (3, 1, 2, 0, 3, 3),
          1352 : (3, 1, 2, 1, 0, 0),
          1353 : (3, 1, 2, 1, 0, 1),
          1354 : (3, 1, 2, 1, 0, 2),
          1355 : (3, 1, 2, 1, 0, 3),
          1356 : (3, 1, 2, 1, 1, 0),
          1357 : (3, 1, 2, 1, 2, 0),
          1358 : (3, 1, 2, 1, 3, 0),
          1359 : (3, 1, 2, 2, 0, 0),
          1360 : (3, 1, 2, 2, 0, 1),
          1361 : (3, 1, 2, 2, 0, 2),
          1362 : (3, 1, 2, 2, 0, 3),
          1363 : (3, 1, 2, 2, 1, 0),
          1364 : (3, 1, 2, 2, 2, 0),
          1365 : (3, 1, 2, 2, 3, 0),
          1366 : (3, 1, 2, 3, 0, 0),
          1367 : (3, 1, 2, 3, 0, 1),
          1368 : (3, 1, 2, 3, 0, 2),
          1369 : (3, 1, 2, 3, 0, 3),
          1370 : (3, 1, 2, 3, 1, 0),
          1371 : (3, 1, 2, 3, 2, 0),
          1372 : (3, 1, 2, 3, 3, 0),
          1373 : (3, 1, 3, 0, 0, 2),
          1374 : (3, 1, 3, 0, 1, 2),
          1375 : (3, 1, 3, 0, 2, 0),
          1376 : (3, 1, 3, 0, 2, 1),
          1377 : (3, 1, 3, 0, 2, 2),
          1378 : (3, 1, 3, 0, 2, 3),
          1379 : (3, 1, 3, 0, 3, 2),
          1380 : (3, 1, 3, 1, 0, 2),
          1381 : (3, 1, 3, 1, 2, 0),
          1382 : (3, 1, 3, 2, 0, 0),
          1383 : (3, 1, 3, 2, 0, 1),
          1384 : (3, 1, 3, 2, 0, 2),
          1385 : (3, 1, 3, 2, 0, 3),
          1386 : (3, 1, 3, 2, 1, 0),
          1387 : (3, 1, 3, 2, 2, 0),
          1388 : (3, 1, 3, 2, 3, 0),
          1389 : (3, 1, 3, 3, 0, 2),
          1390 : (3, 1, 3, 3, 2, 0),
          1391 : (3, 2, 0, 0, 0, 1),
          1392 : (3, 2, 0, 0, 1, 0),
          1393 : (3, 2, 0, 0, 1, 1),
          1394 : (3, 2, 0, 0, 1, 2),
          1395 : (3, 2, 0, 0, 1, 3),
          1396 : (3, 2, 0, 0, 2, 1),
          1397 : (3, 2, 0, 0, 3, 1),
          1398 : (3, 2, 0, 1, 0, 0),
          1399 : (3, 2, 0, 1, 0, 1),
          1400 : (3, 2, 0, 1, 0, 2),
          1401 : (3, 2, 0, 1, 0, 3),
          1402 : (3, 2, 0, 1, 1, 0),
          1403 : (3, 2, 0, 1, 1, 1),
          1404 : (3, 2, 0, 1, 1, 2),
          1405 : (3, 2, 0, 1, 1, 3),
          1406 : (3, 2, 0, 1, 2, 0),
          1407 : (3, 2, 0, 1, 2, 1),
          1408 : (3, 2, 0, 1, 2, 2),
          1409 : (3, 2, 0, 1, 2, 3),
          1410 : (3, 2, 0, 1, 3, 0),
          1411 : (3, 2, 0, 1, 3, 1),
          1412 : (3, 2, 0, 1, 3, 2),
          1413 : (3, 2, 0, 1, 3, 3),
          1414 : (3, 2, 0, 2, 0, 1),
          1415 : (3, 2, 0, 2, 1, 0),
          1416 : (3, 2, 0, 2, 1, 1),
          1417 : (3, 2, 0, 2, 1, 2),
          1418 : (3, 2, 0, 2, 1, 3),
          1419 : (3, 2, 0, 2, 2, 1),
          1420 : (3, 2, 0, 2, 3, 1),
          1421 : (3, 2, 0, 3, 0, 1),
          1422 : (3, 2, 0, 3, 1, 0),
          1423 : (3, 2, 0, 3, 1, 1),
          1424 : (3, 2, 0, 3, 1, 2),
          1425 : (3, 2, 0, 3, 1, 3),
          1426 : (3, 2, 0, 3, 2, 1),
          1427 : (3, 2, 0, 3, 3, 1),
          1428 : (3, 2, 1, 0, 0, 0),
          1429 : (3, 2, 1, 0, 0, 1),
          1430 : (3, 2, 1, 0, 0, 2),
          1431 : (3, 2, 1, 0, 0, 3),
          1432 : (3, 2, 1, 0, 1, 0),
          1433 : (3, 2, 1, 0, 1, 1),
          1434 : (3, 2, 1, 0, 1, 2),
          1435 : (3, 2, 1, 0, 1, 3),
          1436 : (3, 2, 1, 0, 2, 0),
          1437 : (3, 2, 1, 0, 2, 1),
          1438 : (3, 2, 1, 0, 2, 2),
          1439 : (3, 2, 1, 0, 2, 3),
          1440 : (3, 2, 1, 0, 3, 0),
          1441 : (3, 2, 1, 0, 3, 1),
          1442 : (3, 2, 1, 0, 3, 2),
          1443 : (3, 2, 1, 0, 3, 3),
          1444 : (3, 2, 1, 1, 0, 0),
          1445 : (3, 2, 1, 1, 0, 1),
          1446 : (3, 2, 1, 1, 0, 2),
          1447 : (3, 2, 1, 1, 0, 3),
          1448 : (3, 2, 1, 1, 1, 0),
          1449 : (3, 2, 1, 1, 2, 0),
          1450 : (3, 2, 1, 1, 3, 0),
          1451 : (3, 2, 1, 2, 0, 0),
          1452 : (3, 2, 1, 2, 0, 1),
          1453 : (3, 2, 1, 2, 0, 2),
          1454 : (3, 2, 1, 2, 0, 3),
          1455 : (3, 2, 1, 2, 1, 0),
          1456 : (3, 2, 1, 2, 2, 0),
          1457 : (3, 2, 1, 2, 3, 0),
          1458 : (3, 2, 1, 3, 0, 0),
          1459 : (3, 2, 1, 3, 0, 1),
          1460 : (3, 2, 1, 3, 0, 2),
          1461 : (3, 2, 1, 3, 0, 3),
          1462 : (3, 2, 1, 3, 1, 0),
          1463 : (3, 2, 1, 3, 2, 0),
          1464 : (3, 2, 1, 3, 3, 0),
          1465 : (3, 2, 2, 0, 0, 1),
          1466 : (3, 2, 2, 0, 1, 0),
          1467 : (3, 2, 2, 0, 1, 1),
          1468 : (3, 2, 2, 0, 1, 2),
          1469 : (3, 2, 2, 0, 1, 3),
          1470 : (3, 2, 2, 0, 2, 1),
          1471 : (3, 2, 2, 0, 3, 1),
          1472 : (3, 2, 2, 1, 0, 0),
          1473 : (3, 2, 2, 1, 0, 1),
          1474 : (3, 2, 2, 1, 0, 2),
          1475 : (3, 2, 2, 1, 0, 3),
          1476 : (3, 2, 2, 1, 1, 0),
          1477 : (3, 2, 2, 1, 2, 0),
          1478 : (3, 2, 2, 1, 3, 0),
          1479 : (3, 2, 2, 2, 0, 1),
          1480 : (3, 2, 2, 2, 1, 0),
          1481 : (3, 2, 2, 3, 0, 1),
          1482 : (3, 2, 2, 3, 1, 0),
          1483 : (3, 2, 3, 0, 0, 1),
          1484 : (3, 2, 3, 0, 1, 0),
          1485 : (3, 2, 3, 0, 1, 1),
          1486 : (3, 2, 3, 0, 1, 2),
          1487 : (3, 2, 3, 0, 1, 3),
          1488 : (3, 2, 3, 0, 2, 1),
          1489 : (3, 2, 3, 0, 3, 1),
          1490 : (3, 2, 3, 1, 0, 0),
          1491 : (3, 2, 3, 1, 0, 1),
          1492 : (3, 2, 3, 1, 0, 2),
          1493 : (3, 2, 3, 1, 0, 3),
          1494 : (3, 2, 3, 1, 1, 0),
          1495 : (3, 2, 3, 1, 2, 0),
          1496 : (3, 2, 3, 1, 3, 0),
          1497 : (3, 2, 3, 2, 0, 1),
          1498 : (3, 2, 3, 2, 1, 0),
          1499 : (3, 2, 3, 3, 0, 1),
          1500 : (3, 2, 3, 3, 1, 0),
          1501 : (3, 3, 0, 0, 1, 2),
          1502 : (3, 3, 0, 0, 2, 1),
          1503 : (3, 3, 0, 1, 0, 2),
          1504 : (3, 3, 0, 1, 1, 2),
          1505 : (3, 3, 0, 1, 2, 0),
          1506 : (3, 3, 0, 1, 2, 1),
          1507 : (3, 3, 0, 1, 2, 2),
          1508 : (3, 3, 0, 1, 2, 3),
          1509 : (3, 3, 0, 1, 3, 2),
          1510 : (3, 3, 0, 2, 0, 1),
          1511 : (3, 3, 0, 2, 1, 0),
          1512 : (3, 3, 0, 2, 1, 1),
          1513 : (3, 3, 0, 2, 1, 2),
          1514 : (3, 3, 0, 2, 1, 3),
          1515 : (3, 3, 0, 2, 2, 1),
          1516 : (3, 3, 0, 2, 3, 1),
          1517 : (3, 3, 0, 3, 1, 2),
          1518 : (3, 3, 0, 3, 2, 1),
          1519 : (3, 3, 1, 0, 0, 2),
          1520 : (3, 3, 1, 0, 1, 2),
          1521 : (3, 3, 1, 0, 2, 0),
          1522 : (3, 3, 1, 0, 2, 1),
          1523 : (3, 3, 1, 0, 2, 2),
          1524 : (3, 3, 1, 0, 2, 3),
          1525 : (3, 3, 1, 0, 3, 2),
          1526 : (3, 3, 1, 1, 0, 2),
          1527 : (3, 3, 1, 1, 2, 0),
          1528 : (3, 3, 1, 2, 0, 0),
          1529 : (3, 3, 1, 2, 0, 1),
          1530 : (3, 3, 1, 2, 0, 2),
          1531 : (3, 3, 1, 2, 0, 3),
          1532 : (3, 3, 1, 2, 1, 0),
          1533 : (3, 3, 1, 2, 2, 0),
          1534 : (3, 3, 1, 2, 3, 0),
          1535 : (3, 3, 1, 3, 0, 2),
          1536 : (3, 3, 1, 3, 2, 0),
          1537 : (3, 3, 2, 0, 0, 1),
          1538 : (3, 3, 2, 0, 1, 0),
          1539 : (3, 3, 2, 0, 1, 1),
          1540 : (3, 3, 2, 0, 1, 2),
          1541 : (3, 3, 2, 0, 1, 3),
          1542 : (3, 3, 2, 0, 2, 1),
          1543 : (3, 3, 2, 0, 3, 1),
          1544 : (3, 3, 2, 1, 0, 0),
          1545 : (3, 3, 2, 1, 0, 1),
          1546 : (3, 3, 2, 1, 0, 2),
          1547 : (3, 3, 2, 1, 0, 3),
          1548 : (3, 3, 2, 1, 1, 0),
          1549 : (3, 3, 2, 1, 2, 0),
          1550 : (3, 3, 2, 1, 3, 0),
          1551 : (3, 3, 2, 2, 0, 1),
          1552 : (3, 3, 2, 2, 1, 0),
          1553 : (3, 3, 2, 3, 0, 1),
          1554 : (3, 3, 2, 3, 1, 0),
          1555 : (3, 3, 3, 0, 1, 2),
          1556 : (3, 3, 3, 0, 2, 1),
          1557 : (3, 3, 3, 1, 0, 2),
          1558 : (3, 3, 3, 1, 2, 0),
          1559 : (3, 3, 3, 2, 0, 1),
          1560 : (3, 3, 3, 2, 1, 0)}

map_6_3 ={ 1 : (0, 0, 0, 0, 1, 2),
           2 : (0, 0, 0, 0, 2, 1),
           3 : (0, 0, 0, 1, 0, 2),
           4 : (0, 0, 0, 1, 1, 2),
           5 : (0, 0, 0, 1, 2, 0),
           6 : (0, 0, 0, 1, 2, 1),
           7 : (0, 0, 0, 1, 2, 2),
           8 : (0, 0, 0, 2, 0, 1),
           9 : (0, 0, 0, 2, 1, 0),
          10 : (0, 0, 0, 2, 1, 1),
          11 : (0, 0, 0, 2, 1, 2),
          12 : (0, 0, 0, 2, 2, 1),
          13 : (0, 0, 1, 0, 0, 2),
          14 : (0, 0, 1, 0, 1, 2),
          15 : (0, 0, 1, 0, 2, 0),
          16 : (0, 0, 1, 0, 2, 1),
          17 : (0, 0, 1, 0, 2, 2),
          18 : (0, 0, 1, 1, 0, 2),
          19 : (0, 0, 1, 1, 1, 2),
          20 : (0, 0, 1, 1, 2, 0),
          21 : (0, 0, 1, 1, 2, 1),
          22 : (0, 0, 1, 1, 2, 2),
          23 : (0, 0, 1, 2, 0, 0),
          24 : (0, 0, 1, 2, 0, 1),
          25 : (0, 0, 1, 2, 0, 2),
          26 : (0, 0, 1, 2, 1, 0),
          27 : (0, 0, 1, 2, 1, 1),
          28 : (0, 0, 1, 2, 1, 2),
          29 : (0, 0, 1, 2, 2, 0),
          30 : (0, 0, 1, 2, 2, 1),
          31 : (0, 0, 1, 2, 2, 2),
          32 : (0, 0, 2, 0, 0, 1),
          33 : (0, 0, 2, 0, 1, 0),
          34 : (0, 0, 2, 0, 1, 1),
          35 : (0, 0, 2, 0, 1, 2),
          36 : (0, 0, 2, 0, 2, 1),
          37 : (0, 0, 2, 1, 0, 0),
          38 : (0, 0, 2, 1, 0, 1),
          39 : (0, 0, 2, 1, 0, 2),
          40 : (0, 0, 2, 1, 1, 0),
          41 : (0, 0, 2, 1, 1, 1),
          42 : (0, 0, 2, 1, 1, 2),
          43 : (0, 0, 2, 1, 2, 0),
          44 : (0, 0, 2, 1, 2, 1),
          45 : (0, 0, 2, 1, 2, 2),
          46 : (0, 0, 2, 2, 0, 1),
          47 : (0, 0, 2, 2, 1, 0),
          48 : (0, 0, 2, 2, 1, 1),
          49 : (0, 0, 2, 2, 1, 2),
          50 : (0, 0, 2, 2, 2, 1),
          51 : (0, 1, 0, 0, 0, 2),
          52 : (0, 1, 0, 0, 1, 2),
          53 : (0, 1, 0, 0, 2, 0),
          54 : (0, 1, 0, 0, 2, 1),
          55 : (0, 1, 0, 0, 2, 2),
          56 : (0, 1, 0, 1, 0, 2),
          57 : (0, 1, 0, 1, 1, 2),
          58 : (0, 1, 0, 1, 2, 0),
          59 : (0, 1, 0, 1, 2, 1),
          60 : (0, 1, 0, 1, 2, 2),
          61 : (0, 1, 0, 2, 0, 0),
          62 : (0, 1, 0, 2, 0, 1),
          63 : (0, 1, 0, 2, 0, 2),
          64 : (0, 1, 0, 2, 1, 0),
          65 : (0, 1, 0, 2, 1, 1),
          66 : (0, 1, 0, 2, 1, 2),
          67 : (0, 1, 0, 2, 2, 0),
          68 : (0, 1, 0, 2, 2, 1),
          69 : (0, 1, 0, 2, 2, 2),
          70 : (0, 1, 1, 0, 0, 2),
          71 : (0, 1, 1, 0, 1, 2),
          72 : (0, 1, 1, 0, 2, 0),
          73 : (0, 1, 1, 0, 2, 1),
          74 : (0, 1, 1, 0, 2, 2),
          75 : (0, 1, 1, 1, 0, 2),
          76 : (0, 1, 1, 1, 1, 2),
          77 : (0, 1, 1, 1, 2, 0),
          78 : (0, 1, 1, 1, 2, 1),
          79 : (0, 1, 1, 1, 2, 2),
          80 : (0, 1, 1, 2, 0, 0),
          81 : (0, 1, 1, 2, 0, 1),
          82 : (0, 1, 1, 2, 0, 2),
          83 : (0, 1, 1, 2, 1, 0),
          84 : (0, 1, 1, 2, 1, 1),
          85 : (0, 1, 1, 2, 1, 2),
          86 : (0, 1, 1, 2, 2, 0),
          87 : (0, 1, 1, 2, 2, 1),
          88 : (0, 1, 1, 2, 2, 2),
          89 : (0, 1, 2, 0, 0, 0),
          90 : (0, 1, 2, 0, 0, 1),
          91 : (0, 1, 2, 0, 0, 2),
          92 : (0, 1, 2, 0, 1, 0),
          93 : (0, 1, 2, 0, 1, 1),
          94 : (0, 1, 2, 0, 1, 2),
          95 : (0, 1, 2, 0, 2, 0),
          96 : (0, 1, 2, 0, 2, 1),
          97 : (0, 1, 2, 0, 2, 2),
          98 : (0, 1, 2, 1, 0, 0),
          99 : (0, 1, 2, 1, 0, 1),
          100 : (0, 1, 2, 1, 0, 2),
          101 : (0, 1, 2, 1, 1, 0),
          102 : (0, 1, 2, 1, 1, 1),
          103 : (0, 1, 2, 1, 1, 2),
          104 : (0, 1, 2, 1, 2, 0),
          105 : (0, 1, 2, 1, 2, 1),
          106 : (0, 1, 2, 1, 2, 2),
          107 : (0, 1, 2, 2, 0, 0),
          108 : (0, 1, 2, 2, 0, 1),
          109 : (0, 1, 2, 2, 0, 2),
          110 : (0, 1, 2, 2, 1, 0),
          111 : (0, 1, 2, 2, 1, 1),
          112 : (0, 1, 2, 2, 1, 2),
          113 : (0, 1, 2, 2, 2, 0),
          114 : (0, 1, 2, 2, 2, 1),
          115 : (0, 1, 2, 2, 2, 2),
          116 : (0, 2, 0, 0, 0, 1),
          117 : (0, 2, 0, 0, 1, 0),
          118 : (0, 2, 0, 0, 1, 1),
          119 : (0, 2, 0, 0, 1, 2),
          120 : (0, 2, 0, 0, 2, 1),
          121 : (0, 2, 0, 1, 0, 0),
          122 : (0, 2, 0, 1, 0, 1),
          123 : (0, 2, 0, 1, 0, 2),
          124 : (0, 2, 0, 1, 1, 0),
          125 : (0, 2, 0, 1, 1, 1),
          126 : (0, 2, 0, 1, 1, 2),
          127 : (0, 2, 0, 1, 2, 0),
          128 : (0, 2, 0, 1, 2, 1),
          129 : (0, 2, 0, 1, 2, 2),
          130 : (0, 2, 0, 2, 0, 1),
          131 : (0, 2, 0, 2, 1, 0),
          132 : (0, 2, 0, 2, 1, 1),
          133 : (0, 2, 0, 2, 1, 2),
          134 : (0, 2, 0, 2, 2, 1),
          135 : (0, 2, 1, 0, 0, 0),
          136 : (0, 2, 1, 0, 0, 1),
          137 : (0, 2, 1, 0, 0, 2),
          138 : (0, 2, 1, 0, 1, 0),
          139 : (0, 2, 1, 0, 1, 1),
          140 : (0, 2, 1, 0, 1, 2),
          141 : (0, 2, 1, 0, 2, 0),
          142 : (0, 2, 1, 0, 2, 1),
          143 : (0, 2, 1, 0, 2, 2),
          144 : (0, 2, 1, 1, 0, 0),
          145 : (0, 2, 1, 1, 0, 1),
          146 : (0, 2, 1, 1, 0, 2),
          147 : (0, 2, 1, 1, 1, 0),
          148 : (0, 2, 1, 1, 1, 1),
          149 : (0, 2, 1, 1, 1, 2),
          150 : (0, 2, 1, 1, 2, 0),
          151 : (0, 2, 1, 1, 2, 1),
          152 : (0, 2, 1, 1, 2, 2),
          153 : (0, 2, 1, 2, 0, 0),
          154 : (0, 2, 1, 2, 0, 1),
          155 : (0, 2, 1, 2, 0, 2),
          156 : (0, 2, 1, 2, 1, 0),
          157 : (0, 2, 1, 2, 1, 1),
          158 : (0, 2, 1, 2, 1, 2),
          159 : (0, 2, 1, 2, 2, 0),
          160 : (0, 2, 1, 2, 2, 1),
          161 : (0, 2, 1, 2, 2, 2),
          162 : (0, 2, 2, 0, 0, 1),
          163 : (0, 2, 2, 0, 1, 0),
          164 : (0, 2, 2, 0, 1, 1),
          165 : (0, 2, 2, 0, 1, 2),
          166 : (0, 2, 2, 0, 2, 1),
          167 : (0, 2, 2, 1, 0, 0),
          168 : (0, 2, 2, 1, 0, 1),
          169 : (0, 2, 2, 1, 0, 2),
          170 : (0, 2, 2, 1, 1, 0),
          171 : (0, 2, 2, 1, 1, 1),
          172 : (0, 2, 2, 1, 1, 2),
          173 : (0, 2, 2, 1, 2, 0),
          174 : (0, 2, 2, 1, 2, 1),
          175 : (0, 2, 2, 1, 2, 2),
          176 : (0, 2, 2, 2, 0, 1),
          177 : (0, 2, 2, 2, 1, 0),
          178 : (0, 2, 2, 2, 1, 1),
          179 : (0, 2, 2, 2, 1, 2),
          180 : (0, 2, 2, 2, 2, 1),
          181 : (1, 0, 0, 0, 0, 2),
          182 : (1, 0, 0, 0, 1, 2),
          183 : (1, 0, 0, 0, 2, 0),
          184 : (1, 0, 0, 0, 2, 1),
          185 : (1, 0, 0, 0, 2, 2),
          186 : (1, 0, 0, 1, 0, 2),
          187 : (1, 0, 0, 1, 1, 2),
          188 : (1, 0, 0, 1, 2, 0),
          189 : (1, 0, 0, 1, 2, 1),
          190 : (1, 0, 0, 1, 2, 2),
          191 : (1, 0, 0, 2, 0, 0),
          192 : (1, 0, 0, 2, 0, 1),
          193 : (1, 0, 0, 2, 0, 2),
          194 : (1, 0, 0, 2, 1, 0),
          195 : (1, 0, 0, 2, 1, 1),
          196 : (1, 0, 0, 2, 1, 2),
          197 : (1, 0, 0, 2, 2, 0),
          198 : (1, 0, 0, 2, 2, 1),
          199 : (1, 0, 0, 2, 2, 2),
          200 : (1, 0, 1, 0, 0, 2),
          201 : (1, 0, 1, 0, 1, 2),
          202 : (1, 0, 1, 0, 2, 0),
          203 : (1, 0, 1, 0, 2, 1),
          204 : (1, 0, 1, 0, 2, 2),
          205 : (1, 0, 1, 1, 0, 2),
          206 : (1, 0, 1, 1, 1, 2),
          207 : (1, 0, 1, 1, 2, 0),
          208 : (1, 0, 1, 1, 2, 1),
          209 : (1, 0, 1, 1, 2, 2),
          210 : (1, 0, 1, 2, 0, 0),
          211 : (1, 0, 1, 2, 0, 1),
          212 : (1, 0, 1, 2, 0, 2),
          213 : (1, 0, 1, 2, 1, 0),
          214 : (1, 0, 1, 2, 1, 1),
          215 : (1, 0, 1, 2, 1, 2),
          216 : (1, 0, 1, 2, 2, 0),
          217 : (1, 0, 1, 2, 2, 1),
          218 : (1, 0, 1, 2, 2, 2),
          219 : (1, 0, 2, 0, 0, 0),
          220 : (1, 0, 2, 0, 0, 1),
          221 : (1, 0, 2, 0, 0, 2),
          222 : (1, 0, 2, 0, 1, 0),
          223 : (1, 0, 2, 0, 1, 1),
          224 : (1, 0, 2, 0, 1, 2),
          225 : (1, 0, 2, 0, 2, 0),
          226 : (1, 0, 2, 0, 2, 1),
          227 : (1, 0, 2, 0, 2, 2),
          228 : (1, 0, 2, 1, 0, 0),
          229 : (1, 0, 2, 1, 0, 1),
          230 : (1, 0, 2, 1, 0, 2),
          231 : (1, 0, 2, 1, 1, 0),
          232 : (1, 0, 2, 1, 1, 1),
          233 : (1, 0, 2, 1, 1, 2),
          234 : (1, 0, 2, 1, 2, 0),
          235 : (1, 0, 2, 1, 2, 1),
          236 : (1, 0, 2, 1, 2, 2),
          237 : (1, 0, 2, 2, 0, 0),
          238 : (1, 0, 2, 2, 0, 1),
          239 : (1, 0, 2, 2, 0, 2),
          240 : (1, 0, 2, 2, 1, 0),
          241 : (1, 0, 2, 2, 1, 1),
          242 : (1, 0, 2, 2, 1, 2),
          243 : (1, 0, 2, 2, 2, 0),
          244 : (1, 0, 2, 2, 2, 1),
          245 : (1, 0, 2, 2, 2, 2),
          246 : (1, 1, 0, 0, 0, 2),
          247 : (1, 1, 0, 0, 1, 2),
          248 : (1, 1, 0, 0, 2, 0),
          249 : (1, 1, 0, 0, 2, 1),
          250 : (1, 1, 0, 0, 2, 2),
          251 : (1, 1, 0, 1, 0, 2),
          252 : (1, 1, 0, 1, 1, 2),
          253 : (1, 1, 0, 1, 2, 0),
          254 : (1, 1, 0, 1, 2, 1),
          255 : (1, 1, 0, 1, 2, 2),
          256 : (1, 1, 0, 2, 0, 0),
          257 : (1, 1, 0, 2, 0, 1),
          258 : (1, 1, 0, 2, 0, 2),
          259 : (1, 1, 0, 2, 1, 0),
          260 : (1, 1, 0, 2, 1, 1),
          261 : (1, 1, 0, 2, 1, 2),
          262 : (1, 1, 0, 2, 2, 0),
          263 : (1, 1, 0, 2, 2, 1),
          264 : (1, 1, 0, 2, 2, 2),
          265 : (1, 1, 1, 0, 0, 2),
          266 : (1, 1, 1, 0, 1, 2),
          267 : (1, 1, 1, 0, 2, 0),
          268 : (1, 1, 1, 0, 2, 1),
          269 : (1, 1, 1, 0, 2, 2),
          270 : (1, 1, 1, 1, 0, 2),
          271 : (1, 1, 1, 1, 2, 0),
          272 : (1, 1, 1, 2, 0, 0),
          273 : (1, 1, 1, 2, 0, 1),
          274 : (1, 1, 1, 2, 0, 2),
          275 : (1, 1, 1, 2, 1, 0),
          276 : (1, 1, 1, 2, 2, 0),
          277 : (1, 1, 2, 0, 0, 0),
          278 : (1, 1, 2, 0, 0, 1),
          279 : (1, 1, 2, 0, 0, 2),
          280 : (1, 1, 2, 0, 1, 0),
          281 : (1, 1, 2, 0, 1, 1),
          282 : (1, 1, 2, 0, 1, 2),
          283 : (1, 1, 2, 0, 2, 0),
          284 : (1, 1, 2, 0, 2, 1),
          285 : (1, 1, 2, 0, 2, 2),
          286 : (1, 1, 2, 1, 0, 0),
          287 : (1, 1, 2, 1, 0, 1),
          288 : (1, 1, 2, 1, 0, 2),
          289 : (1, 1, 2, 1, 1, 0),
          290 : (1, 1, 2, 1, 2, 0),
          291 : (1, 1, 2, 2, 0, 0),
          292 : (1, 1, 2, 2, 0, 1),
          293 : (1, 1, 2, 2, 0, 2),
          294 : (1, 1, 2, 2, 1, 0),
          295 : (1, 1, 2, 2, 2, 0),
          296 : (1, 2, 0, 0, 0, 0),
          297 : (1, 2, 0, 0, 0, 1),
          298 : (1, 2, 0, 0, 0, 2),
          299 : (1, 2, 0, 0, 1, 0),
          300 : (1, 2, 0, 0, 1, 1),
          301 : (1, 2, 0, 0, 1, 2),
          302 : (1, 2, 0, 0, 2, 0),
          303 : (1, 2, 0, 0, 2, 1),
          304 : (1, 2, 0, 0, 2, 2),
          305 : (1, 2, 0, 1, 0, 0),
          306 : (1, 2, 0, 1, 0, 1),
          307 : (1, 2, 0, 1, 0, 2),
          308 : (1, 2, 0, 1, 1, 0),
          309 : (1, 2, 0, 1, 1, 1),
          310 : (1, 2, 0, 1, 1, 2),
          311 : (1, 2, 0, 1, 2, 0),
          312 : (1, 2, 0, 1, 2, 1),
          313 : (1, 2, 0, 1, 2, 2),
          314 : (1, 2, 0, 2, 0, 0),
          315 : (1, 2, 0, 2, 0, 1),
          316 : (1, 2, 0, 2, 0, 2),
          317 : (1, 2, 0, 2, 1, 0),
          318 : (1, 2, 0, 2, 1, 1),
          319 : (1, 2, 0, 2, 1, 2),
          320 : (1, 2, 0, 2, 2, 0),
          321 : (1, 2, 0, 2, 2, 1),
          322 : (1, 2, 0, 2, 2, 2),
          323 : (1, 2, 1, 0, 0, 0),
          324 : (1, 2, 1, 0, 0, 1),
          325 : (1, 2, 1, 0, 0, 2),
          326 : (1, 2, 1, 0, 1, 0),
          327 : (1, 2, 1, 0, 1, 1),
          328 : (1, 2, 1, 0, 1, 2),
          329 : (1, 2, 1, 0, 2, 0),
          330 : (1, 2, 1, 0, 2, 1),
          331 : (1, 2, 1, 0, 2, 2),
          332 : (1, 2, 1, 1, 0, 0),
          333 : (1, 2, 1, 1, 0, 1),
          334 : (1, 2, 1, 1, 0, 2),
          335 : (1, 2, 1, 1, 1, 0),
          336 : (1, 2, 1, 1, 2, 0),
          337 : (1, 2, 1, 2, 0, 0),
          338 : (1, 2, 1, 2, 0, 1),
          339 : (1, 2, 1, 2, 0, 2),
          340 : (1, 2, 1, 2, 1, 0),
          341 : (1, 2, 1, 2, 2, 0),
          342 : (1, 2, 2, 0, 0, 0),
          343 : (1, 2, 2, 0, 0, 1),
          344 : (1, 2, 2, 0, 0, 2),
          345 : (1, 2, 2, 0, 1, 0),
          346 : (1, 2, 2, 0, 1, 1),
          347 : (1, 2, 2, 0, 1, 2),
          348 : (1, 2, 2, 0, 2, 0),
          349 : (1, 2, 2, 0, 2, 1),
          350 : (1, 2, 2, 0, 2, 2),
          351 : (1, 2, 2, 1, 0, 0),
          352 : (1, 2, 2, 1, 0, 1),
          353 : (1, 2, 2, 1, 0, 2),
          354 : (1, 2, 2, 1, 1, 0),
          355 : (1, 2, 2, 1, 2, 0),
          356 : (1, 2, 2, 2, 0, 0),
          357 : (1, 2, 2, 2, 0, 1),
          358 : (1, 2, 2, 2, 0, 2),
          359 : (1, 2, 2, 2, 1, 0),
          360 : (1, 2, 2, 2, 2, 0),
          361 : (2, 0, 0, 0, 0, 1),
          362 : (2, 0, 0, 0, 1, 0),
          363 : (2, 0, 0, 0, 1, 1),
          364 : (2, 0, 0, 0, 1, 2),
          365 : (2, 0, 0, 0, 2, 1),
          366 : (2, 0, 0, 1, 0, 0),
          367 : (2, 0, 0, 1, 0, 1),
          368 : (2, 0, 0, 1, 0, 2),
          369 : (2, 0, 0, 1, 1, 0),
          370 : (2, 0, 0, 1, 1, 1),
          371 : (2, 0, 0, 1, 1, 2),
          372 : (2, 0, 0, 1, 2, 0),
          373 : (2, 0, 0, 1, 2, 1),
          374 : (2, 0, 0, 1, 2, 2),
          375 : (2, 0, 0, 2, 0, 1),
          376 : (2, 0, 0, 2, 1, 0),
          377 : (2, 0, 0, 2, 1, 1),
          378 : (2, 0, 0, 2, 1, 2),
          379 : (2, 0, 0, 2, 2, 1),
          380 : (2, 0, 1, 0, 0, 0),
          381 : (2, 0, 1, 0, 0, 1),
          382 : (2, 0, 1, 0, 0, 2),
          383 : (2, 0, 1, 0, 1, 0),
          384 : (2, 0, 1, 0, 1, 1),
          385 : (2, 0, 1, 0, 1, 2),
          386 : (2, 0, 1, 0, 2, 0),
          387 : (2, 0, 1, 0, 2, 1),
          388 : (2, 0, 1, 0, 2, 2),
          389 : (2, 0, 1, 1, 0, 0),
          390 : (2, 0, 1, 1, 0, 1),
          391 : (2, 0, 1, 1, 0, 2),
          392 : (2, 0, 1, 1, 1, 0),
          393 : (2, 0, 1, 1, 1, 1),
          394 : (2, 0, 1, 1, 1, 2),
          395 : (2, 0, 1, 1, 2, 0),
          396 : (2, 0, 1, 1, 2, 1),
          397 : (2, 0, 1, 1, 2, 2),
          398 : (2, 0, 1, 2, 0, 0),
          399 : (2, 0, 1, 2, 0, 1),
          400 : (2, 0, 1, 2, 0, 2),
          401 : (2, 0, 1, 2, 1, 0),
          402 : (2, 0, 1, 2, 1, 1),
          403 : (2, 0, 1, 2, 1, 2),
          404 : (2, 0, 1, 2, 2, 0),
          405 : (2, 0, 1, 2, 2, 1),
          406 : (2, 0, 1, 2, 2, 2),
          407 : (2, 0, 2, 0, 0, 1),
          408 : (2, 0, 2, 0, 1, 0),
          409 : (2, 0, 2, 0, 1, 1),
          410 : (2, 0, 2, 0, 1, 2),
          411 : (2, 0, 2, 0, 2, 1),
          412 : (2, 0, 2, 1, 0, 0),
          413 : (2, 0, 2, 1, 0, 1),
          414 : (2, 0, 2, 1, 0, 2),
          415 : (2, 0, 2, 1, 1, 0),
          416 : (2, 0, 2, 1, 1, 1),
          417 : (2, 0, 2, 1, 1, 2),
          418 : (2, 0, 2, 1, 2, 0),
          419 : (2, 0, 2, 1, 2, 1),
          420 : (2, 0, 2, 1, 2, 2),
          421 : (2, 0, 2, 2, 0, 1),
          422 : (2, 0, 2, 2, 1, 0),
          423 : (2, 0, 2, 2, 1, 1),
          424 : (2, 0, 2, 2, 1, 2),
          425 : (2, 0, 2, 2, 2, 1),
          426 : (2, 1, 0, 0, 0, 0),
          427 : (2, 1, 0, 0, 0, 1),
          428 : (2, 1, 0, 0, 0, 2),
          429 : (2, 1, 0, 0, 1, 0),
          430 : (2, 1, 0, 0, 1, 1),
          431 : (2, 1, 0, 0, 1, 2),
          432 : (2, 1, 0, 0, 2, 0),
          433 : (2, 1, 0, 0, 2, 1),
          434 : (2, 1, 0, 0, 2, 2),
          435 : (2, 1, 0, 1, 0, 0),
          436 : (2, 1, 0, 1, 0, 1),
          437 : (2, 1, 0, 1, 0, 2),
          438 : (2, 1, 0, 1, 1, 0),
          439 : (2, 1, 0, 1, 1, 1),
          440 : (2, 1, 0, 1, 1, 2),
          441 : (2, 1, 0, 1, 2, 0),
          442 : (2, 1, 0, 1, 2, 1),
          443 : (2, 1, 0, 1, 2, 2),
          444 : (2, 1, 0, 2, 0, 0),
          445 : (2, 1, 0, 2, 0, 1),
          446 : (2, 1, 0, 2, 0, 2),
          447 : (2, 1, 0, 2, 1, 0),
          448 : (2, 1, 0, 2, 1, 1),
          449 : (2, 1, 0, 2, 1, 2),
          450 : (2, 1, 0, 2, 2, 0),
          451 : (2, 1, 0, 2, 2, 1),
          452 : (2, 1, 0, 2, 2, 2),
          453 : (2, 1, 1, 0, 0, 0),
          454 : (2, 1, 1, 0, 0, 1),
          455 : (2, 1, 1, 0, 0, 2),
          456 : (2, 1, 1, 0, 1, 0),
          457 : (2, 1, 1, 0, 1, 1),
          458 : (2, 1, 1, 0, 1, 2),
          459 : (2, 1, 1, 0, 2, 0),
          460 : (2, 1, 1, 0, 2, 1),
          461 : (2, 1, 1, 0, 2, 2),
          462 : (2, 1, 1, 1, 0, 0),
          463 : (2, 1, 1, 1, 0, 1),
          464 : (2, 1, 1, 1, 0, 2),
          465 : (2, 1, 1, 1, 1, 0),
          466 : (2, 1, 1, 1, 2, 0),
          467 : (2, 1, 1, 2, 0, 0),
          468 : (2, 1, 1, 2, 0, 1),
          469 : (2, 1, 1, 2, 0, 2),
          470 : (2, 1, 1, 2, 1, 0),
          471 : (2, 1, 1, 2, 2, 0),
          472 : (2, 1, 2, 0, 0, 0),
          473 : (2, 1, 2, 0, 0, 1),
          474 : (2, 1, 2, 0, 0, 2),
          475 : (2, 1, 2, 0, 1, 0),
          476 : (2, 1, 2, 0, 1, 1),
          477 : (2, 1, 2, 0, 1, 2),
          478 : (2, 1, 2, 0, 2, 0),
          479 : (2, 1, 2, 0, 2, 1),
          480 : (2, 1, 2, 0, 2, 2),
          481 : (2, 1, 2, 1, 0, 0),
          482 : (2, 1, 2, 1, 0, 1),
          483 : (2, 1, 2, 1, 0, 2),
          484 : (2, 1, 2, 1, 1, 0),
          485 : (2, 1, 2, 1, 2, 0),
          486 : (2, 1, 2, 2, 0, 0),
          487 : (2, 1, 2, 2, 0, 1),
          488 : (2, 1, 2, 2, 0, 2),
          489 : (2, 1, 2, 2, 1, 0),
          490 : (2, 1, 2, 2, 2, 0),
          491 : (2, 2, 0, 0, 0, 1),
          492 : (2, 2, 0, 0, 1, 0),
          493 : (2, 2, 0, 0, 1, 1),
          494 : (2, 2, 0, 0, 1, 2),
          495 : (2, 2, 0, 0, 2, 1),
          496 : (2, 2, 0, 1, 0, 0),
          497 : (2, 2, 0, 1, 0, 1),
          498 : (2, 2, 0, 1, 0, 2),
          499 : (2, 2, 0, 1, 1, 0),
          500 : (2, 2, 0, 1, 1, 1),
          501 : (2, 2, 0, 1, 1, 2),
          502 : (2, 2, 0, 1, 2, 0),
          503 : (2, 2, 0, 1, 2, 1),
          504 : (2, 2, 0, 1, 2, 2),
          505 : (2, 2, 0, 2, 0, 1),
          506 : (2, 2, 0, 2, 1, 0),
          507 : (2, 2, 0, 2, 1, 1),
          508 : (2, 2, 0, 2, 1, 2),
          509 : (2, 2, 0, 2, 2, 1),
          510 : (2, 2, 1, 0, 0, 0),
          511 : (2, 2, 1, 0, 0, 1),
          512 : (2, 2, 1, 0, 0, 2),
          513 : (2, 2, 1, 0, 1, 0),
          514 : (2, 2, 1, 0, 1, 1),
          515 : (2, 2, 1, 0, 1, 2),
          516 : (2, 2, 1, 0, 2, 0),
          517 : (2, 2, 1, 0, 2, 1),
          518 : (2, 2, 1, 0, 2, 2),
          519 : (2, 2, 1, 1, 0, 0),
          520 : (2, 2, 1, 1, 0, 1),
          521 : (2, 2, 1, 1, 0, 2),
          522 : (2, 2, 1, 1, 1, 0),
          523 : (2, 2, 1, 1, 2, 0),
          524 : (2, 2, 1, 2, 0, 0),
          525 : (2, 2, 1, 2, 0, 1),
          526 : (2, 2, 1, 2, 0, 2),
          527 : (2, 2, 1, 2, 1, 0),
          528 : (2, 2, 1, 2, 2, 0),
          529 : (2, 2, 2, 0, 0, 1),
          530 : (2, 2, 2, 0, 1, 0),
          531 : (2, 2, 2, 0, 1, 1),
          532 : (2, 2, 2, 0, 1, 2),
          533 : (2, 2, 2, 0, 2, 1),
          534 : (2, 2, 2, 1, 0, 0),
          535 : (2, 2, 2, 1, 0, 1),
          536 : (2, 2, 2, 1, 0, 2),
          537 : (2, 2, 2, 1, 1, 0),
          538 : (2, 2, 2, 1, 2, 0),
          539 : (2, 2, 2, 2, 0, 1),
          540 : (2, 2, 2, 2, 1, 0)}

map_6_2 ={ 1 : (0, 0, 0, 0, 0, 1),
           2 : (0, 0, 0, 0, 1, 0),
           3 : (0, 0, 0, 0, 1, 1),
           4 : (0, 0, 0, 1, 0, 0),
           5 : (0, 0, 0, 1, 0, 1),
           6 : (0, 0, 0, 1, 1, 0),
           7 : (0, 0, 0, 1, 1, 1),
           8 : (0, 0, 1, 0, 0, 0),
           9 : (0, 0, 1, 0, 0, 1),
          10 : (0, 0, 1, 0, 1, 0),
          11 : (0, 0, 1, 0, 1, 1),
          12 : (0, 0, 1, 1, 0, 0),
          13 : (0, 0, 1, 1, 0, 1),
          14 : (0, 0, 1, 1, 1, 0),
          15 : (0, 0, 1, 1, 1, 1),
          16 : (0, 1, 0, 0, 0, 0),
          17 : (0, 1, 0, 0, 0, 1),
          18 : (0, 1, 0, 0, 1, 0),
          19 : (0, 1, 0, 0, 1, 1),
          20 : (0, 1, 0, 1, 0, 0),
          21 : (0, 1, 0, 1, 0, 1),
          22 : (0, 1, 0, 1, 1, 0),
          23 : (0, 1, 0, 1, 1, 1),
          24 : (0, 1, 1, 0, 0, 0),
          25 : (0, 1, 1, 0, 0, 1),
          26 : (0, 1, 1, 0, 1, 0),
          27 : (0, 1, 1, 0, 1, 1),
          28 : (0, 1, 1, 1, 0, 0),
          29 : (0, 1, 1, 1, 0, 1),
          30 : (0, 1, 1, 1, 1, 0),
          31 : (0, 1, 1, 1, 1, 1),
          32 : (1, 0, 0, 0, 0, 0),
          33 : (1, 0, 0, 0, 0, 1),
          34 : (1, 0, 0, 0, 1, 0),
          35 : (1, 0, 0, 0, 1, 1),
          36 : (1, 0, 0, 1, 0, 0),
          37 : (1, 0, 0, 1, 0, 1),
          38 : (1, 0, 0, 1, 1, 0),
          39 : (1, 0, 0, 1, 1, 1),
          40 : (1, 0, 1, 0, 0, 0),
          41 : (1, 0, 1, 0, 0, 1),
          42 : (1, 0, 1, 0, 1, 0),
          43 : (1, 0, 1, 0, 1, 1),
          44 : (1, 0, 1, 1, 0, 0),
          45 : (1, 0, 1, 1, 0, 1),
          46 : (1, 0, 1, 1, 1, 0),
          47 : (1, 0, 1, 1, 1, 1),
          48 : (1, 1, 0, 0, 0, 0),
          49 : (1, 1, 0, 0, 0, 1),
          50 : (1, 1, 0, 0, 1, 0),
          51 : (1, 1, 0, 0, 1, 1),
          52 : (1, 1, 0, 1, 0, 0),
          53 : (1, 1, 0, 1, 0, 1),
          54 : (1, 1, 0, 1, 1, 0),
          55 : (1, 1, 0, 1, 1, 1),
          56 : (1, 1, 1, 0, 0, 0),
          57 : (1, 1, 1, 0, 0, 1),
          58 : (1, 1, 1, 0, 1, 0),
          59 : (1, 1, 1, 0, 1, 1),
          60 : (1, 1, 1, 1, 0, 0),
          61 : (1, 1, 1, 1, 0, 1),
          62 : (1, 1, 1, 1, 1, 0)}

map_6_1 ={ 1 : (0, 0, 0, 0, 0, 0)}



#-----------------------------------------------------------------||||||||||||--
#-----------------------------------------------------------------||||||||||||--


vlMapDict ={(1,1) : map_1_1,
            (2,2) : map_2_2,
            (2,1) : map_2_1,
            (3,3) : map_3_3,
            (3,2) : map_3_2,
            (3,1) : map_3_1,
            (4,4) : map_4_4,
            (4,3) : map_4_3,
            (4,2) : map_4_2,
            (4,1) : map_4_1,
            (5,5) : map_5_5,
            (5,4) : map_5_4,
            (5,3) : map_5_3,
            (5,2) : map_5_2,
            (5,1) : map_5_1,
            (6,6) : map_6_6,
            (6,5) : map_6_5,
            (6,4) : map_6_4,
            (6,3) : map_6_3,
            (6,2) : map_6_2,
            (6,1) : map_6_1, }
            
del map_1_1,map_2_2,map_2_1,map_3_3,map_3_2,map_3_1,map_4_4,map_4_3,map_4_2,map_4_1,map_5_5,map_5_4,map_5_3,map_5_2,map_5_1,map_6_6,map_6_5,map_6_4,map_6_3,map_6_2,map_6_1

